//LoginView Component Constructor
function EditEventView() {
    //create object instance, a parasitic subclass of Observable
    var self = Ti.UI.createScrollView({
        height : '100%',
        contentHeight : 'auto',
        contentWidth : '100%',
        top : 0,
        width : '100%'
    });

    //var EventView = require('ui/handheld/EventView');

    //var ProfileWindow = require('ui/handheld/ProfileWindow');

    var MainWindow = require('ui/handheld/MainWindow');

    var EventWindow = require('ui/handheld/EventWindow');

    var ProfileWindow = require('ui/handheld/ProfileWindow');

    var height = Ti.Platform.displayCaps.platformHeight;

    var event = Ti.App.Properties.getObject('EditEvent');

    var MapModule = require('ti.map');
    //alert(event);

    var user = Ti.App.Properties.getObject('User');

    var titleView = Ti.UI.createView({
        top : 0,
        left : 0,
        width : '100%',
        height : '60dp',
        backgroundColor : '#1d9e81'
    });
    var titleLabel = Ti.UI.createLabel({
        top : '10dp',
        font : {
            fontSize : '10pt',
            fontWeight : 'bold'
        },
        color : 'white',
        textAlign : Ti.UI.TEXT_ALIGNMENT_CENTER,
        text : 'Edit Event Detail'
    });

    titleView.add(titleLabel);
    self.add(titleView);

    var typeLabel = Ti.UI.createLabel({
        text : 'Event Type:',
        left : '2%',
        width : '48%',
        top : '70dp',
        height : '50dp',
        color : 'gray',
        font : {
            fontSize : '10pt'
        }
    });
    self.add(typeLabel);

    var typeField = Ti.UI.createTextField({
        color : 'black',
        top : '70dp',
        left : '50%',
        width : '48%',
        height : '50dp',
        backgroundColor : '#B5B5B5',
        value : event.event_type
    });
    self.add(typeField);

    var nameLabel = Ti.UI.createLabel({
        text : 'Name:',
        left : '2%',
        width : '48%',
        top : '130dp',
        height : '50dp',
        color : 'gray',
        font : {
            fontSize : '10pt'
        }
    });
    self.add(nameLabel);

    var nameField = Ti.UI.createTextField({
        color : 'black',
        top : '130dp',
        left : '50%',
        width : '48%',
        height : '50dp',
        backgroundColor : '#B5B5B5',
        value : event.event_name
    });
    self.add(nameField);

    var descriptionLabel = Ti.UI.createLabel({
        text : 'Description:',
        left : '2%',
        width : '48%',
        top : '190dp',
        height : '50dp',
        color : 'gray',
        font : {
            fontSize : '10pt'
        }
    });
    self.add(descriptionLabel);

    var descriptionField = Ti.UI.createTextField({
        color : 'black',
        backgroundColor : '#B5B5B5',
        top : '190dp',
        left : '50%',
        width : '48%',
        height : '50dp',
        value : event.event_description
    });
    self.add(descriptionField);

    var privacyLabel = Ti.UI.createLabel({
        text : 'Privacy:',
        left : '2%',
        width : '48%',
        top : '250dp',
        height : '50dp',
        color : 'gray',
        font : {
            fontSize : '10pt'
        }
    });
    self.add(privacyLabel);

    if (event.isPrivate == 1) {
        var privacyData = [];
        privacyData[0] = Ti.UI.createPickerRow({
            title : "Private",
            value : 1
        });
        privacyData[1] = Ti.UI.createPickerRow({
            title : "Public",
            value : 0
        });
        var privacyPicker = Ti.UI.createPicker({
            backgroundColor : '#B5B5B5',
            top : '250dp',
            left : '50%',
            width : '48%',
            height : '50dp'
        });
    } else {
        var privacyData = [];
        privacyData[0] = Ti.UI.createPickerRow({
            title : "Public",
            value : 0
        });
        privacyData[1] = Ti.UI.createPickerRow({
            title : "Private",
            value : 1
        });
        var privacyPicker = Ti.UI.createPicker({
            backgroundColor : '#B5B5B5',
            top : '250dp',
            left : '50%',
            width : '48%',
            height : '50dp'
        });
    }

    privacyPicker.add(privacyData);
    privacyPicker.selectionIndicator = true;
    self.add(privacyPicker);

    var startDateLabel = Ti.UI.createLabel({
        text : 'Start Date:',
        left : '2%',
        width : '48%',
        top : '310dp',
        height : '50dp',
        color : 'gray',
        font : {
            fontSize : '10pt'
        }
    });
    self.add(startDateLabel);

    var temp = event.start_date.split("-");
    var time = temp[0] + "/" + temp[1] + "/" + temp[2];

    var startDateField = Ti.UI.createTextField({
        color : 'black',
        backgroundColor : '#B5B5B5',
        top : '310dp',
        left : '50%',
        width : '48%',
        height : '50dp',
        value : time
    });
    self.add(startDateField);

    var startDatePicker = Ti.UI.createPicker({
        //backgroundColor: '#B5B5B5',
        type : Ti.UI.PICKER_TYPE_DATE,
        useSpinner : 'true',
        //calendarViewShown: 'true',
        //minDate:new Date(1900,1,1),
        //maxDate:new Date(2013,11,31),
        value : new Date(2014, 1, 1),
        zIndex : 1
    });
    startDateField.addEventListener('focus', function() {
        startDatePicker.showDatePickerDialog({
            callback : function(e) {
                if (!e.cancel) {
                    var dateValue = e.value;
                    startDateField.value = dateValue.getDate() + '/' + (dateValue.getMonth() + 1) + '/' + dateValue.getFullYear();
                    startDateField.blur();
                }
            }
        });
    });

    var startTimeLabel = Ti.UI.createLabel({
        text : 'Start Time:',
        left : '2%',
        width : '48%',
        top : '370dp',
        height : '50dp',
        color : 'gray',
        font : {
            fontSize : '10pt'
        }
    });
    self.add(startTimeLabel);

    var startTimeField = Ti.UI.createTextField({
        color : 'black',
        backgroundColor : '#B5B5B5',
        top : '370dp',
        left : '50%',
        width : '48%',
        height : '50dp'
    });
    self.add(startTimeField);

    startTimeField.addEventListener('focus', function() {
        var startTimePicker = Ti.UI.createPicker({
            //backgroundColor: '#B5B5B5',
            type : Ti.UI.PICKER_TYPE_TIME
        });
        startTimePicker.showTimePickerDialog({
            callback : function(e) {
                if (!e.cancel) {
                    var timeValue = e.value;
                    startTimeField.value = timeValue.getHours() + ':' + timeValue.getMinutes();
                    startTimeField.blur();
                }
            }
        });
    });

    var endDateLabel = Ti.UI.createLabel({
        text : 'End Date:',
        left : '2%',
        width : '48%',
        top : '430dp',
        height : '50dp',
        color : 'gray',
        font : {
            fontSize : '10pt'
        }
    });
    self.add(endDateLabel);

    temp = event.end_date.split("-");
    time = temp[0] + "/" + temp[1] + "/" + temp[2];
    var endDateField = Ti.UI.createTextField({
        color : 'black',
        backgroundColor : '#B5B5B5',
        top : '430dp',
        left : '50%',
        width : '48%',
        height : '50dp',
        value : time
    });
    self.add(endDateField);

    var endDatePicker = Ti.UI.createPicker({
        //backgroundColor: '#B5B5B5',
        type : Ti.UI.PICKER_TYPE_DATE,
        useSpinner : 'true',
        //calendarViewShown: 'true',
        //minDate:new Date(1900,1,1),
        //maxDate:new Date(2013,11,31),
    });
    endDateField.addEventListener('focus', function() {
        endDatePicker.showDatePickerDialog({
            callback : function(e) {
                if (!e.cancel) {
                    var dateValue = e.value;
                    endDateField.value = dateValue.getDate() + '/' + (dateValue.getMonth() + 1) + '/' + dateValue.getFullYear();
                    endDateField.blur();
                }
            }
        });
    });

    var endTimeLabel = Ti.UI.createLabel({
        text : 'End Time:',
        left : '2%',
        width : '48%',
        top : '490dp',
        height : '50dp',
        color : 'gray',
        font : {
            fontSize : '10pt'
        }
    });
    self.add(endTimeLabel);

    var endTimeField = Ti.UI.createTextField({
        color : 'black',
        backgroundColor : '#B5B5B5',
        top : '490dp',
        left : '50%',
        width : '48%',
        height : '50dp'
    });
    self.add(endTimeField);

    endTimeField.addEventListener('focus', function() {
        var endTimePicker = Ti.UI.createPicker({
            //backgroundColor: '#B5B5B5',
            type : Ti.UI.PICKER_TYPE_TIME
        });
        endTimePicker.showTimePickerDialog({
            callback : function(e) {
                if (!e.cancel) {
                    var timeValue = e.value;
                    endTimeField.value = timeValue.getHours() + ':' + timeValue.getMinutes();
                    endTimeField.blur();
                }
            }
        });
    });

    var locationLabel = Ti.UI.createLabel({
        text : 'Event Location:',
        left : '2%',
        width : '48%',
        top : '550dp',
        height : '50dp',
        color : 'gray',
        font : {
            fontSize : '10pt'
        }
    });
    self.add(locationLabel);

    var locationField = Ti.UI.createTextField({
        color : 'black',
        top : '550dp',
        left : '50%',
        width : '48%',
        height : '50dp',
        backgroundColor : '#B5B5B5',
        value : event.location.formatted_address
    });
    self.add(locationField);

    var json3;
    var xhr3 = Ti.Network.createHTTPClient({
        onload : function() {
            // parse the retrieved data, turning it into a JavaScript object
            json3 = JSON.parse(this.responseText);
            //alert(json.status);
            //MainWindow().open();
            pickLocationPopUpWindow = Ti.UI.createWindow({
                backgroundColor : '#ececec',
                navBarHidden : true,
                exitOnClose : false
            });
            var locationList = json3.results;

            var titleView2 = Ti.UI.createView({
                top : 0,
                left : 0,
                width : '100%',
                height : '60dp',
                backgroundColor : '#1d9e81'
            });
            var titleLabel2 = Ti.UI.createLabel({
                top : '10dp',
                font : {
                    fontSize : '10pt',
                    fontWeight : 'bold'
                },
                color : 'white',
                textAlign : Ti.UI.TEXT_ALIGNMENT_CENTER,
                text : 'Pick a Location'
            });

            var map = MapModule.createView({
                userLocation : true,
                mapType : MapModule.NORMAL_TYPE,
                animate : true,
                region : {
                    latitude : 0,
                    longitude : 0,
                    latitudeDelta : 1,
                    longitudeDelta : 1
                },
                height : '40%',
                top : '60dp',
                left : 0,
                width : '100%'
            });

            var editEventButton = Ti.UI.createButton({
                backgroundColor : '#1d9e81',
                top : '55%',
                height : '7%',
                width : '60%',
                title : 'Edit Location'
            });

            map.addEventListener('click', function(evt) {
                var clicksource = evt.clicksource;
                var source = evt.annotation;
                var index = source.myid;
                if (clicksource == "pin") {
                    Ti.App.Properties.setObject("SetEditEvent", locationList[index]);
                }
            });

            var json4;
            var xhr4 = Ti.Network.createHTTPClient({
                onload : function() {
                    // parse the retrieved data, turning it into a JavaScript object
                    //alert("kkkk");
                    
                    json4 = JSON.parse(this.responseText);
                    
                    //pickLocationPopUpWindow.close();
                    //self.parent.close();
                    //MainWindow().open();
                    alert("Event edited!");
                    //parent kapanmiyor,
                    self.parent.close();
                    Titanium.App.fireEvent('CloseWin');
                    Ti.App.Properties.setObject("Own", "yes");
                    Ti.App.Properties.setObject("User", user);
                    //ProfileWindow().open();
                    //EventWindow().open();
                    MainWindow().open();
                },
                onerror : function(e) {
                    Ti.API.debug("STATUS: " + this.status);
                    Ti.API.debug("TEXT: " + this.responseText);
                    Ti.API.debug("ERROR: " + e.error);
                    alert("STATUS: " + this.status + ", TEXT: " + this.responseText + ",ERROR: " + e.error);
                },
                timeout : 10000
            });

            editEventButton.addEventListener('click', function(e) {
                var editEvent = Ti.App.Properties.getObject('SetEditEvent');
                if (editEvent == null) {
                    alert("Select Location From Map");
                } else {
                    startDateData = startDateField.value.split("/");
                    endDateData = endDateField.value.split("/");
                    var startTime = startDateData[0] + "-" + startDateData[1] + "-" + startDateData[2];
                    var endTime = endDateData[0] + "-" + endDateData[1] + "-" + endDateData[2];
                    var lat;
                    var lng;
                    if (editEvent.hasOwnProperty('geometry')) {
                        lat = editEvent.geometry.location.lat;
                        lng = editEvent.geometry.location.lng;
                        //burada add location yapmamiz lazim
                        var json5;
                        var xhr5 = Ti.Network.createHTTPClient({
                            onload : function() {
                                // parse the retrieved data, turning it into a JavaScript object
                                json5 = JSON.parse(this.responseText);
                                //alert("json5" + json5);
                                var editData = {
                                    event_id : event.event_id,
                                    event_type : typeField.value,
                                    event_name : nameField.value,
                                    event_description : descriptionField.value,
                                    start_time : startTime,
                                    end_time : endTime,
                                    location_id : json5.id,
                                    isPrivate : privacyPicker.getSelectedRow(0).value
                                };

                                var editDataString = JSON.stringify(editData);

                                //var setDataString = JSON.stringify(setData);
                                //alert(editDataString);
                                //Ti.App.Properties.setObject('Event',setDataString);
                                //Ti.App.Properties.setObject('Event', setData);
                                Ti.App.Properties.setObject('Own', "yes");

                                xhr4.open('POST', 'http://54.194.111.128:8080/CerealKillers/rest/event/updateEvent/');

                                xhr4.setRequestHeader("content-type", "application/json");
                                xhr4.send(editDataString);
                            },
                            onerror : function(e) {
                                Ti.API.debug("STATUS: " + this.status);
                                Ti.API.debug("TEXT: " + this.responseText);
                                Ti.API.debug("ERROR: " + e.error);
                                alert('There was an error retrieving the remote data. Try again.');
                            },
                            timeout : 10000
                        });

                        var addLocationData = {
                            latitude : lat,
                            longitude : lng,
                            name : editEvent.name,
                            formatted_address : editEvent.formatted_address,
                            secondary_id : editEvent.id
                        };

                        var addLocationDataString = JSON.stringify(addLocationData);

                        xhr5.open('POST', 'http://54.194.111.128:8080/CerealKillers/rest/location/addLocation/');
                        xhr5.setRequestHeader("content-type", "application/json");
                        xhr5.send(addLocationDataString);
                    } else {
                        lat = editEvent.latitude;
                        lng = editEvent.longitude;
                    }

                    //alert(eventDataString);
                }

            });

            pickLocationPopUpWindow.add(editEventButton);
            pickLocationPopUpWindow.add(map);
            pickLocationPopUpWindow.add(titleView2);
            pickLocationPopUpWindow.add(titleLabel2);

            tableData = [];
            var annotationList = [];

            for (var i = 0; i < locationList.length; i++) {
                /*var address = {
                 title: locationList[i].formatted_address,
                 name:
                 lat:
                 lng:

                 };*/
                if (locationList[i].hasOwnProperty('geometry')) {
                    lat = locationList[i].geometry.location.lat;
                    lng = locationList[i].geometry.location.lng;
                } else {
                    lat = locationList[i].latitude;
                    lng = locationList[i].longitude;
                }

                var eventPin = MapModule.createAnnotation({
                    latitude : lat,
                    longitude : lng,
                    pincolor : MapModule.ANNOTATION_AZURE,
                    title : locationList[i].formatted_address,
                    myid : i
                });
                annotationList.push(eventPin);

                var row = Ti.UI.createTableViewRow({
                    className : 'eventLocation', // used to improve table performance
                    selectedBackgroundColor : 'white',
                    rowIndex : i, // custom property, useful for determining the row during events
                    height : '110dp'
                });
                /*var imageAvatar = Ti.UI.createImageView({
                 image: locationList[i].icon,
                 left:'10dp', top:'5dp',
                 width:'50dp', height: '50dp'
                 });
                 row.add(imageAvatar);*/

                var labelLocationName = Ti.UI.createLabel({
                    color : '#1d9e81',
                    font : {
                        fontFamily : 'Arial',
                        fontSize : 20,
                        fontWeight : 'bold'
                    },
                    text : locationList[i].name,
                    left : '70dp',
                    top : '6dp'
                });
                row.add(labelLocationName);

                var labelDetails = Ti.UI.createLabel({
                    color : '#222',
                    font : {
                        fontFamily : 'Arial',
                        fontSize : 16,
                        fontWeight : 'normal'
                    },
                    text : locationList[i].formatted_address,
                    left : '70dp',
                    top : '44dp',
                    width : '360dp'
                });
                row.add(labelDetails);

                tableData.push(row);
            }
            map.setAnnotations(annotationList);

            //pickLocationPopUpWindow.add(list);
            pickLocationPopUpWindow.open({
                modal : true
            });

            if (locationList[0].hasOwnProperty('geometry')) {
                lat = locationList[0].geometry.location.lat;
                lng = locationList[0].geometry.location.lng;
            } else {
                lat = locationList[0].latitude;
                lng = locationList[0].longitude;
            }

            map.setRegion({
                latitude : lat,
                longitude : lng,
                latitudeDelta : 0.1,
                longitudeDelta : 0.1,
                animate : true
            });
            //alert("lol");
        },
        onerror : function(e) {
            Ti.API.debug("STATUS: " + this.status);
            Ti.API.debug("TEXT: " + this.responseText);
            Ti.API.debug("ERROR: " + e.error);
            alert('There was an error retrieving the remote data. Try again.');
        },
        timeout : 5000
    });

    

    var json2;
    var xhr2 = Ti.Network.createHTTPClient({
        onload : function() {
            // parse the retrieved data, turning it into a JavaScript object
            //alert("kkkk");
            json2 = JSON.parse(this.responseText);

            //pickLocationPopUpWindow.close();
            //self.parent.close();
            //MainWindow().open();
            alert("Event edited!");
            //parent kapanmiyor,
            self.parent.close();
            Titanium.App.fireEvent('CloseWin');
            Ti.App.Properties.setObject("Own", "yes");
            Ti.App.Properties.setObject("User", user);
            //ProfileWindow().open();
            //EventWindow().open();
            MainWindow().open();
        },
        onerror : function(e) {
            Ti.API.debug("STATUS: " + this.status);
            Ti.API.debug("TEXT: " + this.responseText);
            Ti.API.debug("ERROR: " + e.error);
            alert("STATUS: " + this.status + ", TEXT: " + this.responseText + ",ERROR: " + e.error);
        },
        timeout : 10000
    });

    var okButton = Ti.UI.createButton({
        backgroundColor : '#B5B5B5',
        backgroundSelectedColor : '#1d9e81',
        title : 'Edit',
        right : '52%',
        top : '670dp',
        width : '40%',
        height : '50dp'
    });

    self.add(okButton);

    okButton.addEventListener("click", function(e) {

        var startDateData = startDateField.value.split("/");
        var endDateData = endDateField.value.split("/");
        var startTime = startDateData[0] + "-" + startDateData[1] + "-" + startDateData[2];
        var endTime = endDateData[0] + "-" + endDateData[1] + "-" + endDateData[2];

        var editData = {
            event_id : event.event_id,
            event_type : typeField.value,
            event_name : nameField.value,
            event_description : descriptionField.value,
            start_time : startTime,
            end_time : endTime,
            location_id : event.location.location_id,
            isPrivate : privacyPicker.getSelectedRow(0).value
        };

        var setData = {
            distance : event.distance,
            ownerIDs : event.ownerIDs,
            accessIDs : event.accessIDs,
            ownerNames : event.ownerNames,
            event_id : event.event_id,
            event_type : typeField.value,
            event_name : nameField.value,
            event_description : descriptionField.value,
            start_time : startTime,
            end_time : endTime,
            location : event.location,
            isPrivate : privacyPicker.getSelectedRow(0).value
        };

        var editDataString = JSON.stringify(editData);
        //var setDataString = JSON.stringify(setData);
        //alert(editDataString);
        //Ti.App.Properties.setObject('Event',setDataString);
        Ti.App.Properties.setObject('Event', setData);
        Ti.App.Properties.setObject('Own', "yes");

        xhr2.open('POST', 'http://54.194.111.128:8080/CerealKillers/rest/event/updateEvent/');

        xhr2.setRequestHeader("content-type", "application/json");
        xhr2.send(editDataString);
        //alert(editDataString);

    });

    var pickLocationButton = Ti.UI.createButton({
        backgroundColor : '#B5B5B5',
        backgroundSelectedColor : '#1d9e81',
        title : 'Pick Location',
        left : '50%',
        top : '610dp',
        width : '40%',
        height : '50dp'
    });

    self.add(pickLocationButton);

    pickLocationButton.addEventListener("click", function(e) {
        //alert("hebele");
        var url = "http://54.194.111.128:8080/CerealKillers/rest/location/searchLocation/" + locationField.value;

        xhr3.open('GET', url);
        xhr3.send();

    });

    var cancelButton = Ti.UI.createButton({
        backgroundColor : '#B5B5B5',
        backgroundSelectedColor : '#1d9e81',
        title : 'Cancel',
        left : '52%',
        top : '670dp',
        width : '40%',
        height : '50dp'
    });

    self.add(cancelButton);

    cancelButton.addEventListener("click", function(e) {
        self.parent.close();
    });

    return self;

}

module.exports = EditEventView;
