//LoginView Component Constructor
function EventView() {
    //create object instance, a parasitic subclass of Observable
    var self = Ti.UI.createScrollView({
        height : '100%',
        contentHeight : 'auto',
        contentWidth : '100%',
        top : 0,
        width : '100%'
    });

    var JoinersWindow = require('ui/handheld/JoinersWindow');

    var EventWindow = require('ui/handheld/EventWindow');

    var EditEventWindow = require('ui/handheld/EditEventWindow');

    var height = Ti.Platform.displayCaps.platformHeight;

    var own = Ti.App.Properties.getObject('Own');

    var event = Ti.App.Properties.getObject('Event');

    var user = Ti.App.Properties.getObject('User');

    var numberOfJoinedUser;
    var numberOfComments;

    Titanium.App.addEventListener('CloseWin', function(e) {
        EventWindow().close();
    });

    var titleView = Ti.UI.createView({
        top : 0,
        left : 0,
        width : '100%',
        height : '60dp',
        backgroundColor : '#1d9e81'
    });

    var json;
    var xhr = Ti.Network.createHTTPClient({
        onload : function() {
            var flag = false;
            // parse the retrieved data, turning it into a JavaScript object
            json = JSON.parse(this.responseText);
            numberOfJoinedUser = json.length;
            for (var i = 0; i < numberOfJoinedUser; i++) {
                if (json[i].userid == user.userid) {
                    //User already joined...
                    flag = true;
                    break;
                }
            }

            //not joined, display join button
            if (flag == false) {
                titleView.add(joinButton);
            }

            //joined, display delete join button
            else if (flag == true) {
                titleView.add(deleteJoinButton);
            }

            var joinersField = Ti.UI.createLabel({
                text : numberOfJoinedUser + " people are going...",
                color : '#16AA00',
                font : {
                    fontSize : '5pt'
                },
                left : '10dp',
                bottom : '5dp'
            });
            basicInformationContainer.add(joinersField);

            joinersField.addEventListener('click', function(evt) {
                Ti.App.Properties.setObject("Joiners", json);
                //Ti.App.Properties.setObject("Event", json2[evt.source.my_id]);
                JoinersWindow().open({
                    modal : true
                });
                //alert(userList_friend[e.source.parent.rowIndex].first_name + " " +
                //    userList_friend[e.source.parent.rowIndex].last_name);
            });

        },
        onerror : function(e) {
            Ti.API.debug("STATUS: " + this.status);
            Ti.API.debug("TEXT: " + this.responseText);
            Ti.API.debug("ERROR: " + e.error);
            alert('There was an error retrieving the remote data. Try again.');
        },
        timeout : 10000
    });

    var url = 'http://54.194.111.128:8080/CerealKillers/rest/event/getJoiners/' + event.event_id;
    xhr.open('GET', url);
    xhr.send();

    var json4;
    var xhr4 = Ti.Network.createHTTPClient({
        onload : function() {
            // parse the retrieved data, turning it into a JavaScript object
            json4 = JSON.parse(this.responseText);
            numberOfComments = json4.length;
            if (numberOfComments > 0) {
                tableData = [];
                for (var i = 0; i < numberOfComments; ) {
                    var row = Ti.UI.createTableViewRow({
                        className : 'searchResults', // used to improve table performance
                        selectedBackgroundColor : '#d6d6d6',
                        rowIndex : i // custom property, useful for determining the row during events
                        //height : '110dp'
                    });

                    var comment = Ti.UI.createLabel({
                        text : json4[i + 1],
                        color : '#000000',
                        font : {
                            fontSize : '5pt',
                        },
                        left : '10dp',
                        top : '6dp',
                        my_id : i
                    });
                    row.add(comment);

                    var user = Ti.UI.createLabel({
                        text : json4[i].first_name + " " + json4[i].last_name,
                        color : '#16AA00',
                        font : {
                            fontSize : '5pt',
                        },
                        rigth : '10dp',
                        top : '6dp',
                        my_id : i
                    });
                    row.add(user);
                    tableData.push(row);
                    i = i + 2;
                }

                var list = Ti.UI.createTableView({
                    top : '92%',
                    data : tableData
                });

                self.add(list);
            }
            //alert("comment count : " + numberOfComments);
        },
        onerror : function(e) {
            Ti.API.debug("STATUS: " + this.status);
            Ti.API.debug("TEXT: " + this.responseText);
            Ti.API.debug("ERROR: " + e.error);
            alert('There was an error retrieving the remote data. Try again.');
        },
        timeout : 10000
    });

    var url = 'http://54.194.111.128:8080/CerealKillers/rest/event/getComments/' + event.event_id;
    xhr4.open('GET', url);
    xhr4.send();

    var titleLabel = Ti.UI.createLabel({
        font : {
            fontSize : '10pt',
            fontWeight : 'bold'
        },
        color : 'white',
        textAlign : Ti.UI.TEXT_ALIGNMENT_CENTER,
        text : 'Event Detail'
    });

    var joinButton = Ti.UI.createButton({
        title : 'Join',
        left : 0,
        top : 0,
        width : '30%',
        height : '100%',
        color : 'white',
        backgroundColor : 'transparent'
    });

    var json2;
    var xhr2 = Ti.Network.createHTTPClient({
        onload : function() {
            // parse the retrieved data, turning it into a JavaScript object
            json2 = JSON.parse(this.responseText);
            self.parent.close();
            EventWindow().open();
        },
        onerror : function(e) {
            Ti.API.debug("STATUS: " + this.status);
            Ti.API.debug("TEXT: " + this.responseText);
            Ti.API.debug("ERROR: " + e.error);
            alert('There was an error retrieving the remote data. Try again.');
        },
        timeout : 10000
    });

    joinButton.addEventListener('click', function(e) {
        var joinData = {
            event_id : event.event_id,
            user_id : user.userid
        };

        var joinDataString = JSON.stringify(joinData);
        xhr2.open('POST', 'http://54.194.111.128:8080/CerealKillers/rest/event/joinEvent/');
        xhr2.setRequestHeader("content-type", "application/json");
        xhr2.send(joinDataString);
    });

    var json3;
    var xhr3 = Ti.Network.createHTTPClient({
        onload : function() {
            // parse the retrieved data, turning it into a JavaScript object
            json3 = JSON.parse(this.responseText);
            self.parent.close();
            EventWindow().open();
        },
        onerror : function(e) {
            Ti.API.debug("STATUS: " + this.status);
            Ti.API.debug("TEXT: " + this.responseText);
            Ti.API.debug("ERROR: " + e.error);
            alert('There was an error retrieving the remote data. Try again.');
        },
        timeout : 10000
    });

    var deleteJoinButton = Ti.UI.createButton({
        title : 'Leave',
        left : 0,
        top : 0,
        width : '30%',
        height : '100%',
        color : 'white',
        backgroundColor : 'transparent'
    });

    deleteJoinButton.addEventListener('click', function(e) {
        var deleteJoinData = {
            event_id : event.event_id,
            user_id : user.userid
        };

        var deleteJoinDataString = JSON.stringify(deleteJoinData);
        xhr3.open('POST', 'http://54.194.111.128:8080/CerealKillers/rest/event/deleteJoin/');
        xhr3.setRequestHeader("content-type", "application/json");
        xhr3.send(deleteJoinDataString);
    });

    var shareButton = Ti.UI.createButton({
        title : 'Share',
        right : 0,
        top : 0,
        width : '30%',
        height : '100%',
        color : 'white',
        backgroundColor : 'transparent'
    });
    shareButton.addEventListener('click', function(e) {
        var fb = require('facebook');
        fb.appid = "723055737715082";
        fb.forceDialogAuth = false;
        fb.permissions = ['publish_stream'];
        fb.authorize();

        var sharedPost = "See event: " + event.event_name + " on XEvent: http://54.194.111.128:8080/CerealKillers/viewEvent.xhtml?id=" + event.event_id + "\nCheers!";

        fb.requestWithGraphPath('me/feed', {
            message : sharedPost
        }, "POST", function(e) {
            if (e.success) {
                alert("Success!  From FB: " + e.result);
            } else {
                if (e.error) {
                    alert(e.error);
                } else {
                    alert("Unkown result");
                }
            }
        });
    });

    if (event.isPrivate == 0) {
        titleView.add(shareButton);
    }

    titleView.add(titleLabel);
    self.add(titleView);

    var basicInformationContainer = Ti.UI.createView({
        top : '52%',
        height : '200dp',
        width : '94%',
        backgroundColor : '#FAF9F9'
    });

    var eventPicture = Ti.UI.createImageView({
        top : '30dp',
        height : '130dp',
        width : '130dp',
        image : '/images/event.jpg',
        left : '10dp'
    });

    basicInformationContainer.add(eventPicture);

    var eventName = Ti.UI.createLabel({
        text : event.event_name,
        color : '#16AA00',
        font : {
            fontSize : '8pt',
            fontWeight : 'bold'
        },
        left : '10dp',
        top : '5dp'
    });
    basicInformationContainer.add(eventName);

    if (own != null) {
        var editButton = Ti.UI.createButton({
            Color : '#16AA00',
            title : "Edit",
            top : '10dp',
            left : '250dp',
        });
        editButton.addEventListener('click', function(e) {
            Ti.App.Properties.setObject('EditEvent', event);
            EditEventWindow().open({
                modal : true
            });
        });
        basicInformationContainer.add(editButton);
    }

    var description = Ti.UI.createLabel({
        text : 'Description : ' + event.event_description,
        top : '30dp',
        left : '150dp',
        color : 'black'
    });
    basicInformationContainer.add(description);

    var address = Ti.UI.createLabel({
        text : 'Address : ' + event.location.formatted_address,
        top : '60dp',
        left : '150dp',
        color : 'black'
    });
    basicInformationContainer.add(address);

    var type = Ti.UI.createLabel({
        text : 'Type : ' + event.event_type,
        top : '90dp',
        left : '150dp',
        color : 'black'
    });
    basicInformationContainer.add(type);

    var start_date = Ti.UI.createLabel({
        text : 'Start Date : ' + event.start_date,
        top : '120dp',
        left : '150dp',
        color : 'black'
    });
    basicInformationContainer.add(start_date);

    var end_date = Ti.UI.createLabel({
        text : 'End Date: ' + event.end_date,
        top : '150dp',
        left : '150dp',
        color : 'black'
    });
    basicInformationContainer.add(end_date);

    var textfield = Ti.UI.createTextField({
        left : '3%',
        top : '85%',
        width : '70%',
        height: '40dp',
        backgroundColor : '#FAF9F9',
        //color : 'white',
        //keyboardType : Ti.UI.KEYBOARD_DEFAULT,
        //returnKeyType : Ti.UI.RETURNKEY_DONE,
        //borderStyle : Ti.UI.INPUT_BORDERSTYLE_ROUNDED,
        hintText : 'Write a comment here...'
    });

    self.add(textfield);

    var commentButton = Ti.UI.createButton({
        title : 'OK',
        right : '3%',
        top : '85%',
        height: '40dp',
        backgroundColor : '#FAF9F9',
        width : '20%'
    });

    self.add(commentButton);

    commentButton.addEventListener('click', function(evt) {
        //alert("button clicked with " + textfield.value );
        var json5;
        var xhr5 = Ti.Network.createHTTPClient({
            onload : function() {
                // parse the retrieved data, turning it into a JavaScript object
                json5 = JSON.parse(this.responseText);
                Ti.App.Properties.setObject("Own", own);
                Ti.App.Properties.setObject("Event", event);
                Ti.App.Properties.setObject("User", user);
                self.parent.close();
                EventWindow().open({
                    modal : true
                });
            },
            onerror : function(e) {
                Ti.API.debug("STATUS: " + this.status);
                Ti.API.debug("TEXT: " + this.responseText);
                Ti.API.debug("ERROR: " + e.error);
                alert('There was an error retrieving the remote data. Try again.');
            },
            timeout : 10000
        });
        var commentData = {
            event_id : event.event_id,
            user_id : user.userid,
            comment : textfield.value
        };

        var commentDataString = JSON.stringify(commentData);
        xhr5.open('POST', 'http://54.194.111.128:8080/CerealKillers/rest/event/commentOnEvent/');
        xhr5.setRequestHeader("content-type", "application/json");
        xhr5.send(commentDataString);

        //alert(userList_friend[e.source.parent.rowIndex].first_name + " " +
        //    userList_friend[e.source.parent.rowIndex].last_name);
    });

    self.add(basicInformationContainer);

    var MapModule = require('ti.map');

    var map = MapModule.createView({
        userLocation : true,
        mapType : MapModule.NORMAL_TYPE,
        animate : true,
        region : {
            latitude : 0,
            longitude : 0,
            latitudeDelta : 1,
            longitudeDelta : 1
        },
        height : '40%',
        top : '60dp',
        left : 0,
        width : '100%'
    });
    self.add(map);

    Ti.Geolocation.getCurrentPosition(function(e) {
        if (e.error) {
            return;
        }
        map.setRegion({
            latitude : event.location.latitude, //e.coords.latitude,
            longitude : event.location.longitude, //e.coords.longitude,
            latitudeDelta : 0.1,
            longitudeDelta : 0.1,
            animate : true
        });
    });

    var annotationList = [];
    var eventPin = MapModule.createAnnotation({
        latitude : event.location.latitude,
        longitude : event.location.longitude,
        pincolor : MapModule.ANNOTATION_AZURE,
        // Even though we are creating a button, it does not respond to Button events or animates.
        // Use the Map View's click event and monitor the clicksource property for 'leftPane'.
        leftView : Ti.UI.createButton({
            title : 'Detail'
        }),
        // For eventing, use the Map View's click event
        // and monitor the clicksource property for 'rightPane'.
        //rightButton: 'appicon.png',
        title : event.event_name,
        subtitle : event.event_type
    });
    annotationList.push(eventPin);
    map.setAnnotations(annotationList);
    return self;

}

module.exports = EventView;
