//FirstView Component Constructor
function FirstView() {
	//create object instance, a parasitic subclass of Observable
	var self = Ti.UI.createView({
		backgroundColor: '#eae9e9'
		//backgroundImage: '/images/back.png',
		//backgroundRepeat: false
	});
	

	var LoginWindow = require('ui/handheld/LoginWindow');
	var ProfileWindow = require('ui/handheld/ProfileWindow');
	var MainWindow = require('ui/handheld/MainWindow');
	var fb = require('facebook');
	fb.appid = "723055737715082";
	fb.forceDialogAuth = false;
	fb.permissions = ['email', 'user_about_me', 'user_location', 'user_birthday'];
	//fb.authorize();
	
	
	var json;
	var xhr = Ti.Network.createHTTPClient({
		onload : function() {
			// parse the retrieved data, turning it into a JavaScript object
			json = JSON.parse(this.responseText);
			if (json.hasOwnProperty('message')) {
				alert(json.message);
			} else {
				Ti.App.Properties.setBool("Registered", true);
				Ti.App.Properties.setObject("User", json);
				MainWindow().open();
				self.parent.close();
			}
		},
		onerror : function(e) {
			Ti.API.debug("STATUS: " + this.status);
			Ti.API.debug("TEXT: " + this.responseText);
			Ti.API.debug("ERROR: " + e.error);
			alert('There was an error retrieving the remote data. Try again.');
		},
		timeout : 10000
	});
	
	if(fb.getLoggedIn())
	{
		fb.logout();
	} 
	
	fb.addEventListener('login', function(e) {
		
		
		
		if (e.success) {
			fb.requestWithGraphPath('me', {}, 'GET', function(c) {
				if (c.success) {
					det = JSON.parse(c.result);
					Ti.API.info(det.name);
					
					Ti.API.info(JSON.stringify(det));
					
					
					var birthdate = "";
					var splitted = det.birthday.split("/");
					birthdate += splitted[1];
					birthdate += "-";
					birthdate += splitted[0];
					birthdate += "-";
					birthdate += splitted[2];

					var city = det.location.name.split(',')[0];

					url = "http://54.194.111.128:8080/CerealKillers/rest/login/" + det.email + '/' + fb.uid + '/' + det.first_name + '/' + det.last_name + '/' + det.gender + '/' + birthdate + '/' + city;
					alert(url);
					xhr.open('GET', url);
					xhr.send();


				} else if (c.error) {
					alert(c.error);
				} else {
					alert("unknown");
				}

			});
			//alert('Logged in');
		}
	}); 
	
	/*fb.addEventListener('logout', function(e) {
		alert('Logged out');
	});*/
	/*self.add(fb.createLoginButton({
		top: '58%',
		width: '70%',
		height: '10%',
		style : fb.BUTTON_STYLE_WIDE
	}));*/
	
	var back = Ti.UI.createImageView({
		image: '/images/back2.png',
		width: '100%',
		zIndex: -2
	});
	self.add(back); 
	
	
	var logo = Ti.UI.createImageView({
		image: '/images/logo.png',
		top: '15%',
		width: '70%',
		zIndex: -1
	});
	self.add(logo);
	
	var view1 = Ti.UI.createView({ backgroundColor:'transparent' });
	var view2 = Ti.UI.createView({ backgroundColor:'transparent' });
	var view3 = Ti.UI.createView({ backgroundColor:'transparent' });
	
	var label1 = Ti.UI.createLabel({
		text: "XEvent helps you find the perfect events just for you!",
		color: '#1a9579',
  		textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
		font: {fontSize: '22sp'}
	});
	view1.add(label1);
	
	var label2 = Ti.UI.createLabel({
		text: "Create, Share, and Promote your events with everyone you know.",
		color: '#1a9579',
  		textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
		font: {fontSize: '22sp'}
	});
	view2.add(label2);
	
	var label3 = Ti.UI.createLabel({
		text: "Looking for inspiration? Look no further, see what your friends are up to and check our recommendations containing the most popular events according to your interests.",
		color: '#1a9579',
  		textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
		font: {fontSize: '22sp'}
	});
	view3.add(label3);
	
	var detailsScrollable = Ti.UI.createScrollableView({
		views:[view1,view2,view3],
		showPagingControl: true,
		width: '80%',
		height: '50%' ,
		layout:'vertical',
		bottom: '20%'
	});
	
	self.add(detailsScrollable);
	
	/*var emailLoginButton = Ti.UI.createButton({
		backgroundColor: '#1d9e81',
		title: "Login with email",
		color: 'white',
		top: '47%',
		width: '70%',
		height: '10%'
	});*/
	
	var emailLoginButton = Ti.UI.createButton({
		backgroundColor: '#1d9e81',
		backgroundFocusedColor: '#1a9579',
		backgroundSelectedColor: '#1a9579',
		title: "Login\nwith email",
		layout:'vertical',
		color: 'white',
		//font: {fontWeight: 'bold', fontSize: '28sp'},
		bottom: 0,
		left: 0,
		width: '49%',
		height: '20%'
	});
	
	emailLoginButton.addEventListener('click', function(e){
		//alert(e.source.title);
		LoginWindow().open({modal:true});
	});
	
	self.add(emailLoginButton);
	
	
	var facebookLoginButton = Ti.UI.createButton({
		backgroundColor: '#43609C',
		backgroundFocusedColor: '#334e88',
		backgroundSelectedColor: '#334e88',
		title: "Login\nwith Facebook",
		layout:'vertical',
		color: 'white',
		//font: {fontWeight: 'bold', fontSize: '28sp'},
		bottom: 0,
		right: 0,
		width: '49%',
		height: '20%'
	});
	
	facebookLoginButton.addEventListener('click', function(e){
		//alert(e.source.title);
		fb.authorize();
		
		//LoginWindow().open({modal:true});
	});
	
	self.add(facebookLoginButton);
	
	
	return self;
}

module.exports = FirstView;
