//LoginView Component Constructor
function GeneralProfileView() {
	//create object instance, a parasitic subclass of Observable
	var self = Ti.UI.createScrollView({
		height: '100%',
		contentHeight: 'auto',
		contentWidth: '100%',
		top: 0,
		width: '100%'
	});
	
	var EventWindow = require('ui/handheld/EventWindow');

	var height = Ti.Platform.displayCaps.platformHeight;
	
	var user = Ti.App.Properties.getObject("GeneralUser");
	
	Ti.App.Properties.setObject("Own", null);
	
	var titleView = Ti.UI.createView({
		top: 0,
		left: 0,
		width: '100%',
		height: '60dp',
		backgroundColor: '#1d9e81'
	});
	var titleLabel = Ti.UI.createLabel({
		top: '10dp',
		font: {fontSize: '10pt', fontWeight: 'bold'},
		color: 'white',
		textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
		text: 'Profile'
	});
	/*var FriendRequestsButton = Ti.UI.createButton({
		title: 'Requests',
		right: 0,
		top: 0,
		width: '30%',
		height: '100%',
		color: 'white',
		backgroundColor:'transparent'
	});
	logoutButton.addEventListener('click', function(e){
		Ti.App.Properties.removeProperty('User');
		Ti.App.Properties.setBool('Registered', false);
		self.parent.close();
	});
	titleView.add(logoutButton);*/
	self.add(titleView);
	self.add(titleLabel);
	
	
	var basicInformationContainer = Ti.UI.createView({
		top: '70dp',
		height: '200dp',
		width: '90%',
		backgroundColor : '#FAF9F9',
		//backgroundColor : '#d6d6d6'
	});
	
	var profilePicture = Ti.UI.createImageView({
		top: '60dp',
		height: '130dp',
		width: '130dp',
		image: '/images/avatar.png',
		left: '10dp'
	});
	basicInformationContainer.add(profilePicture);
	
	var profileName = Ti.UI.createLabel({
		text: user.first_name + ' ' + user.last_name,
		color: '#1d9e81',
		font: {fontSize: '10pt', fontWeight: 'bold'},
		left: '10dp',
		top: '10dp'
	});
	basicInformationContainer.add(profileName);
	
	var locationInfo = Ti.UI.createLabel({
		text: 'Location: ' + user.city,
		top: '60dp',
		left: '150dp',
		color: 'black'
	});
	basicInformationContainer.add(locationInfo);
	
	var genderInfo = Ti.UI.createLabel({
		text: 'Gender: ' + user.gender,
		top: '90dp',
		left: '150dp',
		color: 'black'
	});
	basicInformationContainer.add(genderInfo);
	
	var birthdayInfo = Ti.UI.createLabel({
		text: 'Birthday: ' + user.date_of_birth,
		top: '120dp',
		left: '150dp',
		color: 'black'
	});
	basicInformationContainer.add(birthdayInfo);
	
	self.add(basicInformationContainer);
	
	var url = 'http://54.194.111.128:8080/CerealKillers/rest/event/getEventsOfUser/' + user.userid + '/';
	var json;
	
	var xhr = Ti.Network.createHTTPClient({
	    onload: function() {
			// parse the retrieved data, turning it into a JavaScript object
	    	json = JSON.parse(this.responseText);
	    	
	    	//alert('Events are loaded.');
	    	for(var i=0; i<json.length; i++)
	    	{
	    		var eventsContainer = Ti.UI.createView({
					top: (300+i*60).toString() + 'dp',
					height: '50dp',
					width: '90%',
					backgroundColor : '#FAF9F9',
					//backgroundColor : '#d6d6d6'
				});
				
				var eventName = Ti.UI.createLabel({
					text: json[i].event_name,
					color: '#1d9e81',
					font: {fontSize: '10pt', fontWeight: 'bold'},
					left: '10dp',
					top: '10dp',
					my_id: i
				});
				eventsContainer.add(eventName);
				eventName.addEventListener('click', function(evt) {
					//alert(json2[0][0]);
					Ti.App.Properties.setObject("Event", json[evt.source.my_id]);
					EventWindow().open({
						modal : true
					});
					//alert(userList_friend[e.source.parent.rowIndex].first_name + " " +
					//	  userList_friend[e.source.parent.rowIndex].last_name);
				});
				
				/*
				var eventType = Ti.UI.createLabel({
					text: 'Event Type: ' + json[i].event_type,
					top: '60dp',
					left: '10dp',
					color: 'black'
				});
				eventsContainer.add(eventType);	
				
				var eventDescription = Ti.UI.createLabel({
					text: 'Description: ' + json[i].event_description,
					top: '90dp',
					left: '10dp',
					color: 'black'
				});
				eventsContainer.add(eventDescription);	
				
				var startTime = Ti.UI.createLabel({
					text: 'Start-Time: ' + json[i].start_date,
					top: '120dp',
					left: '10dp',
					color: 'black'
				});
				eventsContainer.add(startTime);	
				
				var endTime = Ti.UI.createLabel({
					text: 'End-Time: ' + json[i].end_date,
					top: '150dp',
					left: '10dp',
					color: 'black'
				});
				eventsContainer.add(endTime);	
				*/			
				self.add(eventsContainer);
	    	}
	    	self.setContentHeight((300+json.length*60).toString() + 'dp');
			
			//alert("lol");
			
			
		}, 
		onerror: function(e) {
			Ti.API.debug("STATUS: " + this.status);
			Ti.API.debug("TEXT: " + this.responseText);
			Ti.API.debug("ERROR: " + e.error);
			alert('There was an error retrieving the remote data. Try again.');
		},
	 	timeout:10000
	});
				
	xhr.open('GET',url);
	xhr.send();
	
	
	

	
	
	return self;
}

module.exports = GeneralProfileView;
