//LoginView Component Constructor
function LoginView() {
    //create object instance, a parasitic subclass of Observable
    var self = Ti.UI.createView({
        backgroundColor : '#E5E5E5'
    });

    var registerWindow = require('ui/handheld/RegisterWindow');
    var MainWindow = require('ui/handheld/MainWindow');

    var height = Ti.Platform.displayCaps.platformHeight;

    var titleView = Ti.UI.createView({
        top : 0,
        left : 0,
        width : '100%',
        height : '60dp',
        backgroundColor : '#1d9e81'
    });
    var titleLabel = Ti.UI.createLabel({
        font : {
            fontSize : '10pt',
            fontWeight : 'bold'
        },
        color : 'white',
        textAlign : Ti.UI.TEXT_ALIGNMENT_CENTER,
        text : 'Login'
    });
    titleView.add(titleLabel);
    self.add(titleView);

    var emailField = Ti.UI.createTextField({
        color : '#000000',
        //backgroundColor : '#B5B5B5',
        backgroundColor : '#FAF9F9',
        width : '70%',
        height : '50dp',
        //top : height / 2 - 100,
        top : '110dp',
        hintText : 'mail@example.com'
    });

    var passwordField = Ti.UI.createTextField({
        color : '#000000',
        //backgroundColor : '#B5B5B5',
        backgroundColor : '#FAF9F9',
        width : '70%',
        height : '50dp',
        //top : height / 2 - 20,
        top : '180dp',
        passwordMask : 'true',
        hintText : 'password'
    });

    var loginButton = Ti.UI.createButton({
        //backgroundColor : '#B5B5B5',
        backgroundColor : '#FAF9F9',
        backgroundSelectedColor : '#1d9e81',
        left : '15%',
        //top : height / 2 + 60,
        top: '250dp',
        height : '50dp',
        width : '32%',
        title : 'Login'
    });
    var url = "http://54.194.111.128:8080/app2/rest/login/username/password";
    var json;

    var xhr = Ti.Network.createHTTPClient({
        onload : function() {
            // parse the retrieved data, turning it into a JavaScript object
            json = JSON.parse(this.responseText);

            if (json.hasOwnProperty('message')) {
                if (json['message'] == "UserDoesNotExistException")
                    alert("E-mail does not exist");
                else if (json['message'] == "PasswordDoesNotMatch")
                    alert("Password does not match");

            } else {
                Ti.App.Properties.setBool("Registered", true);
                //alert(json);
                //{friendRequests=null, first_name=m k, badges=null, friends=null, email=m, last_name=m, userid=76, date_of_birth=2013-11-30, gender=Female, password=m, city=Ankara}
                Ti.App.Properties.setObject("User", json);
                MainWindow().open();
                self.parent.close();
            }

            //alert("lol");

        },
        onerror : function(e) {
            Ti.API.debug("STATUS: " + this.status);
            Ti.API.debug("TEXT: " + this.responseText);
            Ti.API.debug("ERROR: " + e.error);
            alert('There was an error retrieving the remote data. Try again.');
        },
        timeout : 10000
    });
    loginButton.addEventListener('click', function(e) {
        if (Titanium.Network.networkType == Titanium.Network.NETWORK_NONE) {
            alert("No connection!");
        } else {
            if (emailField.value != '' && passwordField.value != '') {
                url = "http://54.194.111.128:8080/CerealKillers/rest/login/" + emailField.value + '/' + passwordField.value + '/';
                //url = "http://144.122.238.245:8080/CerealKillers/rest/login/" + emailField.value + '/' + passwordField.value + '/';
                //url = "http://ip.jsontest.com/";
                xhr.open('GET', url);
                xhr.send();
            } else {
                alert("Fill required fields!");
            }
        }
    });

    var registerButton = Ti.UI.createButton({
        //backgroundColor : '#B5B5B5',
        backgroundColor : '#FAF9F9',
        backgroundSelectedColor : '#1d9e81',
        right : '15%',
        //top : height / 2 + 60,
        top: '250dp',
        height : '50dp',
        width : '32%',
        title : 'Register'
    });

    registerButton.addEventListener('click', function(e) {
        //alert(e.source.title);
        registerWindow().open();
    });

    self.add(emailField);
    self.add(passwordField);

    self.add(loginButton);
    self.add(registerButton);

    return self;
}

module.exports = LoginView;
