//LoginView Component Constructor
function MainView() {
    //create object instance, a parasitic subclass of Observable
    var self = Ti.UI.createView({
        backgroundColor : '#E5E5E5'
    });

    var event = Ti.App.Properties.setObject("Event", null);

    var own = Ti.App.Properties.setObject("Own", null);

    var user = Ti.App.Properties.getObject("User");

    var GeneralProfileWindow = require('ui/handheld/GeneralProfileWindow');
    var ProfileWindow = require('ui/handheld/ProfileWindow');
    var AddEventWindow = require('ui/handheld/AddEventWindow');
    var EventWindow = require('ui/handheld/EventWindow');
    var SearchEventWindow = require('ui/handheld/SearchEventWindow');

    var HEIGHT = Ti.Platform.displayCaps.platformHeight;
    var WIDTH = Ti.Platform.displayCaps.platformWidth;

    //SEARCH WINDOW BEGIN

    var SearchWindow = Ti.UI.createWindow({
        backgroundColor : '#ececec',
        navBarHidden : true,
        exitOnClose : false,
        width : '80%',
        height : '80%'
    });
    var searchView = Ti.UI.createView({
        top : 0,
        left : 0,
        width : '100%',
        height : '60dp',
        backgroundColor : '#1d9e81'
    });
    var searchField = Ti.UI.createTextField({
        top : '10dp',
        left : '5%',
        width : '60%',
        backgroundColor : 'transparent',
        height : '40dp',
        color : 'white',
        hintText : 'Type a name'
    });
    var searchButton = Ti.UI.createButton({
        title : 'Search',
        right : 0,
        top : 0,
        width : '30%',
        height : '100%',
        color : 'white',
        backgroundColor : 'transparent'
    });

    var notificationWindow = Ti.UI.createWindow({
        backgroundColor : '#ececec',
        navBarHidden : true,
        exitOnClose : false,
        width : '80%',
        height : '80%'
    });

    var notificationButton = Ti.UI.createButton({
        title : '0',
        left : 0,
        top : 0,
        width : '60dp',
        height : '100%',
        font : {
            fontSize : '10pt',
            fontWeight : 'bold'
        },
        color : 'white',
        textAlign : Ti.UI.TEXT_ALIGNMENT_CENTER,
        backgroundColor : '#86898E'
    });

    var notificationView = Ti.UI.createView({
        top : 0,
        left : 0,
        width : '100%',
        height : '60dp',
        backgroundColor : '#1d9e81'
    });
    var notificationLabel = Ti.UI.createLabel({
        //top : '10dp',
        font : {
            fontSize : '10pt',
            fontWeight : 'bold'
        },
        color : 'white',
        textAlign : Ti.UI.TEXT_ALIGNMENT_CENTER,
        text : 'Notifications'
    });
    notificationView.add(notificationLabel);
    var showEventButton = Ti.UI.createButton({
        backgroundColor : '#86898E',
        //backgroundColor : '#4c4c4c',
        title : "Tap on an event to see details",
        //top : '60%',
        //layout : 'vertical',
        //top : 0,
        width : '100%',
        height : '7%'
    });

    var profileButton = Ti.UI.createButton({
        backgroundColor : '#1d9e81',
        title : "Profile",
        //top : '68%',
        bottom : 0,
        //width : '60%',
        width : WIDTH / 3 - 2,
        left : 0,
        height : '7%'
    });
    var eventButton = Ti.UI.createButton({
        backgroundColor : '#1d9e81',
        title : "Create Event",
        //top : '76%',
        bottom : 0,
        left : WIDTH / 3 + 2,
        width : WIDTH / 3 - 2,
        //width : '60%',
        height : '7%'
    });
    var logoutButton = Ti.UI.createButton({
        backgroundColor : '#1d9e81',
        title : "Logout",
        //top : '84%',
        bottom : 0,
        //width : '60%',
        width : WIDTH / 3 - 2,
        right : 0,
        height : '7%'
    });

    var json10;
    var xhr10 = Ti.Network.createHTTPClient({
        onload : function() {
            // parse the retrieved data, turning it into a JavaScript object
            json10 = JSON.parse(this.responseText);
            var tableData = [];
            var hebele;
            //alert(json10.length);
            for (var i = 0; i < json10.length; i++) {
                if (json10[i].operation == 'friends') {
                    var row = Ti.UI.createTableViewRow({
                        className : 'searchResults', // used to improve table performance
                        selectedBackgroundColor : 'white',
                        rowIndex : i, // custom property, useful for determining the row during events
                        height : '80dp'
                    });
                    var imageAvatar = Ti.UI.createImageView({
                        image : '/images/avatar.png',
                        left : '10dp',
                        top : '10dp',
                        width : '50dp',
                        height : '50dp'
                    });
                    row.add(imageAvatar);

                    var firstUserName = Ti.UI.createLabel({
                        text : json10[i].user.first_name + ' ' + json10[i].user.last_name,
                        color : '#1d9e81',
                        font : {
                            fontSize : '10pt',
                            fontWeight : 'bold'
                        },
                        left : '70dp',
                        top : '6dp',
                        my_id : i
                    });
                    row.add(firstUserName);

                    firstUserName.addEventListener('click', function(evt) {
                        Ti.App.Properties.setObject("GeneralUser", json10[evt.source.my_id].user);
                        GeneralProfileWindow().open({
                            modal : true
                        });
                    });

                    var textLabel = Ti.UI.createLabel({
                        color : '#222',
                        font : {
                            fontFamily : 'Arial',
                            fontSize : 20,
                            fontWeight : 'normal'
                        },
                        text : ' is now friends with',
                        left : '70dp',
                        top : '44dp',
                        width : '360dp'
                    });
                    row.add(textLabel);
				
                    var secondUserName = Ti.UI.createLabel({
                        color : '#1d9e81',
                        font : {
                            fontFamily : 'Arial',
                            fontSize : 20,
                            fontWeight : 'normal'
                        },
                        text : json10[i].user2.first_name + ' ' + json10[i].user2.last_name,
                        left : '160dp',
                        top : '44dp',
                        width : '360dp',
                        my_id : i
                    });
                    row.add(secondUserName);
                    textLabel.addEventListener('postlayout', function(e) {
				        var leftValue = textLabel.rect.x + textLabel.rect.width+4;
				        //alert(topValue);
				        //showEventButton.top = topValue + showEventButton.rect.height;
				    	secondUserName.left = leftValue;
				    });
                    secondUserName.addEventListener('click', function(evt) {
                        Ti.App.Properties.setObject("GeneralUser", json10[evt.source.my_id].user2);
                        GeneralProfileWindow().open({
                            modal : true
                        });
                    });
                    tableData.push(row);
                } else if (json10[i].operation == 'create') {
                    var row = Ti.UI.createTableViewRow({
                        className : 'searchResults', // used to improve table performance
                        selectedBackgroundColor : 'white',
                        rowIndex : i, // custom property, useful for determining the row during events
                        height : '80dp'
                    });
                    var imageAvatar = Ti.UI.createImageView({
                        image : '/images/avatar.png',
                        left : '10dp',
                        top : '10dp',
                        width : '50dp',
                        height : '50dp'
                    });
                    row.add(imageAvatar);

                    var firstUserName = Ti.UI.createLabel({
                        text : json10[i].user.first_name + ' ' + json10[i].user.last_name,
                        color : '#1d9e81',
                        font : {
                            fontSize : '10pt',
                            fontWeight : 'bold'
                        },
                        left : '70dp',
                        top : '6dp',
                        my_id : i
                    });
                    row.add(firstUserName);
                    
                    firstUserName.addEventListener('click', function(evt) {
                        Ti.App.Properties.setObject("GeneralUser", json10[evt.source.my_id].user);
                        GeneralProfileWindow().open({
                            modal : true
                        });
                    });
                    
                    

                    var textLabel = Ti.UI.createLabel({
                        color : '#222',
                        font : {
                            fontFamily : 'Arial',
                            fontSize : 20,
                            fontWeight : 'normal'
                        },
                        text : ' created an event',
                        left : '70dp',
                        top : '44dp',
                        width : '360dp'
                    });
                    row.add(textLabel);

                    var eventName = Ti.UI.createLabel({
                        color : '#1d9e81',
                        font : {
                            fontFamily : 'Arial',
                            fontSize : 20,
                            fontWeight : 'normal'
                        },
                        text : json10[i].event.event_name,
                        left : '155dp',
                        top : '44dp',
                        width : '360dp',
                        my_id : i
                    });
                    textLabel.addEventListener('postlayout', function(e) {
				        var leftValue = textLabel.rect.x + textLabel.rect.width + 4;
				        //alert(topValue);
				        //showEventButton.top = topValue + showEventButton.rect.height;
				    	eventName.left = leftValue;
				    });
                    row.add(eventName);

                    eventName.addEventListener('click', function(evt) {
                        var json11;
                        var xhr11 = Ti.Network.createHTTPClient({
                            onload : function() {
                                // parse the retrieved data, turning it into a JavaScript object
                                json11 = JSON.parse(this.responseText);
                                Ti.App.Properties.setObject("Event", json11);
                                EventWindow().open({
                                    modal : true
                                });
                            },
                            onerror : function(e) {
                                Ti.API.debug("STATUS: " + this.status);
                                Ti.API.debug("TEXT: " + this.responseText);
                                Ti.API.debug("ERROR: " + e.error);
                                alert('There was an error retrieving the remote data. Try again.');
                            },
                            timeout : 10000
                        });
                        var url2 = 'http://54.194.111.128:8080/CerealKillers/rest/event/getEvent/' + user.userid + "/" + json10[evt.source.my_id].event.event_id;
                        xhr11.open('GET', url2);
                        xhr11.send();

                    });
                    tableData.push(row);
                } else if (json10[i].operation == 'join') {
                    var row = Ti.UI.createTableViewRow({
                        className : 'searchResults', // used to improve table performance
                        selectedBackgroundColor : 'white',
                        rowIndex : i, // custom property, useful for determining the row during events
                        height : '80dp'
                    });
                    var imageAvatar = Ti.UI.createImageView({
                        image : '/images/avatar.png',
                        left : '10dp',
                        top : '10dp',
                        width : '50dp',
                        height : '50dp'
                    });
                    row.add(imageAvatar);

                    var firstUserName = Ti.UI.createLabel({
                        text : json10[i].user.first_name + ' ' + json10[i].user.last_name,
                        color : '#1d9e81',
                        font : {
                            fontSize : '10pt',
                            fontWeight : 'bold'
                        },
                        left : '70dp',
                        top : '6dp',
                        my_id : i
                    });
                    row.add(firstUserName);
                    
                    firstUserName.addEventListener('click', function(evt) {
                        Ti.App.Properties.setObject("GeneralUser", json10[evt.source.my_id].user);
                        GeneralProfileWindow().open({
                            modal : true
                        });
                    });

                    var textLabel = Ti.UI.createLabel({
                        color : '#222',
                        font : {
                            fontFamily : 'Arial',
                            fontSize : 20,
                            fontWeight : 'normal'
                        },
                        text : ' is attending',
                        left : '70dp',
                        top : '44dp',
                        width : '360dp'
                    });
                    row.add(textLabel);

                    var eventName = Ti.UI.createLabel({
                        color : '#1d9e81',
                        font : {
                            fontFamily : 'Arial',
                            fontSize : 20,
                            fontWeight : 'normal'
                        },
                        text : json10[i].event.event_name,
                        left : '130dp',
                        top : '44dp',
                        width : '360dp',
                        my_id : i
                    });
                    row.add(eventName);
					textLabel.addEventListener('postlayout', function(e) {
				        var leftValue = textLabel.rect.x + textLabel.rect.width+4;
				        //alert(topValue);
				        //showEventButton.top = topValue + showEventButton.rect.height;
				    	eventName.left = leftValue;
					});	
                    eventName.addEventListener('click', function(evt) {
                        var json11;
                        var xhr11 = Ti.Network.createHTTPClient({
                            onload : function() {
                                // parse the retrieved data, turning it into a JavaScript object
                                json11 = JSON.parse(this.responseText);
                                Ti.App.Properties.setObject("Event", json11);
                                EventWindow().open({
                                    modal : true
                                });
                            },
                            onerror : function(e) {
                                Ti.API.debug("STATUS: " + this.status);
                                Ti.API.debug("TEXT: " + this.responseText);
                                Ti.API.debug("ERROR: " + e.error);
                                alert('There was an error retrieving the remote data. Try again.');
                            },
                            timeout : 10000
                        });
                        var url2 = 'http://54.194.111.128:8080/CerealKillers/rest/event/getEvent/' + user.userid + "/" + json10[evt.source.my_id].event.event_id;
                        xhr11.open('GET', url2);
                        xhr11.send();

                    });
                    tableData.push(row);
                } else if (json10[i].operation == 'rate') {
                    var row = Ti.UI.createTableViewRow({
                        className : 'searchResults', // used to improve table performance
                        selectedBackgroundColor : 'white',
                        rowIndex : i, // custom property, useful for determining the row during events
                        height : '80dp'
                    });
                    var imageAvatar = Ti.UI.createImageView({
                        image : '/images/avatar.png',
                        left : '10dp',
                        top : '10dp',
                        width : '50dp',
                        height : '50dp'
                    });
                    row.add(imageAvatar);

                    var firstUserName = Ti.UI.createLabel({
                        text : json10[i].user.first_name + ' ' + json10[i].user.last_name,
                        color : '#1d9e81',
                        font : {
                            fontSize : '10pt',
                            fontWeight : 'bold'
                        },
                        left : '70dp',
                        top : '6dp',
                        my_id : i
                    });
                    row.add(firstUserName);
                    
                    firstUserName.addEventListener('click', function(evt) {
                        Ti.App.Properties.setObject("GeneralUser", json10[evt.source.my_id].user);
                        GeneralProfileWindow().open({
                            modal : true
                        });
                    });

                    var textLabel = Ti.UI.createLabel({
                        color : '#222',
                        font : {
                            fontFamily : 'Arial',
                            fontSize : 20,
                            fontWeight : 'normal'
                        },
                        text : ' has rated the event ',
                        left : '70dp',
                        top : '44dp',
                        width : '360dp'
                    });
                    row.add(textLabel);

                    var eventName = Ti.UI.createLabel({
                        color : '#1d9e81',
                        font : {
                            fontFamily : 'Arial',
                            fontSize : 20,
                            fontWeight : 'normal'
                        },
                        text : json10[i].event.event_name,
                        left : '165dp',
                        top : '44dp',
                        width : '360dp',
                        my_id : i
                    });
                    row.add(eventName);
                    textLabel.addEventListener('postlayout', function(e) {
				        var leftValue = textLabel.rect.x + textLabel.rect.width+4;
				        //alert(topValue);
				        //showEventButton.top = topValue + showEventButton.rect.height;
				    	eventName.left = leftValue;
					});	
                    eventName.addEventListener('click', function(evt) {
                        var json11;
                        var xhr11 = Ti.Network.createHTTPClient({
                            onload : function() {
                                // parse the retrieved data, turning it into a JavaScript object
                                json11 = JSON.parse(this.responseText);
                                Ti.App.Properties.setObject("Event", json11);
                                EventWindow().open({
                                    modal : true
                                });
                            },
                            onerror : function(e) {
                                Ti.API.debug("STATUS: " + this.status);
                                Ti.API.debug("TEXT: " + this.responseText);
                                Ti.API.debug("ERROR: " + e.error);
                                alert('There was an error retrieving the remote data. Try again.');
                            },
                            timeout : 10000
                        });
                        var url2 = 'http://54.194.111.128:8080/CerealKillers/rest/event/getEvent/' + user.userid + "/" + json10[evt.source.my_id].event.event_id;
                        xhr11.open('GET', url2);
                        xhr11.send();

                    });
                    tableData.push(row);
                } else if (json10[i].operation == 'comment') {
                    var row = Ti.UI.createTableViewRow({
                        className : 'searchResults', // used to improve table performance
                        selectedBackgroundColor : 'white',
                        rowIndex : i, // custom property, useful for determining the row during events
                        height : '80dp'
                    });
                    var imageAvatar = Ti.UI.createImageView({
                        image : '/images/avatar.png',
                        left : '10dp',
                        top : '10dp',
                        width : '50dp',
                        height : '50dp'
                    });
                    row.add(imageAvatar);

                    var firstUserName = Ti.UI.createLabel({
                        text : json10[i].user.first_name + ' ' + json10[i].user.last_name,
                        color : '#1d9e81',
                        font : {
                            fontSize : '10pt',
                            fontWeight : 'bold'
                        },
                        left : '70dp',
                        top : '6dp',
                        my_id : i
                    });
                    row.add(firstUserName);
                    
                    firstUserName.addEventListener('click', function(evt) {
                        Ti.App.Properties.setObject("GeneralUser", json10[evt.source.my_id].user);
                        GeneralProfileWindow().open({
                            modal : true
                        });
                    });

                    var textLabel = Ti.UI.createLabel({
                        color : '#222',
                        font : {
                            fontFamily : 'Arial',
                            fontSize : 20,
                            fontWeight : 'normal'
                        },
                        text : ' has commented on the event ',
                        left : '70dp',
                        top : '44dp',
                        width : '360dp'
                    });
                    row.add(textLabel);

                    var eventName = Ti.UI.createLabel({
                        color : '#1d9e81',
                        font : {
                            fontFamily : 'Arial',
                            fontSize : 20,
                            fontWeight : 'normal'
                        },
                        text : json10[i].event.event_name,
                        left : '210dp',
                        top : '44dp',
                        width : '360dp',
                        my_id : i
                    });
                    row.add(eventName);
					textLabel.addEventListener('postlayout', function(e) {
				        var leftValue = textLabel.rect.x + textLabel.rect.width+4;
				        //alert(topValue);
				        //showEventButton.top = topValue + showEventButton.rect.height;
				    	eventName.left = leftValue;
					});	
                    eventName.addEventListener('click', function(evt) {
                        var json11;
                        var xhr11 = Ti.Network.createHTTPClient({
                            onload : function() {
                                // parse the retrieved data, turning it into a JavaScript object
                                json11 = JSON.parse(this.responseText);
                                Ti.App.Properties.setObject("Event", json11);
                                EventWindow().open({
                                    modal : true
                                });
                            },
                            onerror : function(e) {
                                Ti.API.debug("STATUS: " + this.status);
                                Ti.API.debug("TEXT: " + this.responseText);
                                Ti.API.debug("ERROR: " + e.error);
                                alert('There was an error retrieving the remote data. Try again.');
                            },
                            timeout : 10000
                        });
                        var url2 = 'http://54.194.111.128:8080/CerealKillers/rest/event/getEvent/' + user.userid + "/" + json10[evt.source.my_id].event.event_id;
                        xhr11.open('GET', url2);
                        xhr11.send();
                    });
                    tableData.push(row);
                }

            }
            var list = Ti.UI.createTableView({
                top : '54%',

                height : (HEIGHT / 5.32).toString() + 'dp',
                data : tableData
            });
            self.add(list);

        },
        onerror : function(e) {
            Ti.API.debug("STATUS: " + this.status);
            Ti.API.debug("TEXT: " + this.responseText);
            Ti.API.debug("ERROR: " + e.error);
            alert('There was an error retrieving the remote data. Try again.');
        },
        timeout : 10000
    });

    var url = 'http://54.194.111.128:8080/CerealKillers/rest/newsfeed/getNewsfeed/' + user.userid;
    xhr10.open('GET', url);
    xhr10.send();

    var json9;
    var xhr9 = Ti.Network.createHTTPClient({
        onload : function() {
            // parse the retrieved data, turning it into a JavaScript object
            json9 = JSON.parse(this.responseText);
            var notificationCount = json9.length;
            notificationButton.title = (notificationCount).toString();
            //notificationButton.title = "H";

            if (notificationCount > 0)
                notificationButton.backgroundColor = '#E1151E';
            //alert(json4.length);
        },
        onerror : function(e) {
            Ti.API.debug("STATUS: " + this.status);
            Ti.API.debug("TEXT: " + this.responseText);
            Ti.API.debug("ERROR: " + e.error);
            alert('There was an error retrieving the remote data. Try again.');
        },
        timeout : 10000
    });

    var url = 'http://54.194.111.128:8080/CerealKillers/rest/friendship/getFriendRequestsOfUser/' + user.userid;
    xhr9.open('GET', url);
    xhr9.send();

    var json3;
    var xhr3 = Ti.Network.createHTTPClient({
        onload : function() {
            // parse the retrieved data, turning it into a JavaScript object
            json3 = JSON.parse(this.responseText);
            //alert(json3.message);
            if (SearchWindow.children.length == 2)
                SearchWindow.remove(SearchWindow.children[1]);
            SearchWindow.close();
            //alert("lol");
        },
        onerror : function(e) {
            Ti.API.debug("STATUS: " + this.status);
            Ti.API.debug("TEXT: " + this.responseText);
            Ti.API.debug("ERROR: " + e.error);
            alert('There was an error retrieving the remote data. Try again.');
        },
        timeout : 10000
    });

    var json5;
    var xhr5 = Ti.Network.createHTTPClient({
        onload : function() {
            // parse the retrieved data, turning it into a JavaScript object
            json5 = JSON.parse(this.responseText);
            //alert(json3.message);
            if (notificationWindow.children.length == 2)
                notificationWindow.remove(notificationWindow.children[1]);
            notificationWindow.close();
            //alert("lol");
        },
        onerror : function(e) {
            Ti.API.debug("STATUS: " + this.status);
            Ti.API.debug("TEXT: " + this.responseText);
            Ti.API.debug("ERROR: " + e.error);
            alert('There was an error retrieving the remote data. Try again.');
        },
        timeout : 10000
    });

    var json6;
    var xhr6 = Ti.Network.createHTTPClient({
        onload : function() {
            // parse the retrieved data, turning it into a JavaScript object
            json6 = JSON.parse(this.responseText);
            //alert(json3.message);
            if (notificationWindow.children.length == 2)
                notificationWindow.remove(notificationWindow.children[1]);
            notificationWindow.close();
            //alert("lol");
        },
        onerror : function(e) {
            Ti.API.debug("STATUS: " + this.status);
            Ti.API.debug("TEXT: " + this.responseText);
            Ti.API.debug("ERROR: " + e.error);
            alert('There was an error retrieving the remote data. Try again.');
        },
        timeout : 10000
    });

    var json2;
    var xhr2 = Ti.Network.createHTTPClient({
        onload : function() {
            // parse the retrieved data, turning it into a JavaScript object
            json2 = JSON.parse(this.responseText);
            var userList_friend = json2[0];
            var userList_notfriend = json2[1];
            //alert(userList.length);
            tableData = [];

            for (var i = 0; i < userList_friend.length; i++) {
                var row = Ti.UI.createTableViewRow({
                    className : 'searchResults', // used to improve table performance
                    selectedBackgroundColor : 'white',
                    rowIndex : i, // custom property, useful for determining the row during events
                    height : '110dp'
                });

                var infoField = Ti.UI.createButton({
                    title : 'Friend',
                    right : 0,
                    top : '20dp',
                    width : '20%',
                    height : '20%',
                    color : 'white',
                    backgroundColor : '#1d9e81'
                });

                row.add(infoField);

                var imageAvatar = Ti.UI.createImageView({
                    image : '/images/avatar.png',
                    left : '10dp',
                    top : '10dp',
                    width : '75dp',
                    height : '75dp'
                });
                row.add(imageAvatar);

                var userName = Ti.UI.createLabel({
                    color : '#1d9e81',
                    font : {
                        fontFamily : 'Arial',
                        fontSize : 30,
                        fontWeight : 'bold'
                    },
                    text : userList_friend[i].first_name + " " + userList_friend[i].last_name,
                    left : '90dp',
                    top : '6dp'
                });
                row.add(userName);
                userName.addEventListener('click', function(e) {
                    //alert(json2[0][0]);
                    Ti.App.Properties.setObject("GeneralUser", json2[0][e.source.parent.rowIndex]);
                    GeneralProfileWindow().open({
                        modal : true
                    });
                    //alert(userList_friend[e.source.parent.rowIndex].first_name + " " +
                    //	  userList_friend[e.source.parent.rowIndex].last_name);
                });

                //userList_notfriend[e.source.parent.rowIndex]

                var userDetails = Ti.UI.createLabel({
                    color : '#222',
                    font : {
                        fontFamily : 'Arial',
                        fontSize : 20,
                        fontWeight : 'normal'
                    },
                    text : userList_friend[i].city,
                    left : '90dp',
                    top : '44dp',
                    width : '360dp'
                });
                row.add(userDetails);

                tableData.push(row);
            }

            for (var i = 0; i < userList_notfriend.length; i++) {
                var row = Ti.UI.createTableViewRow({
                    className : 'searchResults', // used to improve table performance
                    selectedBackgroundColor : 'white',
                    rowIndex : i, // custom property, useful for determining the row during events
                    height : '110dp'
                });

                var addButton = Ti.UI.createButton({
                    title : 'Add',
                    right : 0,
                    top : '20dp',
                    width : '20%',
                    height : '20%',
                    color : 'white',
                    backgroundColor : '#1d9e81'
                });
                row.add(addButton);

                addButton.addEventListener('click', function(e) {

                    var friendRequestData = {
                        user_id : user.userid,
                        requested_user_id : userList_notfriend[e.source.parent.rowIndex].userid,
                    };

                    var friendRequestDataString = JSON.stringify(friendRequestData);

                    xhr3.open('POST', 'http://54.194.111.128:8080/CerealKillers/rest/friendship/addRequest/');

                    xhr3.setRequestHeader("content-type", "application/json");
                    xhr3.send(friendRequestDataString);
                    alert("request sended from :  " + user.userid + " to " + userList_notfriend[e.source.parent.rowIndex].userid);
                });

                var imageAvatar = Ti.UI.createImageView({
                    image : '/images/avatar.png',
                    left : '10dp',
                    top : '10dp',
                    width : '75dp',
                    height : '75dp'
                });
                row.add(imageAvatar);

                var userName = Ti.UI.createLabel({
                    color : '#1d9e81',
                    font : {
                        fontFamily : 'Arial',
                        fontSize : 30,
                        fontWeight : 'bold'
                    },
                    text : userList_notfriend[i].first_name + " " + userList_notfriend[i].last_name,
                    left : '90dp',
                    top : '6dp'
                });
                row.add(userName);
                userName.addEventListener('click', function(e) {
                    Ti.App.Properties.setObject("GeneralUser", json2[1][e.source.parent.rowIndex]);
                    GeneralProfileWindow().open({
                        modal : true
                    });
                    //alert(userList_notfriend[e.source.parent.rowIndex].first_name + " " +
                    //	  userList_notfriend[e.source.parent.rowIndex].last_name);
                });

                var userDetails = Ti.UI.createLabel({
                    color : '#222',
                    font : {
                        fontFamily : 'Arial',
                        fontSize : 20,
                        fontWeight : 'normal'
                    },
                    text : userList_notfriend[i].city,
                    left : '90dp',
                    top : '44dp',
                    width : '360dp'
                });
                row.add(userDetails);

                tableData.push(row);
            }

            var list = Ti.UI.createTableView({
                top : '60dp',
                data : tableData
            });
            /*
             list.addEventListener('click', function(e) {

             var friendRequestData = {
             user_id : user.userid,
             requested_user_id : userList[e.index].userid,
             };

             var friendRequestDataString = JSON.stringify(friendRequestData);

             xhr3.open('POST', 'http://54.194.111.128:8080/CerealKillers/rest/friendship/addRequest/');

             xhr3.setRequestHeader("content-type", "application/json");
             xhr3.send(friendRequestDataString);
             });
             */
            SearchWindow.add(list);

        },
        onerror : function(e) {
            Ti.API.debug("STATUS: " + this.status);
            Ti.API.debug("TEXT: " + this.responseText);
            Ti.API.debug("ERROR: " + e.error);
            alert('There was an error retrieving the remote data. Try again.');
        },
        timeout : 10000
    });

    searchButton.addEventListener('click', function(e) {
        if (SearchWindow.children.length == 2)
            SearchWindow.remove(SearchWindow.children[1]);
        var url = 'http://54.194.111.128:8080/CerealKillers/rest/friendship/searchUser/' + searchField.value + "/" + user.userid;
        xhr2.open('GET', url);
        xhr2.send();
    });

    searchView.add(searchButton);
    searchView.add(searchField);

    SearchWindow.add(searchView);
    //SEARCH WINDOW END

    var json4;
    var xhr4 = Ti.Network.createHTTPClient({
        onload : function() {
            // parse the retrieved data, turning it into a JavaScript object
            json4 = JSON.parse(this.responseText);

            //alert(json4.length);
            tableData = [];

            for (var i = 0; i < json4.length; i++) {
                var row = Ti.UI.createTableViewRow({
                    className : 'searchResults', // used to improve table performance
                    selectedBackgroundColor : 'white',
                    rowIndex : i, // custom property, useful for determining the row during events
                    height : '110dp'
                });

                var imageAvatar = Ti.UI.createImageView({
                    image : '/images/avatar.png',
                    left : '10dp',
                    top : '5dp',
                    width : '50dp',
                    height : '50dp'
                });
                row.add(imageAvatar);

                var userName = Ti.UI.createLabel({
                    color : '#1d9e81',
                    font : {
                        fontFamily : 'Arial',
                        fontSize : 20,
                        fontWeight : 'bold'
                    },
                    text : json4[i].first_name + " " + json4[i].last_name,
                    left : '70dp',
                    top : '6dp'
                });
                row.add(userName);

                var userDetails = Ti.UI.createLabel({
                    color : '#222',
                    font : {
                        fontFamily : 'Arial',
                        fontSize : 16,
                        fontWeight : 'normal'
                    },
                    text : json4[i].city,
                    left : '70dp',
                    top : '44dp',
                    width : '360dp'
                });
                row.add(userDetails);

                var acceptButton = Ti.UI.createButton({
                    right : '50dp',
                    top : '15dp',
                    width : '10%',
                    height : '40%',
                    backgroundColor : 'transparent',
                    image : '/images/accept.png'
                });
                row.add(acceptButton);

                var rejectButton = Ti.UI.createButton({
                    right : '15dp',
                    top : '15dp',
                    width : '10%',
                    height : '40%',
                    backgroundColor : 'transparent',
                    image : '/images/reject.png'
                });
                row.add(rejectButton);

                acceptButton.addEventListener('click', function(e) {

                    var acceptRequestData = {
                        user_id : user.userid,
                        friend_user_id : json4[e.source.parent.rowIndex].userid,
                    };

                    var acceptRequestDataString = JSON.stringify(acceptRequestData);

                    xhr5.open('POST', 'http://54.194.111.128:8080/CerealKillers/rest/friendship/acceptRequest');

                    xhr5.setRequestHeader("content-type", "application/json");
                    xhr5.send(acceptRequestDataString);
                    alert("request accepted from :  " + json4[e.source.parent.rowIndex].userid);
                });

                rejectButton.addEventListener('click', function(e) {

                    var rejectRequestData = {
                        user_id : user.userid,
                        friend_user_id : json4[e.source.parent.rowIndex].userid,
                    };

                    var rejectRequestDataString = JSON.stringify(rejectRequestData);

                    xhr6.open('POST', 'http://54.194.111.128:8080/CerealKillers/rest/friendship/rejectRequest');

                    xhr6.setRequestHeader("content-type", "application/json");
                    xhr6.send(rejectRequestDataString);
                    alert("request rejected from :  " + json4[e.source.parent.rowIndex].userid);
                });

                tableData.push(row);
            }

            var list = Ti.UI.createTableView({
                top : '60dp',
                data : tableData
            });
            /*
             list.addEventListener('click', function(e) {

             var friendRequestData = {
             user_id : user.userid,
             requested_user_id : userList[e.index].userid,
             };

             var friendRequestDataString = JSON.stringify(friendRequestData);

             xhr3.open('POST', 'http://54.194.111.128:8080/CerealKillers/rest/friendship/addRequest/');

             xhr3.setRequestHeader("content-type", "application/json");
             xhr3.send(friendRequestDataString);
             });
             */
            notificationWindow.add(list);

        },
        onerror : function(e) {
            Ti.API.debug("STATUS: " + this.status);
            Ti.API.debug("TEXT: " + this.responseText);
            Ti.API.debug("ERROR: " + e.error);
            alert('There was an error retrieving the remote data. Try again.');
        },
        timeout : 10000
    });

    notificationWindow.add(notificationView);

    var MapModule = require('ti.map');

    var height = Ti.Platform.displayCaps.platformHeight;

    var titleView = Ti.UI.createView({
        top : 0,
        left : 0,
        width : '100%',
        height : '60dp',
        backgroundColor : '#1d9e81'
    });
    var titleLabel = Ti.UI.createLabel({
        top : '10dp',
        font : {
            fontSize : '10pt',
            fontWeight : 'bold'
        },
        color : 'white',
        textAlign : Ti.UI.TEXT_ALIGNMENT_CENTER,
        text : 'Main Window'
    });
    var goToSearchButton = Ti.UI.createButton({
        title : 'Find People',
        right : 0,
        top : 0,
        width : '30%',
        height : '100%',
        color : 'white',
        backgroundColor : 'transparent'
    });
    goToSearchButton.addEventListener('click', function(e) {
        SearchWindow.open({
            modal : true
        });
    });

    SearchWindow.addEventListener('close', function(e) {
        //alert('you just hit back --ie, this thing closed');
        if (SearchWindow.children.length == 2)
            SearchWindow.remove(SearchWindow.children[1]);
        SearchWindow.close();
    });

    var searchEventButton = Ti.UI.createButton({
        title : 'Search Event',
        left : '33%',
        top : 0,
        width : '30%',
        height : '100%',
        color : 'white',
        backgroundColor : 'transparent'
    });

    searchEventButton.addEventListener('click', function(e) {
        //alert('you just hit back --ie, this thing closed');
        Ti.App.Properties.setObject("User", user);
        SearchEventWindow().open({
            height : '80%',
            width : '80%',
            modal : true
        });
    });

    notificationButton.addEventListener('click', function(e) {
        var url = 'http://54.194.111.128:8080/CerealKillers/rest/friendship/getFriendRequestsOfUser/' + user.userid;
        xhr4.open('GET', url);
        xhr4.send();
        notificationWindow.open({
            modal : true
        });

    });

    notificationWindow.addEventListener('close', function(e) {
        //alert('you just hit back --ie, this thing closed');
        if (notificationWindow.children.length == 2)
            notificationWindow.remove(notificationWindow.children[1]);
        notificationWindow.close();
    });

    titleView.add(goToSearchButton);
    titleView.add(searchEventButton);
    titleView.add(notificationButton);

    self.add(titleView);
    //self.add(titleLabel);

    var map = MapModule.createView({
        userLocation : true,
        mapType : MapModule.NORMAL_TYPE,
        animate : true,
        region : {
            latitude : 0,
            longitude : 0,
            latitudeDelta : 1,
            longitudeDelta : 1
        },
        height : '40%',
        top : '60dp',
        left : 0,
        width : '100%',
        layout : 'vertical'
    });
    self.add(map);

    Ti.Geolocation.getCurrentPosition(function(e) {
        if (e.error) {
            return;
        }
        map.setRegion({
            latitude : e.coords.latitude,
            longitude : e.coords.longitude,
            latitudeDelta : 0.1,
            longitudeDelta : 0.1,
            animate : true
        });
    });

    var url = 'http://54.194.111.128:8080/CerealKillers/rest/event/getFriendsEventsInRadius/' + user.userid + '/39.897917/32.798861/100/15/01-01-2010/01-01-2020/';
    var json;

    var xhr = Ti.Network.createHTTPClient({
        onload : function() {
            // parse the retrieved data, turning it into a JavaScript object
            json = JSON.parse(this.responseText);

            //alert("pins are created");
            var annotationList = [];

            for (var i = 0; i < json.length; i++) {
                var eventPin = MapModule.createAnnotation({
                    latitude : json[i].location.latitude,
                    longitude : json[i].location.longitude,
                    pincolor : MapModule.ANNOTATION_AZURE,
                    // Even though we are creating a button, it does not respond to Button events or animates.
                    // Use the Map View's click event and monitor the clicksource property for 'leftPane'.
                    /*leftView : Ti.UI.createButton({
                    title : 'Detail'
                    }),*/
                    // For eventing, use the Map View's click event
                    // and monitor the clicksource property for 'rightPane'.
                    //rightButton: 'appicon.png',
                    title : json[i].event_name,
                    subtitle : json[i].event_type,
                    myid : i
                });
                map.addEventListener('click', function(evt) {
                    var clicksource = evt.clicksource;
                    var source = evt.annotation;
                    var index = source.myid;
                    //if (clicksource == "leftPane" || clicksource == "title") {//leftButton event
                    if (clicksource == "pin") {
                        Ti.App.Properties.setObject("Event", json[index]);
                        showEventButton.backgroundColor = "#1d9e81";
                        showEventButton.title = "Go to event details: " + json[index].event_name;
                        //alert("Event Selected...");
                        /*EventWindow().open({
                         modal : true
                         });*/
                        /*alert(json[index].event_name + "\n" + json[index].event_description + "\n" +
                         json[index].location.formatted_address+ "\n" + json[index].event_type + "\n" +
                         json[index].start_date +  "\n" + json[index].end_date); */
                    }
                    //var url = 'http://54.194.111.128:8080/CerealKillers/rest/friendship/getFriendRequestsOfUser/' + user.userid;
                    //xhr4.open('GET', url);
                    //xhr4.send();
                    //notificationWindow.open();

                });
                annotationList.push(eventPin);
            }
            map.setAnnotations(annotationList);

        },
        onerror : function(e) {
            Ti.API.debug("STATUS: " + this.status);
            Ti.API.debug("TEXT: " + this.responseText);
            Ti.API.debug("ERROR: " + e.error);
            alert('There was an error retrieving the remote data. Try again.');
        },
        timeout : 10000
    });

    xhr.open('GET', url);
    xhr.send();

    //var topValue = map.rect.x + map.rect.height;
    //alert(topValue);

    showEventButton.addEventListener('click', function(e) {
        var event = Ti.App.Properties.getObject('Event');
        if (event == null) {
            alert("Select Event From Map");
        } else {
            EventWindow().open({
                modal : true
            });
        }

    });

    map.addEventListener('postlayout', function(e) {
        var topValue = map.rect.x + map.rect.height;
        //alert(topValue);
        showEventButton.top = topValue + showEventButton.rect.height;
    });

    profileButton.addEventListener('click', function(e) {
        //alert(e.source.title);
        ProfileWindow().open({
            modal : true
        });
    });
    eventButton.addEventListener('click', function(e) {
        AddEventWindow().open({
            modal : true
        });
    });
    logoutButton.addEventListener('click', function(e) {
        Ti.App.Properties.removeProperty('User');
        Ti.App.Properties.setBool('Registered', false);
        self.parent.close();
    });

    self.add(showEventButton);
    self.add(profileButton);
    self.add(eventButton);
    self.add(logoutButton);

    return self;
}

module.exports = MainView;
