//FirstView Component Constructor
function SearchEventView() {
	//create object instance, a parasitic subclass of Observable

	var user = Ti.App.Properties.getObject("User");
	
	var EventWindow = require('ui/handheld/EventWindow');

	var self = Ti.UI.createScrollView({
		height : '100%',
		contextHeight : 'auto',
		contextWidth : '100%',
		top : 0,
		width : '100%'
	});

	var searchView = Ti.UI.createView({
		top : 0,
		left : 0,
		width : '100%',
		height : '60dp',
		backgroundColor : '#1d9e81'
	});

	var searchField = Ti.UI.createTextField({
		top : '10dp',
		left : '5%',
		width : '60%',
		backgroundColor : 'transparent',
		height : '40dp',
		color : 'white',
		hintText : 'Type an event name'
	});

	var searchButton = Ti.UI.createButton({
		title : 'Search',
		right : 0,
		top : 0,
		width : '30%',
		height : '100%',
		color : 'white',
		backgroundColor : 'transparent'
	});

	var json2;
	var xhr2 = Ti.Network.createHTTPClient({
		onload : function() {
			// parse the retrieved data, turning it into a JavaScript object
			json2 = JSON.parse(this.responseText);
			//alert(json2.length);
			tableData = [];
			
			for (var i = 0; i < json2.length; i++) {
				var row = Ti.UI.createTableViewRow({
					className : 'searchResults', // used to improve table performance
					selectedBackgroundColor : 'white',
					rowIndex : i, // custom property, useful for determining the row during events
					height : '110dp'
				});
				
				var imageAvatar = Ti.UI.createImageView({
					image : '/images/event.jpg',
					left : '10dp',
					top : '10dp',
					width : '75dp',
					height : '75dp'
				});
				row.add(imageAvatar);


				var eventName = Ti.UI.createLabel({
					text : json2[i].event_name,
					color : '#1d9e81',
					font : {
						fontSize : '10pt',
						fontWeight : 'bold'
					},
					left : '90dp',
					top : '6dp',
					my_id : i
				});
				row.add(eventName);
			
				
				eventName.addEventListener('click', function(evt) {
					//alert("id " + evt.source.my_id);

					Ti.App.Properties.setObject("Event", json2[evt.source.my_id]);
					//alert(json[evt.source.my_id]);
					EventWindow().open({
						modal : true
					});
					//alert(userList_friend[e.source.parent.rowIndex].first_name + " " +
					//	  userList_friend[e.source.parent.rowIndex].last_name);
				}); 
				
				var formattedAddress = Ti.UI.createLabel({
					color : '#222',
					font : {
						fontFamily : 'Arial',
						fontSize : 20,
						fontWeight : 'normal'
					},
					text : json2[i].location.formatted_address,
					left : '90dp',
					top : '44dp',
					width : '360dp'
				});
				row.add(formattedAddress);
				
				var time = Ti.UI.createLabel({
					color : '#222',
					font : {
						fontFamily : 'Arial',
						fontSize : 20,
						fontWeight : 'normal'
					},
					text : json2[i].start_date,
					left : '90dp',
					top : '70dp',
					width : '360dp'
				});
				
				row.add(time);
				
				tableData.push(row);
				
			}
			
			var list = Ti.UI.createTableView({
				top : '60dp',
				data : tableData
			});
			
			self.add(list);

		},
		onerror : function(e) {
			Ti.API.debug("STATUS: " + this.status);
			Ti.API.debug("TEXT: " + this.responseText);
			Ti.API.debug("ERROR: " + e.error);
			alert('There was an error retrieving the remote data. Try again.');
		},
		timeout : 10000
	});

	searchButton.addEventListener('click', function(e) {
	    if (self.children.length == 2)
            self.remove(self.children[1]);
		var url = 'http://54.194.111.128:8080/CerealKillers/rest/event/searchEvent/' + searchField.value + "/" + user.userid + "/" + 0 + "/" + 100;
		xhr2.open('GET', url);
		xhr2.send();
	});

	searchView.add(searchButton);
	searchView.add(searchField);

	self.add(searchView);

	return self;
}

module.exports = SearchEventView;

