package tr.cerealkillers.com.Controller;

import com.google.gson.Gson;
import org.primefaces.json.JSONArray;
import org.primefaces.json.JSONException;
import org.primefaces.json.JSONObject;
import tr.cerealkillers.com.Objects.UserImplementation;
import tr.cerealkillers.com.Util.WebServiceConnector;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

@ManagedBean
@SessionScoped
public class FriendshipController implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = -5195480722642958701L;
	public List<UserImplementation> friends;
	public List<UserImplementation> others;
	public List<UserImplementation> results;
	public List<UserImplementation> friendship_requests;

	@ManagedProperty(value = "#{loginController}")
	private LoginController loginController;

    @ManagedProperty(value = "#{viewEventController}")
    private ViewEventController viewEventController;

	private UserImplementation viewUser;

	private int viewUserID;
	private String source;

    public ViewEventController getViewEventController() {
        return viewEventController;
    }

    public void setViewEventController(ViewEventController viewEventController) {
        this.viewEventController = viewEventController;
    }

    public String getSource() {
		return source;
	}

	public void setSource(String source) {
		this.source = source;
	}

	public void setViewUser(UserImplementation viewUser) {
		this.viewUser = viewUser;
	}

	public int getViewUserID() {
		return viewUserID;
	}

	public boolean getDisplayEvents() {
		return viewUserID == loginController.getTheUser().getUserid();
	}

	public void setViewUserID(int viewUserID) {
		this.viewUserID = viewUserID;
	}

	public UserImplementation getViewUser() {
		if (viewUserID == loginController.getTheUser().getUserid()) {
			return loginController.getTheUser();
		} else if (viewUser != null && viewUserID == viewUser.getUserid()) {
			return viewUser;
		} else {
			if (source == null) {
				viewUser = loginController.getTheUser();
				return viewUser;
			} else {
				if (source.equals("search")) {
					for (UserImplementation user : results) {
						if (user.getUserid() == viewUserID) {
							viewUser = user;
							return viewUser;
						}
					}
				} else if (source.equals("request")) {
					for (UserImplementation user : friendship_requests) {
						if (user.getUserid() == viewUserID) {
							viewUser = user;
							return viewUser;
						}
					}
				} else if (source.equals("joiner")) {
                    List<UserImplementation> list = viewEventController.getJoiners();
                    for (UserImplementation user : list) {
                        if (user.getUserid() == viewUserID) {
                            viewUser = user;
                            return viewUser;
                        }
                    }
                }
			}
			return null;
		}
	}

	public FriendshipController() {

	}

	public void setLoginController(LoginController loginController) {
		this.loginController = loginController;
		friendship_requests = new ArrayList<UserImplementation>();
		if (loginController != null && loginController.getTheUser() != null) {
			String result = WebServiceConnector.getInstance().connectGet(
					"rest/friendship/getFriendRequestsOfUser/"
							+ loginController.getTheUser().getUserid());
			try {
				JSONArray arr = new JSONArray(result);
				Gson gson = new Gson();
				int lenght = arr.length();
				for (int i = 0; i < lenght; i++) {
					JSONObject obj = arr.getJSONObject(i);
					UserImplementation ui = gson.fromJson(obj.toString(),
							UserImplementation.class);
					friendship_requests.add(ui);
				}
			} catch (JSONException e) {
				e.printStackTrace();
			}
		}
	}

	public List<UserImplementation> getResults() {
		return results;
	}

	public void setResults(List<UserImplementation> results) {
		this.results = results;
	}

	public List<UserImplementation> getFriends() {
		return friends;
	}

	public void setFriends(List<UserImplementation> friends) {
		this.friends = friends;
	}

	public List<UserImplementation> getOthers() {
		return others;
	}

	public void setOthers(List<UserImplementation> others) {
		this.others = others;
	}

	public List<UserImplementation> getFriendship_requests() {
		return friendship_requests;
	}

	public void setFriendship_requests(
			List<UserImplementation> friendship_requests) {
		this.friendship_requests = friendship_requests;
	}

	public String searchQuery;

	public String getSearchQuery() {
		return searchQuery;
	}

	public void setSearchQuery(String searchQuery) {
		this.searchQuery = searchQuery;
	}

	public String executeQuery() {
		String result = WebServiceConnector.getInstance().connectGet(
				"rest/friendship/searchUser/" + searchQuery + "/"
						+ loginController.getTheUser().getUserid());
		searchQuery = null;
		try {
			Gson gson = new Gson();
			JSONArray objs = new JSONArray(result);
			friends = new ArrayList<UserImplementation>();
			JSONArray arr = objs.getJSONArray(0);
			for (int i = 0; i < arr.length(); i++) {
				JSONObject obj = arr.getJSONObject(i);
				friends.add(gson.fromJson(obj.toString(),
						UserImplementation.class));
			}
			others = new ArrayList<UserImplementation>();
			arr = objs.getJSONArray(1);
			for (int i = 0; i < arr.length(); i++) {
				JSONObject obj = arr.getJSONObject(i);
				others.add(gson.fromJson(obj.toString(),
						UserImplementation.class));
			}
		} catch (JSONException e) {
			e.printStackTrace();
		}
		results = new ArrayList<UserImplementation>();
		results.addAll(friends);
		results.addAll(others);
		return "search";
	}

	public void acceptFriendRequest(UserImplementation user) {
		JSONObject json = new JSONObject();
		try {
			json.put("user_id", loginController.getTheUser().getUserid());
			json.put("friend_user_id", user.getUserid());
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		String result = WebServiceConnector.getInstance().connectPost(
				"rest/friendship/acceptRequest/", json);
		if (result.contains("added")) {
			friendship_requests.remove(user);
			FacesContext.getCurrentInstance().addMessage(null,
					new FacesMessage("Friend request is accepted."));
		} else {
			FacesContext.getCurrentInstance().addMessage(null,
					new FacesMessage("Friend request does not exist anymore."));
		}
	}

	public void sendFriendRequest(UserImplementation user) {
		JSONObject json = new JSONObject();
		try {
			json.put("user_id", loginController.getTheUser().getUserid());
			json.put("requested_user_id", user.getUserid());
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		String result = WebServiceConnector.getInstance().connectPost(
				"rest/friendship/addRequest/", json);
		if (result.contains("added")) {
			FacesContext.getCurrentInstance().addMessage(null,
					new FacesMessage("Friend request is sent."));
		} else {
			FacesContext.getCurrentInstance().addMessage(
					null,
					new FacesMessage(
							"Error occured while sending your request."));
		}
	}

	public void rejectFriendRequest(UserImplementation user) {
		JSONObject json = new JSONObject();
		try {
			json.put("user_id", loginController.getTheUser().getUserid());
			json.put("friend_user_id", user.getUserid());
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		String result = WebServiceConnector.getInstance().connectPost(
				"rest/friendship/rejectRequest/", json);
		if (result.contains("rejected")) {
			friendship_requests.remove(user);
			FacesContext.getCurrentInstance().addMessage(null,
					new FacesMessage("Friend request is rejected."));
		} else {
			FacesContext.getCurrentInstance().addMessage(
					null,
					new FacesMessage(
							"Error occured while processing your request."));
		}
	}

	public String getButtonValue(UserImplementation user) {
		if (user == null)
			user = viewUser;
		if (friends != null && friends.contains(user)) {
			return "Unfriend";
		} else {
			return "Add friend";
		}
	}

	public void processUserRequest(UserImplementation user) {

		if (user == null) {
			user = viewUser;
		} else if (friends.contains(user)) {
			FacesContext.getCurrentInstance().addMessage(
					null,
					new FacesMessage(
							"Unfriend operation is not implemented yet"));// TODO
		} else {
			sendFriendRequest(user);
			friends.add(user);
			others.remove(user);
		}
	}

}
