package tr.cerealkillers.com.Controller;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.reflect.TypeToken;
import org.primefaces.json.JSONException;
import org.primefaces.json.JSONObject;
import org.primefaces.model.map.DefaultMapModel;
import tr.cerealkillers.com.Objects.EventImplementation;
import tr.cerealkillers.com.Objects.NewsfeedItem;
import tr.cerealkillers.com.Objects.UserImplementation;
import tr.cerealkillers.com.Util.ObjectJSONConverter;
import tr.cerealkillers.com.Util.WebServiceConnector;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import java.io.IOException;
import java.io.Serializable;
import java.util.List;

/**
 * Created with IntelliJ IDEA. User: MERT Date: 16.11.2013 Time: 07:16 To change
 * this template use File | Settings | File Templates.
 */

@ManagedBean(name = "loginController")
@SessionScoped
public class LoginController implements Serializable {
	private UserImplementation theUser;

	@ManagedProperty("#{mapBean}")
	private MapBean mapBean;

	public MapBean getMapBean() {
		return mapBean;
	}

	public void setMapBean(MapBean mapBean) {
		this.mapBean = mapBean;
	}

	public UserImplementation getTheUser() {
		return theUser;
	}

	public void setTheUser(UserImplementation theUser) {
		this.theUser = theUser;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getMessage() {
		return message;
	}

	public void setMessage(String message) {
		this.message = message;
	}

	private boolean login;
	public boolean getLogin() {
		if (theUser != null && theUser.getUserid() > 0) {
			return true;
		} else return false;
	}

	public void setLogin(boolean login) {
		this.login = login;
	}

	private String email;
	private String password;
	private String message;

	public String loginUser() {
		String json = WebServiceConnector.getInstance().connectGet(
				"/rest/login/" + email + "/" + password);
		try {
			JSONObject js = new JSONObject(json);
			if (js.has("message")) {
				String mess = js.getString("message");
				if (mess.startsWith("Password")) {
					message = "Password does not match";
				} else {

					message = "E-mail does not exist";
				}
			} else {
				message = "Login successful";
				theUser = ObjectJSONConverter.JsonToObject(json,
						UserImplementation.class);
				mapBean.getNearbyEvents(theUser.getUserid());
                initNewsfeed();
			}
		} catch (JSONException e) {
		}
		FacesContext context = FacesContext.getCurrentInstance();
		context.addMessage(null, new FacesMessage("Welcome", message));

		if (message.startsWith("Login")) {
			return "welcome";
		}
		return "index";
	}

    public boolean isMine(int id) {
        if (theUser == null) {
            return false;
        }
        int uid = theUser.getUserid();
        for (EventImplementation event : mapBean.getEvents()) {
            if (event.getEventID()== id && event.getOwnerIDs().contains(uid)) {
                return true;
            }
        }
        return false;
    }
	private String fbemail;
	private String fbid;
	private String gender;
	private String fbfname;
	private String fblname;
	private String fbbdate;
	private String fbcity;
	
	public String getFbcity() {
		return fbcity;
	}

	public void setFbcity(String fbcity) {
		this.fbcity = fbcity;
	}

	public String getFbemail() {
		return fbemail;
	}

	public void setFbemail(String fbemail) {
		this.fbemail = fbemail;
	}

	public String getFbid() {
		return fbid;
	}

	public void setFbid(String fbid) {
		this.fbid = fbid;
	}

	public String getGender() {
		return gender;
	}

	public void setGender(String gender) {
		this.gender = gender;
	}

	public String getFbfname() {
		return fbfname;
	}

	public void setFbfname(String fbfname) {
		this.fbfname = fbfname;
	}

	public String getFblname() {
		return fblname;
	}

	public void setFblname(String fblname) {
		this.fblname = fblname;
	}

	public String getFbbdate() {
		return fbbdate;
	}

	public void setFbbdate(String fbbdate) {
		this.fbbdate = fbbdate;
	}

	public String loginFB() {
		String json = WebServiceConnector.getInstance().connectGet(
				"/rest/login/" + fbemail + "/" + fbid + "/" + fbfname + "/" + fblname + "/" + gender + "/" + fbbdate + "/" + fbcity);
		try {
			JSONObject js = new JSONObject(json);
			if (js.has("message")) {
				String mess = js.getString("message");
				if (mess.startsWith("Password")) {
					message = "Password does not match";
				} else {

					message = "E-mail does not exist";
				}
			} else {
				message = "Login successful";
				theUser = ObjectJSONConverter.JsonToObject(json,
						UserImplementation.class);
				mapBean.getNearbyEvents(theUser.getUserid());
                initNewsfeed();
			}
		} catch (JSONException e) {
		}
		FacesContext context = FacesContext.getCurrentInstance();
		context.addMessage(null, new FacesMessage("Welcome", message));

		if (message.startsWith("Login")) {
			return "welcome";
		}
		return "index";
	}

	public String logout() {
		theUser = null;
		mapBean.setMapModel(new DefaultMapModel());
		FacesContext context = FacesContext.getCurrentInstance();
		context.addMessage(null, new FacesMessage("Welcome",
				"Logged-out succesfully"));
		FacesContext.getCurrentInstance().getExternalContext()
				.invalidateSession();
		return "index";
	}

	public String registerUser() {
		return "register";
	}

    public void checkLogin() {
        if (theUser == null)  {
            FacesContext
                    .getCurrentInstance()
                    .addMessage(
                            null,
                            new FacesMessage(
                                    "You are not authorized to view this page"));
            FacesContext.getCurrentInstance().getExternalContext()
                    .getFlash().setKeepMessages(true);
            FacesContext.getCurrentInstance().getExternalContext()
                    .getFlash().setRedirect(true);
            try {
                FacesContext.getCurrentInstance().getExternalContext()
                        .redirect("index.xhtml");
            } catch (IOException e) {
                e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
            }
        }
    }

    private List<NewsfeedItem> newsfeed = null;

    public List<NewsfeedItem> getNewsfeed() {
        return newsfeed;
    }

    public void setNewsfeed(List<NewsfeedItem> newsfeed) {
        this.newsfeed = newsfeed;
    }

    public void initNewsfeed() {
        String response = WebServiceConnector.getInstance().
                connectGet("/rest/newsfeed/getNewsfeed/" + theUser.getUserid());

        Gson gson = new GsonBuilder()
                .setDateFormat("dd-MM-yyyy HH:mm:ss").create();
        newsfeed = gson.fromJson(response,
                new TypeToken<List<NewsfeedItem>>() {
                }.getType());

        System.out.println("newsfeed size: "+ newsfeed.size());

    }
	
}
