package tr.cerealkillers.com.Controller;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.reflect.TypeToken;
import org.primefaces.event.map.OverlaySelectEvent;
import org.primefaces.model.map.DefaultMapModel;
import org.primefaces.model.map.LatLng;
import org.primefaces.model.map.MapModel;
import org.primefaces.model.map.Marker;
import tr.cerealkillers.com.Objects.EventImplementation;
import tr.cerealkillers.com.Objects.Location;
import tr.cerealkillers.com.Util.WebServiceConnector;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import java.io.Serializable;
import java.util.List;

@ManagedBean(name="mapBean")
@SessionScoped
public class MapBean implements Serializable {
	private MapModel mapModel;
	private double currentLat;
	private double currentLon;
	private Marker marker;
	private List<EventImplementation> events;
    private List<EventImplementation> usersEvents;
	private String val;

    public List<EventImplementation> getUsersEvents() {
        return usersEvents;
    }

    public void setUsersEvents(List<EventImplementation> usersEvents) {
        this.usersEvents = usersEvents;
    }

    public MapBean() {
		mapModel = new DefaultMapModel();
	}
	


	public String getVal() {
		return val;
	}

	public void setVal(String val) {
		this.val = val;
	}

	public void getNearbyEvents(int userid) {
		String response = WebServiceConnector.getInstance().connectGet(
				"/rest/event/getFriendsEventsInRadius/" + userid + "/39.897917/32.798861/100/15/01-01-2010/01-01-2020");
		Gson gson = new GsonBuilder()
		   .setDateFormat("dd-MM-yyyy HH:mm:ss").create();
		events = gson.fromJson(response,
				new TypeToken<List<EventImplementation>>() {
				}.getType());
        response = WebServiceConnector.getInstance().connectGet(
                "/rest/event/getEventsOfUser/" + userid);
        usersEvents = gson.fromJson(response,
                new TypeToken<List<EventImplementation>>() {
                }.getType());
		mapModel = new DefaultMapModel();
		for (EventImplementation event : events) {
			Location eventLocation = event.getLocation();
			LatLng coord = new LatLng(eventLocation.getLatitude(),
					eventLocation.getLongitude());
            Marker marker = new Marker(coord, event.getEvent_name(), event );
            marker.setIcon(WebServiceConnector.baseUri + "marker.png");
			mapModel.addOverlay(marker);
		}

        for (EventImplementation event : usersEvents) {
            Location eventLocation = event.getLocation();
            LatLng coord = new LatLng(eventLocation.getLatitude(),
                    eventLocation.getLongitude());
            Marker marker = new Marker(coord, event.getEvent_name(), event );
            marker.setIcon(WebServiceConnector.baseUri + "marker2.png");
            mapModel.addOverlay(marker);
        }

	}

	
	public void onMarkerSelect(OverlaySelectEvent event) {  
        marker = (Marker) event.getOverlay();   
    }  
	
	public List<EventImplementation> getEvents() {
		return events;
	}

	public void setEvents(List<EventImplementation> events) {
		this.events = events;
	}

	public double getCurrentLat() {
		return currentLat;
	}

	public void setCurrentLat(double currentLat) {
		this.currentLat = currentLat;
	}

	public double getCurrentLon() {
		return currentLon;
	}

	public void setCurrentLon(double currentLon) {
		this.currentLon = currentLon;
	}

	public MapModel getMapModel() {
		return mapModel;
	}
	public void setMapModel(MapModel mapModel) {
		this.mapModel = mapModel;
	}

	public Marker getMarker() {
		return marker;
	}

	public void setMarker(Marker marker) {
		this.marker = marker;
	}
}
