package tr.cerealkillers.com.Controller;

import org.primefaces.json.JSONException;
import org.primefaces.json.JSONObject;
import tr.cerealkillers.com.Util.WebServiceConnector;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.context.FacesContext;
import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: Baris
 * Date: 27.11.2013
 * Time: 18:02
 * To change this template use File | Settings | File Templates.
 */


@ManagedBean
@RequestScoped
public class RegisterController implements Serializable{
    private String e_mail;
    private String password;
    private String passwordCheck;
    private String first_name;
    private String last_name;
    private String gender = "unknown";
    private Date birth_day;
    private String city;
    private String message;
    

    public String getMessage() {
		return message;
	}

	public void setMessage(String message) {
		this.message = message;
	}

	public String getE_mail() {
        return e_mail;
    }

    public void setE_mail(String e_mail) {
        this.e_mail = e_mail;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getPasswordCheck() {
        return passwordCheck;
    }

    public void setPasswordCheck(String passwordCheck) {
        this.passwordCheck = passwordCheck;
    }

    public String getFirst_name() {
        return first_name;
    }

    public void setFirst_name(String first_name) {
        this.first_name = first_name;
    }

    public String getLast_name() {
        return last_name;
    }

    public void setLast_name(String last_name) {
        this.last_name = last_name;
    }

    public String getGender() {
        return gender;
    }

    public void setGender(String gender) {
        this.gender = gender;
    }

    public Date getBirth_day() {
        return birth_day;
    }

    public void setBirth_day(Date birth_day) {
        this.birth_day = birth_day;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public String registerUser() {
    	JSONObject jsonObject = new JSONObject();
        try {
        	SimpleDateFormat formatter = new SimpleDateFormat("dd-MM-yyyy");
    		jsonObject.put("first_name", first_name);
    		jsonObject.put("last_name", last_name);
    	    jsonObject.put("email", e_mail);
    	    jsonObject.put("password", password);
    	    jsonObject.put("city", city);
    	    jsonObject.put("date_of_birth", formatter.format(birth_day));
    	    jsonObject.put("gender", gender);
    	    String response = WebServiceConnector.getInstance().connectPost("/rest/register/", jsonObject);
    	    JSONObject json = new JSONObject(response);
    	    response = json.getString("message");
    	    if (response.equals("OK")) {
    	    	message = "Registered succesfully";
    	    } else {
    	    	message = "This e-mail has already registered";
    	    }
    	} catch (JSONException e) {
    		// TODO Auto-generated catch block
    		e.printStackTrace();
    	}
        FacesContext context = FacesContext.getCurrentInstance();  
        context.addMessage(null, new FacesMessage("Welcome", message)); 
    	if (message.startsWith("Re")) {
    		return "index";
    	} else {
    		return "register";
    	}
    }
    
    public List<String> complete(String query) {
    	List<String> cities = new ArrayList<String>();
    	cities.add("Ankara");
    	cities.add("İstanbul");
    	cities.add("İzmir");
    	List<String> results = new ArrayList<String>();  
        for (String city : cities) {
        	if (city.startsWith(query)) {
        		results.add(city);
        	}
        }
        return results;  
    }

}
