package tr.cerealkillers.com.Controller;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.reflect.TypeToken;
import org.primefaces.event.map.OverlaySelectEvent;
import org.primefaces.json.JSONArray;
import org.primefaces.json.JSONException;
import org.primefaces.json.JSONObject;
import org.primefaces.model.map.DefaultMapModel;
import org.primefaces.model.map.LatLng;
import org.primefaces.model.map.MapModel;
import org.primefaces.model.map.Marker;
import tr.cerealkillers.com.Objects.*;
import tr.cerealkillers.com.Util.WebServiceConnector;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import java.io.IOException;
import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@ManagedBean(name = "viewEventController")
@SessionScoped
public class ViewEventController implements Serializable {
	@ManagedProperty("#{mapBean}")
	private MapBean mapBean;
	private List<GoogleLocation> results;
	private MapModel map;

    public boolean getCanEdit() {
        return canEdit;
    }

    public void setCanEdit(boolean canEdit) {
        this.canEdit = canEdit;
    }

    private boolean canEdit = false;
	private double eventLat;
	private double eventLon;
    private int resultIndex = -1;
    private int eventIndex  = -1;

    public MapModel getMap() {
		return map;
	}

	public void setMap(MapModel map) {
		this.map = map;
	}

	private Marker marker;
	
	public Marker getMarker() {
		return marker;
	}

	public void setMarker(Marker marker) {
		this.marker = marker;
	}

	public MapBean getMapBean() {
		return mapBean;
	}

	public void setMapBean(MapBean mapBean) {
		this.mapBean = mapBean;
	}

	@ManagedProperty(value = "#{loginController}")
	private LoginController loginController;

	public void setLoginController(LoginController loginController) {
		this.loginController = loginController;
	}
	private double firstLat;
	private double firstLng;
	private int selectedEventId;
	private EventImplementation theEvent;
	private MapModel mapModel = new DefaultMapModel();
	private boolean state = false;

    private int location_id;
    private String eventName;
    private String eventDescription;
    private String eventAddress;
    private String eventType;
    private int isPrivate;
	private Date start_date;
	private Date end_date;
    private List<UserImplementation> joiners;
    private List<CommentViewModel> comments;
    private String newComment;
    private int commentIndex = -1;
    private Integer rating;
    private int rating2;
    private int rating3;

    public int getRating3() {
        return rating3;
    }

    public void setRating3(int rating3) {
        this.rating3 = rating3;
    }

    public int getRating2() {
        return rating2;
    }

    public void setRating2(int rating2) {
        this.rating2 = rating2;
    }

    public Integer getRating() {
        return rating;
    }

    public void setRating(Integer rating) {
        this.rating = rating;
    }

    public String getNewComment() {
        return newComment;
    }

    public void setNewComment(String newComment) {
        this.newComment = newComment;
    }

    public List<CommentViewModel> getComments() {
        return comments;
    }

    public void setComments(List<CommentViewModel> comments) {
        this.comments = comments;
    }

    public List<UserImplementation> getJoiners() {
        return joiners;
    }

    public void setJoiners(List<UserImplementation> joiners) {
        this.joiners = joiners;
    }

    public Date getStart_date() {
		return start_date;
	}

    public String getEventDescription() {
        return eventDescription;
    }

    public void setEventDescription(String eventDescription) {
        this.eventDescription = eventDescription;
    }

    public String getEventAddress() {
        return eventAddress;
    }

    public void setEventAddress(String eventAddress) {
        this.eventAddress = eventAddress;
    }

    public String getEventType() {
        return eventType;
    }

    public void setEventType(String eventType) {
        this.eventType = eventType;
    }

    public int getIsPrivate() {
        return isPrivate;
    }

    public void setIsPrivate(int isPrivate) {
        this.isPrivate = isPrivate;
    }

    public String getEventName() {
        return eventName;
    }

    public void setEventName(String eventName) {
        this.eventName = eventName;
    }

    public void setStart_date(Date start_date) {
		this.start_date = start_date;
	}

	public Date getEnd_date() {
		return end_date;
	}

	public void setEnd_date(Date end_date) {
		this.end_date = end_date;
	}

	public boolean isState() {
		return state;
	}

	public void setState(boolean state) {
		this.state = state;
	}

	public MapModel getMapModel() {
		return mapModel;
	}

	public void setMapModel(MapModel mapModel) {
		this.mapModel = mapModel;
	}

	public EventImplementation getTheEvent() {
		return theEvent;
	}

	public void setTheEvent(EventImplementation theEvent) {
		this.theEvent = theEvent;
	}

	public int getSelectedEventId() {
		return selectedEventId;
	}

	public void setSelectedEventId(int selectedEventId) {
		this.selectedEventId = selectedEventId;
        newComment = "";
        if (theEvent != null && theEvent.getEventID() == selectedEventId) return;
        theEvent = null;
        theEventId = selectedEventId;
		List<EventImplementation> list = mapBean.getEvents();
        int uid = -1;
        canEdit = false;
        if (loginController != null) {
            UserImplementation user = loginController.getTheUser();
            if (user != null) {
                uid = user.getUserid();
            }
        }
		if (list != null && list.size() > 0) {
			for (EventImplementation event : list) {
				if (event.getEventID() == selectedEventId) {
					theEvent = event;
					mapModel = new DefaultMapModel();
					LatLng coor = new LatLng(event.getLocation().getLatitude(),
							event.getLocation().getLongitude());
                    Marker marker = new Marker(coor);
                    marker.setIcon(WebServiceConnector.baseUri + "marker.png");
					mapModel.addOverlay(marker);
                    location_id = theEvent.getLocation().getLocation_id();
                    eventName = theEvent.getEvent_name();
                    eventDescription = theEvent.getEvent_description();
                    eventAddress = theEvent.getLocation().getFormatted_address();
                    eventType = theEvent.getEvent_type();
                    isPrivate = theEvent.getIsPrivate();
					start_date = theEvent.getStart_date();
					end_date = theEvent.getEnd_date();
					eventLat = theEvent.getLocation().getLatitude();
					eventLon = theEvent.getLocation().getLongitude();
                    if (uid > -1) {
                        if (theEvent.getOwnerIDs().contains(uid)) {
                            canEdit = true;
                        }
                    }
					break;
				}
			}
		}
        List<EventImplementation> userList = mapBean.getUsersEvents();
        if (userList != null && theEvent == null) {
            for (EventImplementation event : userList) {
                if (event.getEventID() == selectedEventId) {
                    theEvent = event;
                    mapModel = new DefaultMapModel();
                    LatLng coor = new LatLng(event.getLocation().getLatitude(),
                            event.getLocation().getLongitude());
                    Marker marker = new Marker(coor);
                    marker.setIcon(WebServiceConnector.baseUri + "marker.png");
                    mapModel.addOverlay(marker);
                    location_id = theEvent.getLocation().getLocation_id();
                    eventName = theEvent.getEvent_name();
                    eventDescription = theEvent.getEvent_description();
                    eventAddress = theEvent.getLocation().getFormatted_address();
                    eventType = theEvent.getEvent_type();
                    isPrivate = theEvent.getIsPrivate();
                    start_date = theEvent.getStart_date();
                    end_date = theEvent.getEnd_date();
                    eventLat = theEvent.getLocation().getLatitude();
                    eventLon = theEvent.getLocation().getLongitude();
                    if (uid > -1) {
                        if (theEvent.getOwnerIDs().contains(uid)) {
                            canEdit = true;
                        }
                    }
                    break;
                }
            }
        }
        if (theEvent == null) {
            String json = WebServiceConnector.getInstance().connectGet(
                    "/rest/event/getEvent/" + uid + "/" + selectedEventId);
            try {
                JSONObject js = new JSONObject(json);
                if (js.has("message")) {
                    try {
                        FacesContext
                                .getCurrentInstance()
                                .addMessage(
                                        null,
                                        new FacesMessage(
                                                "You are not authorized to view this event"));
                        FacesContext.getCurrentInstance().getExternalContext()
                                .getFlash().setKeepMessages(true);
                        FacesContext.getCurrentInstance().getExternalContext()
                                .getFlash().setRedirect(true);
                        FacesContext.getCurrentInstance().getExternalContext()
                                .redirect("welcome.xhtml");
                    } catch (IOException e) {
                    }
                } else {
                    Gson gson = new GsonBuilder().setDateFormat("dd-MM-yyyy HH:mm:ss")
                            .create();
                    theEvent = gson.fromJson(json,
                            new TypeToken<EventImplementation>() {
                            }.getType());
                    mapModel = new DefaultMapModel();
                    LatLng coor = new LatLng(theEvent.getLocation().getLatitude(),
                            theEvent.getLocation().getLongitude());
                    Marker marker = new Marker(coor);
                    marker.setIcon(WebServiceConnector.baseUri + "marker.png");
                    mapModel.addOverlay(marker);
                    location_id = theEvent.getLocation().getLocation_id();
                    eventName = theEvent.getEvent_name();
                    eventDescription = theEvent.getEvent_description();
                    eventAddress = theEvent.getLocation().getFormatted_address();
                    eventType = theEvent.getEvent_type();
                    isPrivate = theEvent.getIsPrivate();
                    start_date = theEvent.getStart_date();
                    end_date = theEvent.getEnd_date();
                    eventLat = theEvent.getLocation().getLatitude();
                    eventLon = theEvent.getLocation().getLongitude();
                    if (uid > -1) {
                        if (theEvent.getOwnerIDs().contains(uid)) {
                            canEdit = true;
                        }
                    }

                }
            } catch (JSONException e) {
            }
        }
		if (theEvent != null) {
            if (uid > -1) {
                if (theEvent.getAccessIDs().contains(uid)) {
                    canEdit = true;
                }
            }
			start_date = theEvent.getStart_date();
			end_date = theEvent.getEnd_date();
            String  response = WebServiceConnector.getInstance().connectGet(
                    "/rest/event/getRating/" + theEventId);
            JSONObject rateJson = null;
            try {
                rateJson = new JSONObject(response);
                rating2 = 0;
                if (rateJson.has("event_id")) {
                    rating3 = (int) rateJson.getDouble("rate");
                    rating2 = (int) rateJson.getDouble("rate");
                }
            } catch (JSONException e) {
            }

            response = WebServiceConnector.getInstance().connectGet(
                    "/rest/event/getJoiners/" + theEventId);
            Gson gson = new GsonBuilder()
                    .setDateFormat("dd-MM-yyyy HH:mm:ss").create();
            joiners = gson.fromJson(response,
                    new TypeToken<List<UserImplementation>>() {
                    }.getType());
            joinButton = "Join";
            for (UserImplementation user : joiners) {
                if (user.getUserid() == uid) {
                    joinButton = "Leave";
                    break;
                }
            }
            initComments();

		}

	}

	private int theEventId;

	public int getTheEventId() {
		return theEventId;
	}

	public void setTheEventId(int theEventId) {
		this.theEventId = theEventId;
	}

	public String gotoevent() {
		return "viewEvent.xhtml?id=" + theEventId;
	}

	public void changeState() {
		state = !state;
	}
	private String message;
	public void saveChanges() {
		String message = "";
		SimpleDateFormat formatter = new SimpleDateFormat("dd-MM-yyyy HH:mm:ss");
		JSONObject jsonObject = new JSONObject();
		try {
			jsonObject.put("event_id", theEvent.getEventID());
			jsonObject.put("event_type", eventType);
			jsonObject.put("event_name", eventName);
			jsonObject.put("event_description", eventDescription);
            if (resultIndex > -1) {
                JSONObject jsonObjectLoc = new JSONObject();
                GoogleLocation gol = results.get(resultIndex);
                jsonObjectLoc.put("latitude", gol.getLat());
                jsonObjectLoc.put("longitude", gol.getLon());
                jsonObjectLoc.put("name", gol.getName());
                jsonObjectLoc.put("formatted_address", gol.getFormattedAddress());
                jsonObjectLoc.put("secondary_id", gol.getGoogleId());
                String response = WebServiceConnector.getInstance().connectPost(
                        "/rest/location/addLocation/", jsonObjectLoc);
                JSONObject resJson = new JSONObject(response);
                location_id = resJson.getInt("id");
            }
			jsonObject.put("location_id", location_id);
			jsonObject.put("start_time", formatter.format(start_date));
			jsonObject.put("end_time", formatter.format(end_date));
			jsonObject.put("isPrivate", isPrivate);
			String response = WebServiceConnector.getInstance().connectPost(
					"/rest/event/updateEvent/", jsonObject);
			JSONObject json = new JSONObject(response);
			response = json.getString("message");
			if (response.equals("Event Updated")) {
                theEvent.setEvent_type(eventType);
                theEvent.setEvent_name(eventName);
                theEvent.setIsPrivate(isPrivate);
                theEvent.setEvent_description(eventDescription);
                theEvent.setEnd_date(new java.sql.Date(end_date.getTime()));
                theEvent.setStart_date(new java.sql.Date(start_date.getTime()));
                if (resultIndex > -1) {
                    GoogleLocation gol = results.get(resultIndex);
                    theEvent.setLocation(new LocationImplementation(gol.getName(),gol.getFormattedAddress(),
                            gol.getGoogleId(),gol.getLat(),gol.getLon(),location_id));
                }

                mapModel = new DefaultMapModel();
                LatLng coor = new LatLng(theEvent.getLocation().getLatitude(),
                        theEvent.getLocation().getLongitude());
                Marker marker = new Marker(coor);
                marker.setIcon("/marker.png");
                mapModel.addOverlay(marker);
				message = "Event updated succesfully";
			} else {
				message = "Event update failed";
			}
		} catch (JSONException e) {
		}
		FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(message));
		state = !state;
	}
	
	public void findLocation() {
		String result = WebServiceConnector.getInstance().connectGet(
				"rest/location/searchLocation/" + eventAddress);
		try {
			JSONObject jsonAddress = new JSONObject(result);

			if (jsonAddress.getString("status").equals("OK")) {
				map = new DefaultMapModel();
				results = new ArrayList<GoogleLocation>();
				JSONArray jarray = jsonAddress.getJSONArray("results");
				for (int i = 0; i < jarray.length(); i++) {
					JSONObject details = jarray.getJSONObject(i);
					String addr = details.getString("formatted_address");
					String name = details.getString("name");
					String googleId = "";
					double lat = 0;
					double lng = 0;
                    int id = 0;
					if (details.has("geometry")) {
						JSONObject location = details.getJSONObject("geometry")
								.getJSONObject("location");
						lat = location.getDouble("lat");
						lng = location.getDouble("lng");
						googleId = details.getString("id");
					} else {
						googleId = details.getString("secondary_id");
                        id = details.getInt("location_id");
						lat = details.getDouble("latitude");
						lng = details.getDouble("longitude");
					}
					results.add(new GoogleLocation(id, name, addr, lat, lng,
                            googleId));
                    Marker newMarker = new Marker(new LatLng(lat, lng), addr);
                    newMarker.setIcon("/marker.png");
					map.addOverlay(newMarker);
					if (i == 0) {
						setFirstLat(lat);
						setFirstLng(lng);
					}

				}
				return;
			} else {
				message = "Cannot find the address: " + theEvent.getLocation().getFormatted_address();
				FacesContext context = FacesContext.getCurrentInstance();
				context.addMessage(null, new FacesMessage(message));
				return;
			}

		} catch (JSONException e) {
			e.printStackTrace();
		}
		FacesContext context = FacesContext.getCurrentInstance();
		context.addMessage(null, new FacesMessage(
				"An error occured that we couldn't figure out why"));
	}

	public double getFirstLat() {
		return firstLat;
	}

	public void setFirstLat(double firstLat) {
		this.firstLat = firstLat;
	}

	public double getFirstLng() {
		return firstLng;
	}

	public void setFirstLng(double firstLng) {
		this.firstLng = firstLng;
	}
	
	public void onMarkerSelect(OverlaySelectEvent event) {
		marker = (Marker) event.getOverlay();
        String markerId = marker.getId();
        resultIndex = 0;
        for (Marker m :map.getMarkers()) {
            if (m.getId().equals(markerId)) {
                break;
            }
            resultIndex++;
        }
        if (results.size() > resultIndex) {
            eventAddress = results.get(resultIndex).getFormattedAddress();
		    FacesContext.getCurrentInstance().addMessage(null,
			    	new FacesMessage("Address selected: " + marker.getTitle()));

        }
	}

	public double getEventLat() {
		return eventLat;
	}

	public void setEventLat(double eventLat) {
		this.eventLat = eventLat;
	}

	public double getEventLon() {
		return eventLon;
	}

	public void setEventLon(double eventLon) {
		this.eventLon = eventLon;
	}

    private String joinButton = "Join";

    public String getJoinButton() {
        return joinButton;
    }

    public void setJoinButton(String joinButton) {
        this.joinButton = joinButton;
    }

    public void joinOrLeave() {
        if (joinButton.equals("Join")) {
            joinEvent();
        } else {
            leaveEvent();
        }
    }

    public void joinEvent() {
        int uid = -1;
        if (loginController.getTheUser() != null) {
            uid = loginController.getTheUser().getUserid();
        }
        if (uid == -1) {
            message = "You need to login to join this event.";
        }
        else {
            JSONObject json = new JSONObject();
            try {
                json.put("user_id", uid);
                json.put("event_id", theEventId);
                String response = WebServiceConnector.getInstance().connectPost("/rest/event/joinEvent", json);
                JSONObject jsonResponse = new JSONObject(response);
                if (jsonResponse.has("message")) {
                    message = jsonResponse.getString("message");
                    joinButton = "Leave";
                    joiners.add(loginController.getTheUser());
                } else {
                    message = "Join operation is unsuccessful";
                }
            } catch (JSONException e) {
                e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
            }
        }
        FacesContext.getCurrentInstance().addMessage(null,
                new FacesMessage(message));

    }

    public void leaveEvent() {
        int uid = -1;
        if (loginController.getTheUser() != null) {
            uid = loginController.getTheUser().getUserid();
        }
        if (uid == -1) {
            message = "You need to login to leave this event.";
        }
        else {
            JSONObject json = new JSONObject();
            try {
                json.put("user_id", uid);
                json.put("event_id", theEventId);
                String response = WebServiceConnector.getInstance().connectPost("/rest/event/deleteEvent", json);
                JSONObject jsonResponse = new JSONObject(response);
                if (jsonResponse.has("message")) {
                    message = "Leave operation is successful";
                    joinButton = "Join";
                    for (UserImplementation user : joiners) {
                        if (user.getUserid() == uid) {
                            joiners.remove(user);
                            break;
                        }
                    }
                } else {
                    message = "Leave operation is unsuccessful";
                }
            } catch (JSONException e) {
                e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
            }
        }
        FacesContext.getCurrentInstance().addMessage(null,
                new FacesMessage(message));

    }

    public void initComments() {
        commentIndex = -1;
        String response = WebServiceConnector.getInstance().connectGet("/rest/event/getComments/" + theEventId);
        try {
            JSONArray jsonArray = new JSONArray(response);
            int size = jsonArray.length();
            comments = new ArrayList<CommentViewModel>();
            Gson gson = new GsonBuilder()
                    .setDateFormat("dd-MM-yyyy HH:mm:ss").create();
            int uid = -1;
            if (loginController != null) {
                uid = loginController.getTheUser().getUserid();
            }
            for (int i=0; i<size; i+=2) {
                CommentViewModel comment = new CommentViewModel();
                UserImplementation user = gson.fromJson(jsonArray.getJSONObject(i).toString(), UserImplementation.class);
                comment.setUser(user);
                comment.setComment(jsonArray.get(i+1).toString());
                comments.add(comment);
                if (user.getUserid() == uid) {
                    comment.setAbleToEdit(true);
                    commentIndex = i/2;
                } else {
                    comment.setAbleToEdit(false);
                }
            }
        } catch (JSONException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
    }

    public void addOrEditComment() {
        if (commentIndex > -1) {
            CommentViewModel theComment = comments.get(commentIndex);
            JSONObject json = new JSONObject();
            try {
                json.put("event_id", theEventId);
                json.put("user_id", theComment.getUser().getUserid());
                json.put("oldcomment", theComment.getComment());
                json.put("newcomment", newComment);
            } catch (JSONException e) {
                e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
            }

            String response = WebServiceConnector.getInstance().connectPost("/rest/event/updateComment/", json);
            try {
                JSONObject jsonResponse = new JSONObject(response);
                if (jsonResponse.has("message")) {
                    message = jsonResponse.getString("message");
                    theComment.setComment(newComment);
                } else {
                    message = "Comment couldn't be updated";
                }
            } catch (JSONException e) {
                e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
            }
        }
        else {
            JSONObject json = new JSONObject();
            int uid = -1;
            if (loginController.getTheUser() == null) {
                message = "You need to login before commenting on Event";
            } else {
                uid = loginController.getTheUser().getUserid();
            }
            try {
                json.put("event_id", theEventId);
                json.put("user_id", uid);
                json.put("comment", newComment);
            } catch (JSONException e) {
                e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
            }
            if (uid > -1) {
                String response = WebServiceConnector.getInstance().connectPost("/rest/event/commentOnEvent/", json);
                try {
                    JSONObject jsonResponse = new JSONObject(response);
                    if (jsonResponse.has("message")) {
                        message = jsonResponse.getString("message");
                        CommentViewModel theComment = new CommentViewModel();
                        theComment.setUser(loginController.getTheUser());
                        theComment.setAbleToEdit(true);
                        theComment.setComment(newComment);
                        commentIndex = comments.size();
                        comments.add(theComment);
                    } else {
                        message = "Comment couldn't be deleted";
                    }
                } catch (JSONException e) {
                    e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
                }
            }
        }
        FacesContext.getCurrentInstance().addMessage(null,
                new FacesMessage(message));
    }

    public void deleteComment(CommentViewModel theComment) {
        JSONObject json = new JSONObject();
        try {
            json.put("event_id", theEventId);
            json.put("user_id", theComment.getUser().getUserid());
            json.put("comment", theComment.getComment());
        } catch (JSONException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }

        String response = WebServiceConnector.getInstance().connectPost("/rest/event/deleteComment/", json);
        try {
            JSONObject jsonResponse = new JSONObject(response);
            if (jsonResponse.has("message")) {
                message = jsonResponse.getString("message");
                comments.remove(theComment);
                commentIndex = -1;
            } else {
                message = "Comment couldn't be deleted";
            }
        } catch (JSONException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
        FacesContext.getCurrentInstance().addMessage(null,
                new FacesMessage(message));
    }

    public void shareEvent() {
        int uid = -1;
        if (loginController.getTheUser() != null) {
            uid = loginController.getTheUser().getUserid();
        }
        if (uid > 0) {
            JSONObject json = new JSONObject();
            try {
                json.put("event_id", theEventId);
                json.put("user_id", uid);
            } catch (JSONException e) {
                e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
            }

            String response = WebServiceConnector.getInstance().connectPost("/rest/event/shareEvent/", json);
            try {
                JSONObject jsonResponse = new JSONObject(response);
                if (jsonResponse.has("message")) {
                    message = jsonResponse.getString("message");
                } else {
                    message = "Error saving this operation.";
                }
            } catch (JSONException e) {
                e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
            }
        }
        FacesContext.getCurrentInstance().addMessage(null,
                new FacesMessage("Event shared"));
    }

    public void submitRating() {
        int uid = -1;
        if (loginController.getTheUser() != null) {
            uid = loginController.getTheUser().getUserid();
        }
        if (uid < 0) {
            FacesContext.getCurrentInstance().addMessage(null,
                    new FacesMessage("You need to login first!"));
            return;
        }

        JSONObject json = new JSONObject();
        try {
            json.put("event_id", theEventId);
            json.put("user_id", uid);
            json.put("rating", rating2);
        } catch (JSONException e) {
        }

        String response = WebServiceConnector.getInstance().connectPost("/rest/event/rateEvent/", json);

        try {
            JSONObject jsonResponse = new JSONObject(response);
            if (jsonResponse.has("message")) {
                rating3 = (int)Math.round(jsonResponse.getDouble("currentRate:"));
                FacesContext.getCurrentInstance().addMessage(null,
                        new FacesMessage("You've rated:" + rating2));
            } else {
            }
        } catch (JSONException e) {
            e.printStackTrace();
        }
    }

}
