package tr.cerealkillers.com.Objects;

import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: MERT
 * Date: 10.11.2013
 * Time: 10:24
 * To change this template use File | Settings | File Templates.
 */
public interface Event {
    /**
     * This method adds user to the Event.
     * This method will be called when a user entered an event.
     * @param user the user that is gonna join the event
     * @return True, if the add operation is successful
     */
    public boolean addAttendee(User user);

    /**
     * TODO How it's gonna work out?
     * This method will trigger the share event on the server
     * @param user the event is shared with this param.
     * @return True, if the operation is successful
     */
    public boolean shareEvent(User user);

    /**
     * This method adds an owner to the Event.
     * @param user The privileged user
     * @return True, if the add operation is successful
     */
    public boolean addOwner(User user);

    /**
     * Get Method of the owners attribute of the Event
     * @return The owner users as {@link List}
     */
    public List<User> getOwners();

    /**
     * Get method of the Location attribute of the Event.
     * @return The location of the Event as a {@link Location} object
     */
    public Location getLocation();

    /**
     * Set method of the Location attribute of the Event
     * @param location The new location of the Event
     * @return True, if the set operation is successful
     */
    public boolean setLocation(Location location);

    /**
     * Get method of the Id attribute of the Event
     * @return the Id as an integer.
     */
    public int getId();

    /**
     * Set method of the Id attribute of the Event
     * @return True, if the set operation is successful
     */
    public boolean setId(int newId);


    /**
     * Get method of the Description attribute of the Event
     * @return the description as a {@link String]
     */
    public String getDescription();


    /**
     * Set method of the Description attribute of the Event
     * @param newDescription
     * @return True, if the set operation is successful
     */
    public boolean setDescription(String newDescription);

    boolean setLocation(LocationImplementation location);

    /**
     * The enum for the privacy setting for an event
     */
    public enum Privacy { Public, Private, Custom };

    /**
     * Gets the privacy setting of the event.
     * @return the privacy setting as a {@link Privacy} enum
     */
    public Privacy getPrivacy();

    /**
     * Set method of the privacy attribute of the Event
     * @param privacy
     * @return True, if the set operation is true.
     */
    public boolean setPrivacy(Privacy privacy);


}
