package tr.cerealkillers.com.Objects;

import java.sql.Date;
import java.util.ArrayList;
import java.util.List;

public class EventImplementation implements Event {


	private ArrayList<Integer> ownerIDs = new ArrayList<Integer>();
	private ArrayList<String>  ownerNames = new ArrayList<String>();
	private ArrayList<Integer>  accessIDs = new ArrayList<Integer>();
    private int event_id;	
    private int isPrivate;		// 0 for public , 1 for private
    private String event_name;
    private String event_type;
    private String event_description;
    private java.sql.Date start_date;
    private java.sql.Date end_date;
    private LocationImplementation location;
    private double distance;
    private double rating;
    
    public EventImplementation() {};
    
    public EventImplementation( ArrayList<Integer> ownerIDs , ArrayList<String> ownerNames , int event_id 
    		, String event_name , String event_type 
    		, String event_description , java.sql.Date start_date , java.sql.Date end_date
    		, int location_id , String location_name  , String location_f_address , String location_s_id
    		, double lat , double lng , int isPrivate ) {

    	
    	this.ownerIDs = ownerIDs;
    	this.ownerNames = ownerNames;
    	this.event_id = event_id;    	
    	this.event_name = event_name;
    	this.event_type = event_type;
    	this.event_description = event_description;
    	this.start_date = start_date;
    	this.end_date = end_date;
    	this.location = new LocationImplementation(location_name, location_f_address
    			, location_s_id , lat, lng, location_id);   	
    	this.setIsPrivate(isPrivate);
    	this.rating = 0;
    	
    }
	
    public EventImplementation( ArrayList<Integer> ownerIDs , ArrayList<String> ownerNames , int event_id 
    		, String event_name , String event_type 
    		, String event_description , Date start_date , Date end_date
    		, int location_id , String location_name  , String location_f_address , String location_s_id
    		, double lat , double lng , double distance , int isPrivate ) {

    	this.ownerIDs = ownerIDs;
    	this.ownerNames = ownerNames;
    	this.event_id = event_id;    	
    	this.event_name = event_name;
    	this.event_type = event_type;
    	this.event_description = event_description;
    	this.start_date = start_date;
    	this.end_date = end_date;
    	this.location = new LocationImplementation(location_name, location_f_address
    			, location_s_id , lat, lng, location_id);   	
    	this.distance = distance;  	
    	this.setIsPrivate(isPrivate);
    	this.rating = 0;
    }
    
    public void addOwner( int id , String name ) {
    	
    	ownerIDs.add(id);
    	ownerNames.add(name);
    }
    
    public int getEventID() {    	
    	return event_id;
    }
    
    
	@Override
	public boolean addAttendee(User user) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean shareEvent(User user) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean addOwner(User user) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public List<User> getOwners() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public LocationImplementation getLocation() {
		return location;
	}

    /**
     * Set method of the Location attribute of the Event
     *
     * @param location The new location of the Event
     * @return True, if the set operation is successful
     */
    @Override
    public boolean setLocation(Location location) {
        return false;  //To change body of implemented methods use File | Settings | File Templates.
    }

    @Override
	public boolean setLocation(LocationImplementation location) {
		this.location = location;
		return false;
	}

	@Override
	public int getId() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public boolean setId(int newId) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public String getDescription() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public boolean setDescription(String newDescription) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public Privacy getPrivacy() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public boolean setPrivacy(Privacy privacy) {
		// TODO Auto-generated method stub
		return false;
	}

	public String getEvent_name() {
		return event_name;
	}

	public void setEvent_name(String event_name) {
		this.event_name = event_name;
	}

	public String getEvent_description() {
		return event_description;
	}

	public void setEvent_description(String event_description) {
		this.event_description = event_description;
	}

	public String getEvent_type() {
		return event_type;
	}

	public void setEvent_type(String event_type) {
		this.event_type = event_type;
	}

	public Date getStart_date() {
		return start_date;
	}

	public void setStart_date(Date start_date) {
		this.start_date = start_date;
	}

	public Date getEnd_date() {
		return end_date;
	}

	public void setEnd_date(Date end_date) {
		this.end_date = end_date;
	}

	public ArrayList<Integer> getOwnerIDs() {
		return ownerIDs;
	}

	public void setOwnerIDs(ArrayList<Integer> ownerIDs) {
		this.ownerIDs = ownerIDs;
	}

	public ArrayList<Integer> getAccessIDs() {
		return accessIDs;
	}

	public void setAccessIDs(ArrayList<Integer> accessIDs) {
		this.accessIDs = accessIDs;
	}

	public int getIsPrivate() {
		return isPrivate;
	}

	public void setIsPrivate(int isPrivate) {
		this.isPrivate = isPrivate;
	}

	public double getRating() {
		return rating;
	}

	public void setRating(double rating1) {
		
		if( rating1 > 10 )
			rating1 = 10;
		if( rating1 < 0  )
			rating1 = 0;
		
		this.rating = rating1;
	}

}
