package tr.cerealkillers.com.Objects;

import com.mysql.jdbc.Statement;
import tr.cerealkillers.com.Util.DatabaseHandler;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

/**
 * Created with Eclipse. User: CAGIN Date: 12.12.2013 Time: 22:24
 */

public class EventOperations {
	// TODO javadocs for this class

	public EventOperations() {
	}

	public static boolean createEvent(int userID, String eventType,
			String eventName, String eventDescription, java.sql.Date startTime,
			java.sql.Date endTime, int locationID, double latitude,
			double longitude, String name, String formatted_address,
			String s_id, int isPrivate) {

		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			if (locationID == 0) { // new location , add it to database

				String query_loc = "insert into Location ( latitude , longitude , name , formatted_address , secondary_id )"
						+ " values( ? , ? , ? , ? , ? );";

				PreparedStatement prepStmtLoc = db.getConnection()
						.prepareStatement(query_loc,
								Statement.RETURN_GENERATED_KEYS);

				prepStmtLoc.setDouble(1, latitude);
				prepStmtLoc.setDouble(2, longitude);
				prepStmtLoc.setString(3, name);
				prepStmtLoc.setString(4, formatted_address);
				prepStmtLoc.setString(5, s_id);
				prepStmtLoc.executeUpdate();

				ResultSet rs = prepStmtLoc.getGeneratedKeys();

				if (rs.next()) {
					locationID = rs.getInt(1);
				}
			}

			int last_inserted_id = 0;

			String query = "insert into Event ( type , name , description , location_id"
					+ " , start_time , end_time , isPrivate ) values( ? , ? , ? , ? , ? , ? , ? );";

			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query, Statement.RETURN_GENERATED_KEYS);
			prepStmt.setString(1, eventType);
			prepStmt.setString(2, eventName);
			prepStmt.setString(3, eventDescription);
			prepStmt.setInt(4, locationID);
			prepStmt.setDate(5, startTime);
			prepStmt.setDate(6, endTime);
			prepStmt.setInt(7, isPrivate);
			prepStmt.executeUpdate();
			
			

			ResultSet rs = prepStmt.getGeneratedKeys();

			if (rs.next()) {
				last_inserted_id = rs.getInt(1);
			}

			String query2 = "insert into CreateEvent ( user_id , event_id ) values( ? , ? );";

			PreparedStatement prepStmt2 = db.getConnection().prepareStatement(
					query2);
			prepStmt2.setInt(1, userID);
			prepStmt2.setInt(2, last_inserted_id);
			prepStmt2.executeUpdate();

			String query3 = "insert into EventAccess ( event_id , user_id ) values( ? , ? );";

			PreparedStatement prepStmt3 = db.getConnection().prepareStatement(
					query3);
			prepStmt3.setInt(1, last_inserted_id);
			prepStmt3.setInt(2, userID);
			prepStmt3.executeUpdate();
			

			if( isPrivate==0 ) {
				String query22 = "insert into Newsfeed ( user_id , user_id2 ,  event_id , operation , server_time ) values ( ? , 10000 , ? , ? , NOw());";
	
				PreparedStatement prepStmt22 = db.getConnection().prepareStatement(query22);
				prepStmt22.setInt(1, userID);
				prepStmt22.setInt(2, last_inserted_id);
				prepStmt22.setString(3, "create");
				prepStmt22.executeUpdate();	
			}

			return true;

		} catch (SQLException e) {
			e.printStackTrace();
			// todo SQL exception kodlarina gore yap
			// todo exception class lari olusturulacak

			// String detailedMessage = e.getMessage();
		}

		return false;
	}

	public static boolean updateEvent(int eventID, String eventType,
			String eventName, String eventDescription, java.sql.Date startTime,
			java.sql.Date endTime, int locationID, int isPrivate) {

		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			String query = "select e.event_id , e.type , e.name AS ename , e.description , e.start_time , e.end_time , e.isPrivate , l.location_id "
					+ ", l.name AS lname, l.formatted_address , l.secondary_id , l.latitude , l.longitude , e.isPrivate "
					+ " from Event e, Location l where e.event_id = ? and e.location_id = l.location_id;";

			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query);
			prepStmt.setInt(1, eventID);
			ResultSet rs = prepStmt.executeQuery();

			while (rs.next()) {

				ArrayList<Integer> al = new ArrayList<Integer>();
				ArrayList<String> al2 = new ArrayList<String>();

				EventImplementation event = new EventImplementation(al, al2,
						rs.getInt("event_id"), rs.getString("ename"),
						rs.getString("type"), rs.getString("description"),
						rs.getDate("start_time"), rs.getDate("end_time"),
						rs.getInt("location_id"), rs.getString("lname"),
						rs.getString("formatted_address"),
						rs.getString("secondary_id"), rs.getDouble("latitude"),
						rs.getDouble("longitude"), rs.getInt("isPrivate"));

				if (eventType == null || eventType.isEmpty()) {

					eventType = event.getEvent_type();
				}

				if (eventName == null || eventName.isEmpty()) {

					eventName = event.getEvent_name();
				}

				if (eventDescription == null || eventDescription.isEmpty()) {

					eventDescription = event.getDescription();
				}

				if (locationID < 1) {

					locationID = event.getLocation().getLocation_id();
				}

				if (isPrivate != 0 && isPrivate != 1) {

					isPrivate = event.getIsPrivate();
				}
			}

			String query2 = "UPDATE Event SET type = ? , name = ? , description = ? , location_id = ? , "
					+ "start_time = ? , end_time = ? , isPrivate = ? WHERE event_id = ?;";

			PreparedStatement prepStmt2 = db.getConnection().prepareStatement(
					query2);
			prepStmt2.setString(1, eventType);
			prepStmt2.setString(2, eventName);
			prepStmt2.setString(3, eventDescription);
			prepStmt2.setInt(4, locationID);
			prepStmt2.setDate(5, startTime);
			prepStmt2.setDate(6, endTime);
			prepStmt2.setInt(7, isPrivate);
			prepStmt2.setInt(8, eventID);
			prepStmt2.executeUpdate();

			return true;

		} catch (SQLException e) {
			e.printStackTrace();
			// todo SQL exception kodlarina gore yap
			// todo exception class lari olusturulacak

			// String detailedMessage = e.getMessage();
		}

		return false;
	}

	public static boolean deleteEvent(int eventID) {

		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			String query = "delete e from Event e where e.event_id = ? ;";

			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query);
			prepStmt.setInt(1, eventID);
			prepStmt.executeUpdate();

			
			return true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return false;
	}

	public static ArrayList<EventImplementation> getEventsOfUser(int userID) {

		ArrayList<EventImplementation> ei = new ArrayList<EventImplementation>();

		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			String query = "select e.event_id , e.type , e.name AS ename , e.description , e.start_time , e.end_time , e.isPrivate , l.location_id "
					+ ", l.name AS lname, l.formatted_address , l.secondary_id , l.latitude , l.longitude , e.isPrivate "
					+ " from CreateEvent c , Event e , Location l where c.user_id = ? and "
					+ "c.event_id = e.event_id and e.location_id = l.location_id;";

			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query);
			prepStmt.setInt(1, userID);
			ResultSet rs = prepStmt.executeQuery();

			while (rs.next()) {

				ArrayList<Integer> al = new ArrayList<Integer>();
				ArrayList<String> al2 = new ArrayList<String>();
				al.add(userID);

				EventImplementation event = new EventImplementation(al, al2,
						rs.getInt("event_id"), rs.getString("ename"),
						rs.getString("type"), rs.getString("description"),
						rs.getDate("start_time"), rs.getDate("end_time"),
						rs.getInt("location_id"), rs.getString("lname"),
						rs.getString("formatted_address"),
						rs.getString("secondary_id"), rs.getDouble("latitude"),
						rs.getDouble("longitude"), rs.getInt("isPrivate"));

				
				event.setRating(getRating(rs.getInt("event_id")));
				
				if (rs.getInt("isPrivate") == 1) {

					String query2 = "select user_id from EventAccess where event_id = ? ;";
					PreparedStatement prepStmt2 = db.getConnection()
							.prepareStatement(query2);
					prepStmt2.setInt(1, rs.getInt("event_id"));
					ResultSet rs2 = prepStmt2.executeQuery();

					ArrayList<Integer> aclist = new ArrayList<Integer>();

					while (rs2.next()) {

						aclist.add(rs2.getInt("user_id"));
					}

					event.setAccessIDs(aclist);
				}
				ei.add(event);
			}

			return ei;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return ei;
	}

	public static ArrayList<EventImplementation> getFriendsEventsInRadius(
			int userID, double lat, double lng, int limit, double radius,
			java.sql.Date startTime, java.sql.Date endTime) {

		ArrayList<EventImplementation> ei = new ArrayList<EventImplementation>();

		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			String query4 = "select event_id from EventAccess where user_id = ? ;";
			PreparedStatement prepStmt4 = db.getConnection().prepareStatement(
					query4);
			prepStmt4.setInt(1, userID);
			ResultSet rs4 = prepStmt4.executeQuery();

			ArrayList<Integer> eventAclist = new ArrayList<Integer>();

			while (rs4.next()) {
				eventAclist.add(rs4.getInt("event_id"));
			}

			String query = "SELECT"
					+ "  l.location_id , l.name AS lname, l.formatted_address , l.secondary_id , l.latitude , l.longitude "
					+ " , e.event_id , e.type , e.name AS ename , e.description , e.start_time "
					+ " , e.end_time , e.isPrivate , u.user_id , u.first_name , u.last_name , ( "
					+ "  3959 * acos ( "
					+ "  cos ( radians(?) ) "
					+ "  * cos( radians( l.latitude ) ) "
					+ "  * cos( radians( l.longitude ) - radians(?) ) "
					+ " + sin ( radians(?) ) "
					+ "  * sin( radians( l.latitude ) ) "
					+ " ) "
					+ " ) AS distance "
					+ " FROM Location l , Event e , CreateEvent c , Friendship f , User u"
					+ " WHERE e.location_id = l.location_id and e.start_time >= ? and "
					+ " e.end_time <= ? "
					+ " and c.event_id = e.event_id and f.user_id = ? and f.friend_user_id = c.user_id and f.friend_user_id = u.user_id"
					+ " HAVING distance < ? " + " ORDER BY distance "
					+ " LIMIT 0 , ?;";

			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query);
			prepStmt.setDouble(1, lat);
			prepStmt.setDouble(2, lng);
			prepStmt.setDouble(3, lat);
			prepStmt.setDate(4, startTime);
			prepStmt.setDate(5, endTime);
			prepStmt.setInt(6, userID);
			prepStmt.setDouble(7, radius);
			prepStmt.setInt(8, limit);

			ResultSet rs = prepStmt.executeQuery();

			while (rs.next()) {

				int in_list = -1;

				for (int i = 0; i < ei.size(); i++) {

					EventImplementation e = ei.get(i);

					if (rs.getInt("event_id") == e.getEventID()) {

						in_list = i;
					}

				}

				if (in_list != -1) {

					EventImplementation e = ei.get(in_list);
					e.addOwner(rs.getInt("user_id"), rs.getString("first_name")
							+ " " + rs.getString("last_name"));

				} else {

					ArrayList<Integer> al = new ArrayList<Integer>();
					ArrayList<String> al2 = new ArrayList<String>();

					al.add(rs.getInt("user_id"));
					al2.add(rs.getString("first_name") + " "
							+ rs.getString("last_name"));

					EventImplementation event = new EventImplementation(al,
							al2, rs.getInt("event_id"), rs.getString("ename"),
							rs.getString("type"), rs.getString("description"),
							rs.getDate("start_time"), rs.getDate("end_time"),
							rs.getInt("location_id"), rs.getString("lname"),
							rs.getString("formatted_address"),
							rs.getString("secondary_id"),
							rs.getDouble("latitude"),
							rs.getDouble("longitude"),
							rs.getDouble("distance"), rs.getInt("isPrivate"));

					event.setRating(getRating(rs.getInt("event_id")));
					
					if (rs.getInt("isPrivate") == 1
							&& eventAclist.contains(rs.getInt("event_id"))) {

						String query2 = "select user_id from EventAccess where event_id = ? ;";
						PreparedStatement prepStmt2 = db.getConnection()
								.prepareStatement(query2);
						prepStmt2.setInt(1, rs.getInt("event_id"));
						ResultSet rs2 = prepStmt2.executeQuery();

						ArrayList<Integer> aclist = new ArrayList<Integer>();

						while (rs2.next()) {

							aclist.add(rs2.getInt("user_id"));
						}

						event.setAccessIDs(aclist);

						ei.add(event);
					} else {
						ei.add(event);
					}
				}

			}

			return ei;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return ei;
	}

	public static ArrayList<EventImplementation> getClosestEventsInRadius(
			int userID, double lat, double lng, int limit, double radius,
			java.sql.Date startTime, java.sql.Date endTime) {

		ArrayList<EventImplementation> ei = new ArrayList<EventImplementation>();

		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			String query4 = "select event_id from EventAccess where user_id = ? ;";
			PreparedStatement prepStmt4 = db.getConnection().prepareStatement(
					query4);
			prepStmt4.setInt(1, userID);
			ResultSet rs4 = prepStmt4.executeQuery();

			ArrayList<Integer> eventAclist = new ArrayList<Integer>();

			while (rs4.next()) {
				eventAclist.add(rs4.getInt("event_id"));
			}

			String query = "SELECT"
					+ "  l.location_id , l.name AS lname , l.formatted_address , l.secondary_id , l.latitude , l.longitude "
					+ " , e.event_id , e.type , e.name AS ename, e.description , e.start_time "
					+ " , e.end_time , e.isPrivate , u.user_id , u.first_name , u.last_name , ( "
					+ "  3959 * acos ( "
					+ "  cos ( radians(?) ) "
					+ "  * cos( radians( l.latitude ) ) "
					+ "  * cos( radians( l.longitude ) - radians(?) ) "
					+ " + sin ( radians(?) ) "
					+ "  * sin( radians( l.latitude ) ) "
					+ " ) "
					+ " ) AS distance "
					+ " FROM Location l , Event e , CreateEvent c , User u "
					+ " WHERE e.location_id = l.location_id and e.start_time >= ? and "
					+ " e.end_time <= ? "
					+ " and c.event_id = e.event_id and u.user_id = c.user_id "
					+ " HAVING distance < ? " + " ORDER BY distance "
					+ " LIMIT 0 , ?;";

			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query);
			prepStmt.setDouble(1, lat);
			prepStmt.setDouble(2, lng);
			prepStmt.setDouble(3, lat);
			prepStmt.setDate(4, startTime);
			prepStmt.setDate(5, endTime);
			prepStmt.setDouble(6, radius);
			prepStmt.setInt(7, limit);

			ResultSet rs = prepStmt.executeQuery();

			while (rs.next()) {

				int in_list = -1;

				for (int i = 0; i < ei.size(); i++) {

					EventImplementation e = ei.get(i);

					if (rs.getInt("event_id") == e.getEventID()) {

						in_list = i;
					}

				}

				if (in_list != -1) {

					EventImplementation e = ei.get(in_list);
					e.addOwner(rs.getInt("user_id"), rs.getString("first_name")
							+ " " + rs.getString("last_name"));

				} else {

					ArrayList<Integer> al = new ArrayList<Integer>();
					ArrayList<String> al2 = new ArrayList<String>();

					al.add(rs.getInt("user_id"));
					al2.add(rs.getString("first_name") + " "
							+ rs.getString("last_name"));

					EventImplementation event = new EventImplementation(al,
							al2, rs.getInt("event_id"), rs.getString("ename"),
							rs.getString("type"), rs.getString("description"),
							rs.getDate("start_time"), rs.getDate("end_time"),
							rs.getInt("location_id"), rs.getString("lname"),
							rs.getString("formatted_address"),
							rs.getString("secondary_id"),
							rs.getDouble("latitude"),
							rs.getDouble("longitude"),
							rs.getDouble("distance"), rs.getInt("isPrivate"));

					event.setRating(getRating(rs.getInt("event_id")));
					
					if (rs.getInt("isPrivate") == 1
							&& eventAclist.contains(rs.getInt("event_id"))) {

						String query2 = "select user_id from EventAccess where event_id = ? ;";
						PreparedStatement prepStmt2 = db.getConnection()
								.prepareStatement(query2);
						prepStmt2.setInt(1, rs.getInt("event_id"));
						ResultSet rs2 = prepStmt2.executeQuery();

						ArrayList<Integer> aclist = new ArrayList<Integer>();

						while (rs2.next()) {

							aclist.add(rs.getInt("user_id"));
						}

						event.setAccessIDs(aclist);

						ei.add(event);
					} else {
						ei.add(event);
					}
				}

			}

			return ei;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return ei;
	}

	public static double getDistance(double lat1, double lng1, double lat2,
			double lng2) {

		double earthRadius = 3958.75;
		double dLat = Math.toRadians(lat2 - lat1);
		double dLng = Math.toRadians(lng2 - lng1);

		double a = Math.sin(dLat / 2) * Math.sin(dLat / 2)
				+ Math.cos(Math.toRadians(lat1))
				* Math.cos(Math.toRadians(lat2)) * Math.sin(dLng / 2)
				* Math.sin(dLng / 2);

		double c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
		double dist = earthRadius * c;

		int meterConversion = 1609;

		return new Double(dist * meterConversion).floatValue();

	}

	public static EventImplementation getEvent(int userID, int eventID) {

		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			String query = "select e.event_id , e.type , e.name AS ename , e.description , e.start_time , e.end_time , e.isPrivate , l.location_id "
					+ ", l.name AS lname, l.formatted_address , l.secondary_id , l.latitude , l.longitude , e.isPrivate "
					+ " from Event e , Location l where e.event_id = ? and e.location_id = l.location_id;";

			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query);
			prepStmt.setInt(1, eventID);
			ResultSet rs = prepStmt.executeQuery();

			while (rs.next()) {

				ArrayList<Integer> al = new ArrayList<Integer>();
				ArrayList<String> al2 = new ArrayList<String>();
				al.add(userID);

				EventImplementation event = new EventImplementation(al, al2,
						rs.getInt("event_id"), rs.getString("ename"),
						rs.getString("type"), rs.getString("description"),
						rs.getDate("start_time"), rs.getDate("end_time"),
						rs.getInt("location_id"), rs.getString("lname"),
						rs.getString("formatted_address"),
						rs.getString("secondary_id"), rs.getDouble("latitude"),
						rs.getDouble("longitude"), rs.getInt("isPrivate"));
				
				event.setRating(getRating(rs.getInt("event_id")));

				if (rs.getInt("isPrivate") == 1) {

					String query2 = "select user_id from EventAccess where event_id = ? ;";
					PreparedStatement prepStmt2 = db.getConnection()
							.prepareStatement(query2);
					prepStmt2.setInt(1, rs.getInt("event_id"));
					ResultSet rs2 = prepStmt2.executeQuery();

					ArrayList<Integer> aclist = new ArrayList<Integer>();

					while (rs2.next()) {

						aclist.add(rs.getInt("user_id"));
					}

					event.setAccessIDs(aclist);

					if (aclist.contains(userID)) {

						return event;
					} else
						return null;
				}

				return event;
			}

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return null;
	}

	public static ArrayList<EventImplementation> searchEvent(int userID,
			String searchString, int lowerLimit, int upperLimit) {

		ArrayList<EventImplementation> ei = new ArrayList<EventImplementation>();

		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			String query4 = "select event_id from EventAccess where user_id = ? ;";
			PreparedStatement prepStmt4 = db.getConnection().prepareStatement(
					query4);
			prepStmt4.setInt(1, userID);
			ResultSet rs4 = prepStmt4.executeQuery();

			ArrayList<Integer> eventAclist = new ArrayList<Integer>();

			while (rs4.next()) {
				eventAclist.add(rs4.getInt("event_id"));
			}
			String query = "";
			if (userID > 0) {
				query = "SELECT"
						+ "  l.location_id , l.name AS lname , l.formatted_address , l.secondary_id , l.latitude , l.longitude "
						+ " , e.event_id , e.type , e.name AS ename, e.description , e.start_time "
						+ " , e.end_time , e.isPrivate , u.user_id , u.first_name , u.last_name"
						+ " FROM Location l , Event e , User u "
						+ " WHERE u.user_id = ? and e.location_id = l.location_id and e.name like ? "
						+ " LIMIT ? , ?;";
			} else {
				return null;
			}
			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query);
			prepStmt.setInt(1,userID);
			prepStmt.setString(2, "%" + searchString + "%");
			prepStmt.setInt(3, lowerLimit);
			prepStmt.setInt(4, upperLimit);

			ResultSet rs = prepStmt.executeQuery();

			while (rs.next()) {

				int in_list = -1;

				for (int i = 0; i < ei.size(); i++) {

					EventImplementation e = ei.get(i);

					if (rs.getInt("event_id") == e.getEventID()) {

						in_list = i;
					}

				}

				if (in_list != -1) {

					EventImplementation e = ei.get(in_list);
					e.addOwner(rs.getInt("user_id"), rs.getString("first_name")
							+ " " + rs.getString("last_name"));

				} else {

					ArrayList<Integer> al = new ArrayList<Integer>();
					ArrayList<String> al2 = new ArrayList<String>();

					al.add(rs.getInt("user_id"));
					al2.add(rs.getString("first_name") + " "
							+ rs.getString("last_name"));

					EventImplementation event = new EventImplementation(al,
							al2, rs.getInt("event_id"), rs.getString("ename"),
							rs.getString("type"), rs.getString("description"),
							rs.getDate("start_time"), rs.getDate("end_time"),
							rs.getInt("location_id"), rs.getString("lname"),
							rs.getString("formatted_address"),
							rs.getString("secondary_id"),
							rs.getDouble("latitude"),
							rs.getDouble("longitude"), 0,
							rs.getInt("isPrivate"));
					
					event.setRating(getRating(rs.getInt("event_id")));

					if (rs.getInt("isPrivate") == 1
							&& eventAclist.contains(rs.getInt("event_id"))) {

						String query2 = "select user_id from EventAccess where event_id = ? ;";
						PreparedStatement prepStmt2 = db.getConnection()
								.prepareStatement(query2);
						prepStmt2.setInt(1, rs.getInt("event_id"));
						ResultSet rs2 = prepStmt2.executeQuery();

						ArrayList<Integer> aclist = new ArrayList<Integer>();

						while (rs2.next()) {

							aclist.add(rs.getInt("user_id"));
						}

						event.setAccessIDs(aclist);

						ei.add(event);
					} else {
						ei.add(event);
					}
				}

			}

			return ei;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return ei;
	}

	public static boolean commentOnEvent(int eventID, int userID, String comment) {

		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			String query = "insert into CommentOnEvent ( event_id , user_id , comment ) values ( ? , ? , ? );";

			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query);
			prepStmt.setInt(1, eventID);
			prepStmt.setInt(2, userID);
			prepStmt.setString(3, comment);
			prepStmt.executeUpdate();

			
			String query2 = "insert into Newsfeed ( user_id , user_id2 ,  event_id , operation , server_time ) values ( ? , 10000 , ? , ? , NOw());";
			
			PreparedStatement prepStmt2 = db.getConnection().prepareStatement(query2);
			prepStmt2.setInt(1, userID);
			prepStmt2.setInt(2, eventID);
			prepStmt2.setString(3, "comment");
			prepStmt2.executeUpdate();	
			
			return true;

		} catch (SQLException e) {
			e.printStackTrace();
			// todo SQL exception kodlarina gore yap
			// todo exception class lari olusturulacak

			// String detailedMessage = e.getMessage();
		}

		return false;

	}

	public static boolean shareEvent(int eventID, int userID) {

		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			String query = "insert into ShareEvent ( event_id , user_id ) values ( ? , ? );";

			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query);
			prepStmt.setInt(1, eventID);
			prepStmt.setInt(2, userID);
			prepStmt.executeUpdate();


			String query2 = "insert into Newsfeed ( user_id , user_id2 ,  event_id , operation , server_time ) values ( ? , 10000 , ? , ? , NOw());";
			
			PreparedStatement prepStmt2 = db.getConnection().prepareStatement(query2);
			prepStmt2.setInt(1, userID);
			prepStmt2.setInt(2, eventID);
			prepStmt2.setString(3, "share");
			prepStmt2.executeUpdate();	
			return true;

		} catch (SQLException e) {
			e.printStackTrace();
			// todo SQL exception kodlarina gore yap
			// todo exception class lari olusturulacak

			// String detailedMessage = e.getMessage();
		}

		return false;
	}

	public static boolean joinEvent(int eventID, int userID) {

		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			String query = "insert into JoinEvent ( event_id , user_id ) values ( ? , ? );";

			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query);
			prepStmt.setInt(1, eventID);
			prepStmt.setInt(2, userID);
			prepStmt.executeUpdate();
			
			String query2 ="insert into Newsfeed ( user_id , user_id2 ,  event_id , operation , server_time ) values ( ? , 10000 , ? , ? , NOw());";
			
			PreparedStatement prepStmt2 = db.getConnection().prepareStatement(query2);
			prepStmt2.setInt(1, userID);
			prepStmt2.setInt(2, eventID);
			prepStmt2.setString(3, "join");
			prepStmt2.executeUpdate();	

			return true;

		} catch (SQLException e) {
			e.printStackTrace();
			// todo SQL exception kodlarina gore yap
			// todo exception class lari olusturulacak

			// String detailedMessage = e.getMessage();
		}

		return false;
	}

	public static boolean rateEvent(int eventID, int userID, int rating) {

		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			String query = "insert into RateEvent ( event_id , user_id , point ) values ( ? , ? , ? );";

			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query);
			prepStmt.setInt(1, eventID);
			prepStmt.setInt(2, userID);
			prepStmt.setInt(3, rating);
			prepStmt.executeUpdate();

        } catch (SQLException e) {
            if (!updateRating(eventID,userID,rating)) {
                 return false;
            }
        }

        try {
			String query2 ="insert into Newsfeed ( user_id , user_id2 ,  event_id , operation , server_time ) values ( ? , 10000 , ? , ? , NOw());";
			
			PreparedStatement prepStmt2 = db.getConnection().prepareStatement(query2);
			prepStmt2.setInt(1, userID);
			prepStmt2.setInt(2, eventID);
			prepStmt2.setString(3, "rate");
			prepStmt2.executeUpdate();			
			
			return true;

		} catch (SQLException e) {
			// todo SQL exception kodlarina gore yap
			// todo exception class lari olusturulacak

			// String detailedMessage = e.getMessage();
		}

		return false;
	}

	public static boolean deleteComment(int eventID, int userID, String comment) {

		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			String query = "delete c from CommentOnEvent c where c.event_id = ? and c.user_id = ? and c.comment = ?;";

			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query);
			prepStmt.setInt(1, eventID);
			prepStmt.setInt(2, userID);
			prepStmt.setString(3, comment);
			prepStmt.executeUpdate();

						
			return true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return false;

	}

	public static boolean deleteShare(int eventID, int userID) {

		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			String query = "delete s from ShareEvent s where s.event_id = ? and s.user_id = ?;";

			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query);
			prepStmt.setInt(1, eventID);
			prepStmt.setInt(2, userID);
			prepStmt.executeUpdate();

			return true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return false;

	}

	public static boolean deleteJoin(int eventID, int userID) {

		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			String query = "delete j from JoinEvent j where j.event_id = ? and j.user_id = ?;";

			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query);
			prepStmt.setInt(1, eventID);
			prepStmt.setInt(2, userID);
			prepStmt.executeUpdate();

			return true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return false;

	}

	public static boolean deleteRating(int eventID, int userID) {

		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			String query = "delete r from RateEvent j where r.event_id = ? and r.user_id = ?;";

			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query);
			prepStmt.setInt(1, eventID);
			prepStmt.setInt(2, userID);
			prepStmt.executeUpdate();

			return true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return false;

	}

	public static boolean updateComment(int eventID, int userID,
			String oldComment, String newComment) {

		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			String query = "update CommentOnEvent set comment = ? where event_id = ? and user_id = ? and comment = ?;";

			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query);
			prepStmt.setString(1, newComment);
			prepStmt.setInt(2, eventID);
			prepStmt.setInt(3, userID);
			prepStmt.setString(4, oldComment);
			prepStmt.executeUpdate();

			return true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return false;

	}

	public static boolean updateRating(int eventID, int userID, int rating) {

		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			String query = "update RateEvent set point = ? where event_id = ? and user_id = ?;";

			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query);
			prepStmt.setInt(1, rating);
			prepStmt.setInt(2, eventID);
			prepStmt.setInt(3, userID);
			prepStmt.executeUpdate();

			return true;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return false;

	}

	public static double getRating(int eventID) {

		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			String query = "select avg(point) as ave from RateEvent where event_id = ?;";

			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query);
			prepStmt.setInt(1, eventID);
			ResultSet rs = prepStmt.executeQuery();

			while (rs.next()) {

				return rs.getDouble("ave");
			}

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return 0;
	}

	public static ArrayList<Object> getComments(int eventID) {

		ArrayList<Object> objects = new ArrayList<Object>();
		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			String query = "select * from CommentOnEvent c , User u where c.event_id = ? and u.user_id = c.user_id;";

			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query);
			prepStmt.setInt(1, eventID);
			ResultSet rs = prepStmt.executeQuery();

			while (rs.next()) {

				UserImplementation ui = new UserImplementation(
						rs.getInt("user_id"), rs.getString("first_name"),
						rs.getString("last_name"), rs.getString("email"),
						null, rs.getString("gender"),
						rs.getDate("date_of_birth"), rs.getString("city"));
				objects.add(ui);
				objects.add(rs.getString("comment"));

			}

			return objects;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return null;
	}

	public static ArrayList<UserImplementation> getJoiners(int eventID) {

		ArrayList<UserImplementation> users = new ArrayList<UserImplementation>();
		DatabaseHandler db = DatabaseHandler.getInstance();

		try {

			String query = "select * from JoinEvent c , User u where c.event_id = ? and u.user_id = c.user_id;";

			PreparedStatement prepStmt = db.getConnection().prepareStatement(
					query);
			prepStmt.setInt(1, eventID);
			ResultSet rs = prepStmt.executeQuery();

			while (rs.next()) {

				UserImplementation ui = new UserImplementation(
						rs.getInt("user_id"), rs.getString("first_name"),
						rs.getString("last_name"), rs.getString("email"),
						rs.getString("password"), rs.getString("gender"),
						rs.getDate("date_of_birth"), rs.getString("city"));

				users.add(ui);

			}

			return users;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return null;
	}

}
