package tr.cerealkillers.com.Objects;

import tr.cerealkillers.com.Util.DatabaseHandler;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

/**
 * Created with Eclipse.
 * User: CAGIN
 * Date: 12.12.2013
 * Time: 22:24
 */

public class FriendshipOperations {
     // TODO javadocs for this class
    
    public FriendshipOperations() {
    }
    
    public static boolean rejectRequest( int userID1 , int userID2 ) {

    	DatabaseHandler db = DatabaseHandler.getInstance();         

        try {
	        String query = "delete from FriendRequest where user_id = ? and requested_user_id = ? ;";
	        
	        PreparedStatement prepStmt = db.getConnection().prepareStatement(query);
			prepStmt.setInt(1,userID2);
			prepStmt.setInt(2,userID1);
			prepStmt.executeUpdate();
	             
	             
	        return true;
             
         } catch (SQLException e) {
        	 e.printStackTrace();
             //todo SQL exception kodlarina gore yap
             //todo exception class lari olusturulacak
             
        	 //String detailedMessage = e.getMessage();
         }
         
        return false;    	
    }
    
    public static boolean acceptRequest( int userID1 , int userID2 ) {

    	DatabaseHandler db = DatabaseHandler.getInstance();         

        try {
        	
	        String query = "insert into Friendship ( user_id , friend_user_id ) values( ? , ? ) , ( ? , ? );";
	        		
	        String query2 = "delete from FriendRequest where user_id = ? and requested_user_id = ? ;";

	        PreparedStatement prepStmt = db.getConnection().prepareStatement(query);
	        PreparedStatement prepStmt2 = db.getConnection().prepareStatement(query2);
			prepStmt.setInt(1,userID1);
			prepStmt.setInt(2,userID2);
			prepStmt.setInt(3,userID2);
			prepStmt.setInt(4,userID1);
			prepStmt2.setInt(1,userID2);
			prepStmt2.setInt(2,userID1);
			prepStmt.executeUpdate();
			prepStmt2.executeUpdate();
	             

			String query22 = "insert into Newsfeed ( user_id , user_id2 , event_id , operation , server_time ) values ( ? , ? , 10000,  ? , NOw());";

			PreparedStatement prepStmt22 = db.getConnection().prepareStatement(query22);
			prepStmt22.setInt(1, userID1);
			prepStmt22.setInt(2, userID2);
			prepStmt22.setString(3, "friends");
			prepStmt22.executeUpdate();		
			
			
	        return true;
             
         } catch (SQLException e) {
        	 e.printStackTrace();
             //todo SQL exception kodlarina gore yap
             //todo exception class lari olusturulacak
             
        	 //String detailedMessage = e.getMessage();
         }
         
        return false;    	
    }
    

    public static boolean addRequest( int userID1 , int userID2 ) {

    	DatabaseHandler db = DatabaseHandler.getInstance();         

        try {
        	
	        String query = "insert into FriendRequest ( user_id , requested_user_id ) values( ? , ? );" ;
	        
	        PreparedStatement prepStmt = db.getConnection().prepareStatement(query);
			prepStmt.setInt(1,userID1);
			prepStmt.setInt(2,userID2);
			prepStmt.executeUpdate();
	             
	        return true;
             
         } catch (SQLException e) {
        	 e.printStackTrace();
             //todo SQL exception kodlarina gore yap
             //todo exception class lari olusturulacak
             
        	 //String detailedMessage = e.getMessage();
         }
         
        return false;    	
    }
    
    public static ArrayList<UserImplementation> getFriendsOfUser( int userID1 ) {

    	ArrayList<UserImplementation> fl = new ArrayList<UserImplementation>();
    	
    	DatabaseHandler db = DatabaseHandler.getInstance();         

        try {
        	
	        String query = "select user_id , email , first_name , last_name , gender , date_of_birth , city " +
						   " from User " +
						   " where user_id in ( " + 
												" select friend_user_id " +
												" from Friendship " + 
												" where user_id = ? );";
	        
	        PreparedStatement prepStmt = db.getConnection().prepareStatement(query);
				prepStmt.setInt(1,userID1);
				ResultSet rs = prepStmt.executeQuery();
			       
				while(rs.next()) {
					
			        UserImplementation user = new UserImplementation( rs.getInt("user_id") 
			        		, rs.getString("first_name") , rs.getString("last_name") 
			        		, rs.getString("email") , "" , rs.getString("gender")
			        		, rs.getDate("date_of_birth") ,  rs.getString("city") );
			        
			        fl.add(user);
	            }				
							
	            return fl;
             
         } catch (SQLException e) {
        	 e.printStackTrace();
             //todo SQL exception kodlarina gore yap
             //todo exception class lari olusturulacak
             
        	 //String detailedMessage = e.getMessage();
         }
         
        return fl;    	
    }
    

    
    public static ArrayList<UserImplementation> getFriendRequestsOfUser( int userID1 ) {

    	ArrayList<UserImplementation> fl = new ArrayList<UserImplementation>();
    	
    	DatabaseHandler db = DatabaseHandler.getInstance();         

        try {
        	
	        String query = "select user_id , email , first_name , last_name , gender , date_of_birth , city " +
						   " from User " +
						   " where user_id in ( " + 
												" select user_id " +
												" from FriendRequest " + 
												" where requested_user_id = ? );";
	        
	        PreparedStatement prepStmt = db.getConnection().prepareStatement(query);
				prepStmt.setInt(1,userID1);
				ResultSet rs = prepStmt.executeQuery();
			       
				while(rs.next()) {
					
			        UserImplementation user = new UserImplementation( rs.getInt("user_id") 
			        		, rs.getString("first_name") , rs.getString("last_name") 
			        		, rs.getString("email") , "" , rs.getString("gender")
			        		, null ,  rs.getString("city") );
			        
			        fl.add(user);
	            }				
							
	            return fl;
             
         } catch (SQLException e) {
        	 e.printStackTrace();
             //todo SQL exception kodlarina gore yap
             //todo exception class lari olusturulacak
             
        	 //String detailedMessage = e.getMessage();
         }
         
        return fl;    	
    }

    
    public static ArrayList<ArrayList<UserImplementation>> searchUser( String firstAndLastName , int userID ) {


		ArrayList<ArrayList<UserImplementation>> users = new ArrayList<ArrayList<UserImplementation>>();

    	ArrayList<UserImplementation> fl1 = new ArrayList<UserImplementation>();
    	ArrayList<UserImplementation> fl2 = new ArrayList<UserImplementation>();
    	
    	DatabaseHandler db = DatabaseHandler.getInstance();         

        try {
        	
	        String query = "select user_id , email , first_name , last_name , gender , date_of_birth , city "+ 
	        			   "from User "+
	        			   "where ( ( first_name like ? and last_name like ? ) "+
	        			   "or ( first_name like ? and last_name like ? )  )" +
	        			   "and user_id in ("+
	        			   "select f.user_id "+
	        			   "from Friendship f "+
	        			   "where f.friend_user_id = ?);" ;
	        
	        String[] parts = firstAndLastName.split(" ");

	        String part1;
	        String part2;
	        
	        if( parts.length == 1 ) {	        	

		        part1 = parts[0]; 
		        part2 = ""; 
	        	
	        }
	        else {
		        part1 = parts[0]; 
		        part2 = parts[1]; 	        	
	        }


	        PreparedStatement prepStmt = db.getConnection().prepareStatement(query);
			prepStmt.setString(1,"%"+part1+"%");
			prepStmt.setString(2,"%"+part2+"%");
			prepStmt.setString(3,"%"+part2+"%");
			prepStmt.setString(4,"%"+part1+"%");
			prepStmt.setInt(5,userID);
			ResultSet rs = prepStmt.executeQuery();
			       
			while(rs.next()) {
				
		        UserImplementation user = new UserImplementation( rs.getInt("user_id") 
		        		, rs.getString("first_name") , rs.getString("last_name") 
		        		, rs.getString("email") , "" , rs.getString("gender")
		        		, null ,  rs.getString("city") );
		        
		        fl1.add(user);
            }				
			


	        
	        String query2 = "select user_id , email , first_name , last_name , gender , date_of_birth , city "+ 
     			   "from User "+
     			   "where ( ( first_name like ? and last_name like ? ) "+
     			   "or ( first_name like ? and last_name like ? )  )" +
     			   "and user_id not in ("+
     			   "select f.user_id "+
     			   "from Friendship f "+
     			   "where f.friend_user_id = ?);" ;
	        
	        
	        PreparedStatement prepStmt2 = db.getConnection().prepareStatement(query2);
			prepStmt2.setString(1,"%"+part1+"%");
			prepStmt2.setString(2,"%"+part2+"%");
			prepStmt2.setString(3,"%"+part2+"%");
			prepStmt2.setString(4,"%"+part1+"%");
			prepStmt2.setInt(5,userID);
			ResultSet rs2 = prepStmt2.executeQuery();
			       
			while(rs2.next()) {
				
		        UserImplementation user = new UserImplementation( rs2.getInt("user_id") 
		        		, rs2.getString("first_name") , rs2.getString("last_name") 
		        		, rs2.getString("email") , "" , rs2.getString("gender")
		        		, null ,  rs2.getString("city") );
		        
		        if( user.getUserid() != userID )
		        	fl2.add(user);
            }				

			users.add(fl1);
			users.add(fl2);
            return users;
             
         } catch (SQLException e) {
        	 e.printStackTrace();
             //todo SQL exception kodlarina gore yap
             //todo exception class lari olusturulacak
             
        	 //String detailedMessage = e.getMessage();
         }
         
        return users;    	
    }
    
    
}
