package tr.cerealkillers.com.Objects;

import tr.cerealkillers.com.Util.DatabaseHandler;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

/**
 * Created with Eclipse.
 * User: CAGIN
 * Date: 22.12.2013
 * Time: 00:12
 */

public class LocationOperations {
     // TODO javadocs for this class
    
    public LocationOperations() {
    }
    public static LocationImplementation getLocation(String secondaryId) {
        DatabaseHandler db = DatabaseHandler.getInstance();
        try {
            String query = "select * from Location where secondary_id = ?";

            PreparedStatement prepStmt = db.getConnection().prepareStatement(query);
            prepStmt.setString(1,secondaryId);
            ResultSet res = prepStmt.executeQuery();

            while (res.next()) {
                return new LocationImplementation(res.getString("name"),res.getString("formatted_address"),
                        res.getString("secondary_id"), res.getDouble("latitude"),
                        res.getDouble("longitude"),res.getInt("location_id"));
            }
        } catch (SQLException sql) {
             sql.printStackTrace();
        }
        return null;
    }
    
    public static boolean addLocation( double latitude , double longitude , String name 
    		, String formatted_address , String secondary_id ) {

    	DatabaseHandler db = DatabaseHandler.getInstance();       
    	
        try {
        	
	        String query = "insert into Location ( latitude , longitude , name , formatted_address , secondary_id )"
	        		+ " values( ? , ? , ? , ? , ? );";
	        
	        PreparedStatement prepStmt = db.getConnection().prepareStatement(query);
			prepStmt.setDouble(1,latitude);
			prepStmt.setDouble(2,longitude);
			prepStmt.setString(3,name);
			prepStmt.setString(4,formatted_address);
			prepStmt.setString(5,secondary_id);
			prepStmt.executeUpdate();
					        
	        return true;
             
         } catch (SQLException e) {
        	 e.printStackTrace();
         }
         
        return false;    	
    }
    

    public static boolean deleteLocation( int locationID ) {

    	DatabaseHandler db = DatabaseHandler.getInstance();     
    	
        try {
        	
	        String query = "delete l from Location l where l.location_id = ? ;";
	        
	        PreparedStatement prepStmt = db.getConnection().prepareStatement(query);
				prepStmt.setInt(1,locationID);
				prepStmt.executeUpdate();
		        
	            return true;
             
         } catch (SQLException e) {
        	 e.printStackTrace();
         }
         
        return false;    	
    }

	public static ArrayList<LocationImplementation> searchLocation(String search) {


    	ArrayList<LocationImplementation> li = new ArrayList<LocationImplementation>();

    	DatabaseHandler db = DatabaseHandler.getInstance();     
    	
        try {

	        String query = "select * " +
	        			   "from Location where name like ? ;" ;
	    
	        
	        PreparedStatement prepStmt = db.getConnection().prepareStatement(query);
			prepStmt.setString(1,"%"+search+"%");
			
			ResultSet rs = prepStmt.executeQuery();
					        
			while(rs.next()) {

				LocationImplementation l = new LocationImplementation(
						rs.getString("name") , rs.getString("formatted_address") 
						, rs.getString("secondary_id") , rs.getDouble("latitude") 
						, rs.getDouble("longitude") , rs.getInt("location_id") );				
				li.add(l);
            }
			
            return li;
             
         } catch (SQLException e) {
        	 e.printStackTrace();
         }
           	
		return null;
	}

	public static boolean updateLocation( int locationID , double latitude , double longitude , String name 
    		, String formatted_address , String secondary_id ) {

    	DatabaseHandler db = DatabaseHandler.getInstance();       
    	
        try {



	        String query = "select * from Location where location_id = ?;";

	        PreparedStatement prepStmt = db.getConnection().prepareStatement(query);
			prepStmt.setInt(1,locationID);
			ResultSet rs = prepStmt.executeQuery();
        	
			while(rs.next()) {

				LocationImplementation l = new LocationImplementation(
						rs.getString("name") , rs.getString("formatted_address") 
						, rs.getString("secondary_id") , rs.getDouble("latitude") 
						, rs.getDouble("longitude") , rs.getInt("location_id") );	

		        if( name == null || name.isEmpty() ) {
		        	
		        	name = l.getName();		        	
		        }
		        
		        if( formatted_address == null || formatted_address.isEmpty() ) {
		        	
		        	formatted_address = l.getFormatted_address();		        	
		        }
		        
		        if( secondary_id == null || secondary_id.isEmpty() ) {
		        	
		        	secondary_id = l.getSecondary_id();		        	
		        }
		        
            }				

        	
        	
	        String query2 = "UPDATE Location SET latitude = ? , longitude = ? , name = ? , formatted_address = ? , "
	        		+ "secondary_id = ? WHERE location_id = ?;";
	        
	        PreparedStatement prepStmt2 = db.getConnection().prepareStatement(query2);
			prepStmt2.setDouble(1,latitude);
			prepStmt2.setDouble(2,longitude);
			prepStmt2.setString(3,name);
			prepStmt2.setString(4,formatted_address);
			prepStmt2.setString(5,secondary_id);
			prepStmt2.setInt(6,locationID);
			prepStmt2.executeUpdate();
			
	        return true;
             
         } catch (SQLException e) {
        	 e.printStackTrace();
         }
         
        return false;    	
    }
       
}
