package tr.cerealkillers.com.Objects;

import tr.cerealkillers.com.Util.DatabaseHandler;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

/**
 * Created with Eclipse.
 * User: CAGIN
 * Date: 22.12.2013
 * Time: 00:12
 */

public class NewsfeedOperations {
     // TODO javadocs for this class
    
    public NewsfeedOperations() {
    }
    
    public static ArrayList<NewsfeedItem> getNewsfeed( int userID ) {
    	

		ArrayList<NewsfeedItem> ni = new ArrayList<NewsfeedItem>();

		DatabaseHandler db = DatabaseHandler.getInstance();
    	

		try {
			
			String query =
					
			"select n.operation , n.server_time, " +
			"u1.user_id as user_id1  , u1.email as e_mail1 , u1.first_name as first_name1 , u1.last_name as last_name1 , " +
			"u1.gender as gender1 , u1.date_of_birth as date_of_birth1 , u1.city as city1 , "+
			"u2.user_id as user_id2  , u2.email as e_mail2 , u2.first_name as first_name2 , u2.last_name as last_name2 , "+
			"u2.gender as gender2 , u2.date_of_birth as date_of_birth2 , u2.city as city2 , "+
			"e.event_id , e.name , e.description , e.type , e.location_id , e.start_time , e.end_time , e.isPrivate "+
			"from Newsfeed n, User u1 , User u2 , Event e , Friendship f "+
			"where n.user_id=u1.user_id and n.user_id2 = u2.user_id and n.event_id = e.event_id "+
			"and "+
			"f.user_id = ? and f.friend_user_id = n.user_id order by n.server_time desc";
			
			PreparedStatement prepStmt = db.getConnection().prepareStatement(query);
			prepStmt.setInt(1,userID);
	
			ResultSet rs = prepStmt.executeQuery();
	
			while (rs.next()) {

				UserImplementation ui1 = new UserImplementation(rs.getInt("user_id1"), rs.getString("first_name1"), rs.getString("last_name1"),
																rs.getString("e_mail1"), "", rs.getString("gender1"),
																rs.getDate("date_of_birth1"), rs.getString("city1"));
				
				UserImplementation ui2 = null;
				EventImplementation event = null;

				if( rs.getInt("user_id2") != 10000 ) {
					ui2 = new UserImplementation(rs.getInt("user_id2"), rs.getString("first_name2"), rs.getString("last_name2"),
							rs.getString("e_mail2"), "", rs.getString("gender2"),
							rs.getDate("date_of_birth2"), rs.getString("city2"));
				}

				
				if( rs.getInt("event_id") != 10000 ) {
					event = new EventImplementation( null , null ,
							rs.getInt("event_id"), rs.getString("name"),
							rs.getString("type"), rs.getString("description"),
							rs.getDate("start_time"), rs.getDate("end_time"),
							rs.getInt("location_id"), "",
							"",
							"", 0,
							0, rs.getInt("isPrivate"));
				}
				ni.add(new NewsfeedItem(ui1, ui2, event, rs.getString("operation"), rs.getTimestamp("server_time")) );
				
			}

			return ni;

		} catch (SQLException e) {
			e.printStackTrace();
		}

		return ni;
    
       
    }
}
