package tr.cerealkillers.com.Objects;

import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: MERT
 * Date: 10.11.2013
 * Time: 10:13
 * To change this template use File | Settings | File Templates.
 */
public interface User {
    /**
     * This method returns all friend requests that the user received
     * @return a all friend request as a {@link List}
     */
    List<FriendRequest> getFriendRequests();

    /**
     * This method rejects a received request from a user
     * @param user the user who send the request
     * @return True, if the reject operation is successful
     */
    public boolean rejectFriendRequest(User user);

    /**
     * This method accepts a request came from a user
     * @param user the user who send the request TODO this parameter may change during the implementation
     * @return True, if the accept operation is successful
     */
    public boolean acceptFriendRequest(User user);

    /**
     * This method sends a friend request to the user given in the parameter
     * @param user the friend that is going to be added
     * @return True, if the send operation is successful
     */
    public boolean sendFriendRequest(User user);

    /**
     * This method removes the friendship between the given user
     * @param user the friend that is going to be removed
     * @return True, if the add operation is successful
     */
    public boolean deleteFriend(User user);

    /**
     * Adds the given badge in the parameter
     * @param badge the badge that is going to be added
     * @return
     */
    public boolean addBadge(Badge badge);

    /**
     * This method adds the given experiencePoints to the users
     * current experience points.
     * @param experiencePoints the amount experience points that the user gained
     * @return True, if the add operation is successful
     */
    public boolean gainExperience(int experiencePoints);



    /**
     * Get method of the badges attribute of the User
     * @return the badges of the user as a {@link List}
     */
    public List<Badge> getBadges();

    /**
     * Get method of the friends attribute of the User
     * @return the friends of the user as a {@link List}
     */
    public List<User> getFriends();

}
