package tr.cerealkillers.com.Objects;

import tr.cerealkillers.com.Exception.EmailAlreadyExist;
import tr.cerealkillers.com.Exception.PasswordDoesNotMatch;
import tr.cerealkillers.com.Exception.UserDoesNotExistException;
import tr.cerealkillers.com.Util.DatabaseHandler;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.primefaces.json.JSONObject;

/**
 * Created with IntelliJ IDEA.
 * User: MERT
 * Date: 16.11.2013
 * Time: 07:38
 * To change this template use File | Settings | File Templates.
 */
public class UserImplementation implements User{

    private List<FriendRequest> friendRequests;
    private int userid;

    public String getFirst_name() {
        return first_name;
    }

    public void setFirst_name(String first_name) {
        this.first_name = first_name;
    }

    public String getLast_name() {
        return last_name;
    }

    public void setLast_name(String last_name) {
        this.last_name = last_name;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getGender() {
        return gender;
    }

    public void setGender(String gender) {
        this.gender = gender;
    }

    public Date getDate_of_birth() {
        return date_of_birth;
    }

    public boolean setDate_of_birth(java.sql.Date date_of_birth) {
        this.date_of_birth = date_of_birth;
        return true;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public int getUserid() {

        return userid;
    }

    public void setUserid(int id) {
        this.userid = id;
    }

    private String first_name;
    private String last_name;
    private String email;
    private String password;
    private String gender;
    private java.sql.Date date_of_birth;
    private String city;

    public UserImplementation() {};
    
    public UserImplementation( int id , String fname ,  String lname ,  String e_mail 
    		,  String pswd ,  String gender , java.sql.Date dob, String city ) {

    	this.userid = id;
    	this.first_name = fname;
    	this.last_name = lname;
    	this.email = e_mail;
    	this.password = pswd;
    	this.gender = gender;
    	this.date_of_birth = dob;
    	this.city = city;
    	
    }



    public static boolean register(String first_name, String last_name, String email, String password, String gender, Date date_of_birth, String city) throws EmailAlreadyExist {
        DatabaseHandler db = DatabaseHandler.getInstance();
        DateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String dateString = df.format(date_of_birth);
        String query = "insert into User" +
                " (email,  password, first_name, last_name," +
                " gender, date_of_birth, city)" +
                " values('"
                + email + "', '" + password
                + "', '" + first_name + "', '" + last_name + "', '" + gender.toString()
                + "', '" + dateString + "', '" + city
                + "')";
        try {
            db.executeUpdate(query);
            return true;
        } catch (SQLException e) {
            //todo SQL exception kodlarina gore yap
            //todo exception class lari olusturulacak
            String detailedMessage = e.getMessage();
            if (detailedMessage.endsWith("'email'")) {
                throw new EmailAlreadyExist();
            }
        }
        return false;
    }
    


	public static UserImplementation updateUser( int userID, String firstname,
			String lastname, String email, String password, String gender, java.sql.Date date,
			String city) {

			DatabaseHandler db = DatabaseHandler.getInstance();       
    	
        try {       	


	        String query = "select * "
	        		+ " from User u where u.user_id = ? ;";

	        PreparedStatement prepStmt = db.getConnection().prepareStatement(query);
			prepStmt.setInt(1,userID);
			ResultSet rs = prepStmt.executeQuery();

	        UserImplementation user = new UserImplementation();
	        
			while(rs.next()) {

                user.userid = rs.getInt("user_id");
                user.email = rs.getString("email");
                user.password =  rs.getString("password");
                user.first_name = rs.getString("first_name");
                user.last_name = rs.getString("last_name");
                user.gender = rs.getString("gender");
                user.date_of_birth = rs.getDate("date_of_birth");
                user.city = rs.getString("city");
				
				
				
		        if( firstname == null || firstname.isEmpty() ) {
		        	
		        	firstname = user.getFirst_name();		        	
		        }
		        
		        if( lastname == null || lastname.isEmpty() ) {
		        	
		        	lastname = user.getLast_name();		        	
		        }
		        
		        if( email == null || email.isEmpty() ) {
		        	
		        	email = user.getEmail();		        	
		        }

		        
		        if( password == null || password.isEmpty() ) {
		        	
		        	password = user.getPassword();		        	
		        }

		        
		        if( gender == null || gender.isEmpty() ) {
		        	
		        	gender = user.getGender();		        	
		        }

		        
		        if( city == null || city.isEmpty() ) {
		        	
		        	city = user.getCity();		        	
		        }

		        
		        if( date == null ) {
		        	
		        	date = (java.sql.Date) user.getDate_of_birth();		        	
		        }
		        
		        
            }				
			
			
			
			
	        String query2 = "UPDATE User SET first_name = ? , last_name = ? , email = ? , password = ? , "
	        		+ "gender = ? , date_of_birth = ? , city = ? WHERE user_id = ?;";
	        
	        PreparedStatement prepStmt2 = db.getConnection().prepareStatement(query2);
			prepStmt2.setString(1,firstname);
			prepStmt2.setString(2,lastname);
			prepStmt2.setString(3,email);
			prepStmt2.setString(4,password);
			prepStmt2.setString(5,gender);
			prepStmt2.setDate(6,date);
			prepStmt2.setString(7,city);
			prepStmt2.setInt(8,userID);
			prepStmt2.executeUpdate();
						
            
	        return new UserImplementation(userID, firstname, lastname, email, password, gender, date, city);
             
         } catch (SQLException e) {
        	 e.printStackTrace();
             //todo SQL exception kodlarina gore yap
             //todo exception class lari olusturulacak
             
        	 //String detailedMessage = e.getMessage();
         }
         
        return null;    	
		
		
	}




    public static UserImplementation login(String email, String password) throws UserDoesNotExistException, PasswordDoesNotMatch{
        DatabaseHandler db = DatabaseHandler.getInstance();
        String query = "select * from User where email=?";
        UserImplementation user = new UserImplementation();
        try {
        	PreparedStatement prepStmt = db.getConnection().prepareStatement(query);
        	prepStmt.setString(1, email);
            ResultSet rs = prepStmt.executeQuery();
            if (rs.next()) {
                if ( !password.equals(rs.getString("password"))) {
                    user.userid = -1;
                    throw new PasswordDoesNotMatch();
                }

                user.userid = rs.getInt("user_id");
                user.email = rs.getString("email");
                user.password = password;
                user.first_name = rs.getString("first_name");
                user.last_name = rs.getString("last_name");
                user.gender = rs.getString("gender");
                user.date_of_birth = rs.getDate("date_of_birth");
                user.city = rs.getString("city");
            }
            else {
                user.userid = -1;
                throw new UserDoesNotExistException();
            }

        } catch (SQLException e) {
            user.userid = -1;
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }

        return user;
    }


    /**
     * This method returns all friend requests that the user received
     *
     * @return a all friend request as a {@link java.util.List}
     */
    @Override
    public List<FriendRequest> getFriendRequests() {
        return friendRequests;  
    }

    /**
     * This method rejects a received request from a user
     *
     * @param user the user who send the request
     * @return True, if the reject operation is successful
     */
    @Override
    public boolean rejectFriendRequest(User user) {
        return false;  
    }

    /**
     * This method accepts a request came from a user
     *
     * @param user the user who send the request TODO this parameter may change during the implementation
     * @return True, if the accept operation is successful
     */
    @Override
    public boolean acceptFriendRequest(User user) {
        return false;  
    }

    /**
     * This method sends a friend request to the user given in the parameter
     *
     * @param user the friend that is going to be added
     * @return True, if the send operation is successful
     */
    @Override
    public boolean sendFriendRequest(User user) {
        return false;  
    }

    /**
     * This method removes the friendship between the given user
     *
     * @param user the friend that is going to be removed
     * @return True, if the add operation is successful
     */
    @Override
    public boolean deleteFriend(User user) {
        return false;  
    }

    /**
     * Adds the given badge in the parameter
     *
     * @param badge the badge that is going to be added
     * @return
     */
    @Override
    public boolean addBadge(Badge badge) {
        return false;  
    }

    /**
     * This method adds the given experiencePoints to the users
     * current experience points.
     *
     * @param experiencePoints the amount experience points that the user gained
     * @return True, if the add operation is successful
     */
    @Override
    public boolean gainExperience(int experiencePoints) {
        return false;  
    }


    /**
     * Get method of the badges attribute of the User
     *
     * @return the badges of the user as a {@link java.util.List}
     */
    @Override
    public List<Badge> getBadges() {
        return null;  
    }

    /**
     * Get method of the friends attribute of the User
     *
     * @return the friends of the user as a {@link java.util.List}
     */
    @Override
    public List<User> getFriends() {
        return null;  
    }

    /**
     * This method will be called after a user is registered
     * It also sets the id attribute of the user
     * @return true, if the create operation is successful
     */
    private boolean createUser() {

        //TODO sql update with parameters instead of direct strings

        DatabaseHandler db = DatabaseHandler.getInstance();
        DateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String dateString = df.format(date_of_birth);
        String query = "insert into User" +
                " (email, password, first_name, last_name," +
                " gender, date_of_birth, city)" +
                " values('"
                + email + "', '" + password
                + "', '" + first_name + "', '" + last_name + "', '" + gender.toString()
                + "', '" + dateString + "', '" + city
                + "')";
        try {
            db.executeUpdate(query);
            query = "select user_id from User where email='" + email + "'";
            ResultSet rs = db.executeQuery(query);
            if (rs.next()) {
                userid = rs.getInt("user_id");
                return true;
            }
            return false;
        } catch (SQLException e) {
            //todo exception class lari olusturulacak
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
        return false;
    }

    /**
     * If a set operation is called, then this method will
     * be called to reflect the changes to the database
     * @return True, if the database update is successful
     */
    private boolean saveChanges() {
        DatabaseHandler db = DatabaseHandler.getInstance();

         //TODO sql update with parameters instead of direct strings
        String query = "update User set " +
                "email='" + email + "' " +
                "password='" + password + "' " +
                "first_name='" + first_name + "' " +
                "last_name='" + last_name + "' " +
                "gender='" + gender.toString() + "' where user_id='" + userid;

        try {
            db.executeQuery(query);
            return true;
        } catch (SQLException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
        return false;
    }
    
    @Override
    public String toString() {
    	return new JSONObject(this).toString();
    }


}
