package tr.cerealkillers.com.Util;

import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.WebResource;
import com.sun.jersey.api.client.config.ClientConfig;
import com.sun.jersey.api.client.config.DefaultClientConfig;
import com.sun.jersey.core.util.MultivaluedMapImpl;
import org.primefaces.json.JSONObject;

import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.MultivaluedMap;
import javax.ws.rs.core.UriBuilder;
import java.net.URI;

public class WebServiceConnector {
	private static WebServiceConnector instance = null;
	private static WebResource service = null;
	private static WebResource serviceGoogle = null;
	private static String key = "AIzaSyASGYF8Z8nEyjUwDm02nzOYHQzmQbEUjGc";
	public static String baseUri = "/CerealKillers/";
	private WebServiceConnector() {
		ClientConfig config = new DefaultClientConfig();
		Client client = Client.create(config);
		service = client.resource(getBaseURI());
		serviceGoogle = client.resource(getBaseGoogleURI());
	}

	public static WebServiceConnector getInstance() {
		if (instance == null) {
			return instance = new WebServiceConnector();
		}
		return instance;
	}

	public String connectGooglePlacesApi(String[] keywords) {
		String params = keywords[0];
		for (int i = 1; i < keywords.length; i++) {
			params += "+" + keywords[i];
		}
		MultivaluedMap<String, String> queryParams = new MultivaluedMapImpl();
		queryParams.add("query", params);
		queryParams.add("sensor", "false");
		queryParams.add("key", key);
		String json = serviceGoogle.queryParams(queryParams)
				.accept(MediaType.APPLICATION_JSON).get(String.class)
				.toString();
		return json;
	}

	public String connectGet(String path) {
		String json = service.path(path).accept(MediaType.APPLICATION_JSON)
				.get(String.class).toString();
		return json;
	}

	public String connectPost(String path, JSONObject jsonObject) {
		return service.path(path).type("application/json")
				.post(String.class, jsonObject.toString());
	}

	private static URI getBaseGoogleURI() {
		// http://maps.googleapis.com/maps/api/geocode/json?address=cepa+ankara&sensor=true
		return UriBuilder.fromUri(
				"https://maps.googleapis.com/maps/api/place/textsearch/json").build();
	}

	private static URI getBaseURI() {
		return UriBuilder.fromUri("http://localhost:8080" + baseUri)
				.build();
	}
}
