package tr.cerealkillers.com.WebService;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import org.primefaces.json.JSONException;
import org.primefaces.json.JSONObject;
import tr.cerealkillers.com.Objects.EventImplementation;
import tr.cerealkillers.com.Objects.EventOperations;
import tr.cerealkillers.com.Objects.UserImplementation;

import javax.ws.rs.*;
import javax.ws.rs.core.MediaType;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;

@Path("/event")
public class Event {

	@POST
	@Consumes(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/createEvent")
	public String createEvent(String jsonString) {

		JSONObject json = null;

		try {
			json = new JSONObject(jsonString);
		} catch (JSONException e1) {
			e1.printStackTrace();
		}

		SimpleDateFormat formatter = new SimpleDateFormat("dd-MM-yyyy HH:mm:ss");
		java.sql.Date date1 = null;
		java.sql.Date date2 = null;

		try {

			date1 = new java.sql.Date(formatter.parse(
					json.getString("start_time")).getTime());
			date2 = new java.sql.Date(formatter.parse(
					json.getString("end_time")).getTime());

		} catch (ParseException e) {
			e.printStackTrace();
		} catch (JSONException e) {
			e.printStackTrace();
		}

		try {
			
			if( json.has("location_id") ) { // location is at the database

				EventOperations.createEvent(json.getInt("user_id"),
						json.getString("event_type"), json.getString("event_name"),
						json.getString("event_description"),
						date1, date2 , json.getInt("location_id") , 0 , 0 , "" , "" , "" , json.getInt("isPrivate") );	
				
			}
			else { 	// new location, add it to database

				EventOperations.createEvent(json.getInt("user_id"),
						json.getString("event_type"), json.getString("event_name"),
						json.getString("event_description"),
						date1, date2 , 0 , json.getDouble("latitude") , json.getDouble("longitude") ,
						json.getString("name"), json.getString("formatted_address") ,  json.getString("secondary_id") ,
						json.getInt("isPrivate"));					
			}

		} catch (JSONException e) {
			return e.getMessage();
		}
		return "{\"message\" : \"Event Created\"}";
	}


	@POST
	@Consumes(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/updateEvent")
	public String updateEvent(String jsonString) {

		JSONObject json = null;

		try {
			json = new JSONObject(jsonString);
		} catch (JSONException e1) {
			e1.printStackTrace();
		}

		SimpleDateFormat formatter = new SimpleDateFormat("dd-MM-yyyy HH:mm:ss");
		java.sql.Date date1 = null;
		java.sql.Date date2 = null;

		try {

			date1 = new java.sql.Date(formatter.parse(
					json.getString("start_time")).getTime());
			date2 = new java.sql.Date(formatter.parse(
					json.getString("end_time")).getTime());

		} catch (ParseException e) {
			e.printStackTrace();
		} catch (JSONException e) {
			e.printStackTrace();
		}

		try {
			
			EventOperations.updateEvent(json.getInt("event_id"),
					json.getString("event_type"), json.getString("event_name"),
					json.getString("event_description"),
					date1, date2 , json.getInt("location_id") , json.getInt("isPrivate") );	
				
			

		} catch (JSONException e) {
			return e.getMessage();
		}
		return "{\"message\" : \"Event Updated\"}";
	}
	
	
	@POST
	@Consumes(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/deleteEvent")
	public String deleteEvent(String jsonString) {

		JSONObject json = null;

		try {
			json = new JSONObject(jsonString);
		} catch (JSONException e1) {
			e1.printStackTrace();
		}

		try {

			EventOperations.deleteEvent(json.getInt("event_id"));

		} catch (JSONException e) {
			return e.getMessage();
		}
		return "{\"message\" : \"Event Deleted\"}";
	}
	

	@POST
	@Consumes(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/commentOnEvent")
	public String commentOnEvent(String jsonString) {

		JSONObject json = null;

		try {
			json = new JSONObject(jsonString);
		} catch (JSONException e1) {
			e1.printStackTrace();
		}

		try {

			EventOperations.commentOnEvent(json.getInt("event_id"),json.getInt("user_id"),json.getString("comment"));

		} catch (JSONException e) {
			return e.getMessage();
		}
		return "{\"message\" : \"Comment operation successful\"}";
	}

	

	@POST
	@Consumes(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/updateComment")
	public String updateComment(String jsonString) {

		JSONObject json = null;

		try {
			json = new JSONObject(jsonString);
		} catch (JSONException e1) {
			e1.printStackTrace();
		}

		try {

			EventOperations.updateComment(json.getInt("event_id"),json.getInt("user_id"),json.getString("oldcomment"),json.getString("newcomment"));

		} catch (JSONException e) {
			return e.getMessage();
		}
		return "{\"message\" : \"Comment operation successful\"}";
	}

	@POST
	@Consumes(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/deleteComment")
	public String deleteComment(String jsonString) {

		JSONObject json = null;

		try {
			json = new JSONObject(jsonString);
		} catch (JSONException e1) {
			e1.printStackTrace();
		}

		try {

			EventOperations.deleteComment(json.getInt("event_id"),json.getInt("user_id"),json.getString("comment"));

		} catch (JSONException e) {
			return e.getMessage();
		}
		return "{\"message\" : \"Comment deleted successful\"}";
	}
	
	@GET
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/getComments/{event_id}")	
	public String getComments( @PathParam("event_id") int eventID   ) {

		
		try {
			
			ArrayList<Object> ei = EventOperations.getComments( eventID );
						
			Gson gson = new GsonBuilder()
			   .setDateFormat("dd-MM-yyyy HH:mm:ss").create();
			
			String json = gson.toJson(ei);  
			return json;
		} catch (Exception e) {
			// TODO handle errors
		}
		return "{\"message\": \"NULL\"}";
	}
	

	@POST
	@Consumes(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/shareEvent")
	public String shareEvent(String jsonString) {

		JSONObject json = null;

		try {
			json = new JSONObject(jsonString);
		} catch (JSONException e1) {
			e1.printStackTrace();
		}

		try {

			EventOperations.shareEvent(json.getInt("event_id"),json.getInt("user_id"));

		} catch (JSONException e) {
			return e.getMessage();
		}
		return "{\"message\" : \"Share operation successful\"}";
	}

	@POST
	@Consumes(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/deleteShare")
	public String deleteShare(String jsonString) {

		JSONObject json = null;

		try {
			json = new JSONObject(jsonString);
		} catch (JSONException e1) {
			e1.printStackTrace();
		}

		try {

			EventOperations.deleteShare(json.getInt("event_id"),json.getInt("user_id"));

		} catch (JSONException e) {
			return e.getMessage();
		}
		return "{\"message\" : \"Share deleted successful\"}";
	}

	@POST
	@Consumes(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/joinEvent")
	public String joinEvent(String jsonString) {

		JSONObject json = null;

		try {
			json = new JSONObject(jsonString);
		} catch (JSONException e1) {
			e1.printStackTrace();
		}

		try {

			EventOperations.joinEvent(json.getInt("event_id"),json.getInt("user_id"));

		} catch (JSONException e) {
			return e.getMessage();
		}
		return "{\"message\" : \"Join operation successful\"}";
	}
	

	@POST
	@Consumes(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/deleteJoin")
	public String deleteJoin(String jsonString) {

		JSONObject json = null;

		try {
			json = new JSONObject(jsonString);
		} catch (JSONException e1) {
			e1.printStackTrace();
		}

		try {

			EventOperations.deleteJoin(json.getInt("event_id"),json.getInt("user_id"));

		} catch (JSONException e) {
			return e.getMessage();
		}
		return "{\"message\" : \"Join deleted successful\"}";
	}
	

	@GET
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/getJoiners/{event_id}")	
	public String getJoiners( @PathParam("event_id") int eventID   ) {

		
		try {
			
			ArrayList<UserImplementation> ei = EventOperations.getJoiners( eventID );
						
			Gson gson = new GsonBuilder()
			   .setDateFormat("dd-MM-yyyy HH:mm:ss").create();
			
			String json = gson.toJson(ei);  
			return json;
		} catch (Exception e) {
			// TODO handle errors
		}
		return "{\"message\": \"NULL\"}";
	}


	@POST
	@Consumes(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/rateEvent")
	public String rateEvent(String jsonString) {

		JSONObject json = null;
        double currentRate = 0;
		try {
			json = new JSONObject(jsonString);
		} catch (JSONException e1) {
			e1.printStackTrace();
		}

		try {

			EventOperations.rateEvent(json.getInt("event_id"),json.getInt("user_id"),json.getInt("rating"));
            currentRate = EventOperations.getRating(json.getInt("event_id"));

		} catch (JSONException e) {
			return e.getMessage();
		}
		return "{\"message\" : \"Rate operation successful\"" +
                ", \"currentRate:\" : " + currentRate + "}";
	}

	@POST
	@Consumes(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/updateRating")
	public String updateRating(String jsonString) {

		JSONObject json = null;

		try {
			json = new JSONObject(jsonString);
		} catch (JSONException e1) {
			e1.printStackTrace();
		}

		try {

			EventOperations.updateRating(json.getInt("event_id"),json.getInt("user_id"),json.getInt("rating"));

		} catch (JSONException e) {
			return e.getMessage();
		}
		return "{\"message\" : \"Rate operation successful\"}";
	}
	


	@POST
	@Consumes(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/deleteRating")
	public String deleteRating(String jsonString) {

		JSONObject json = null;

		try {
			json = new JSONObject(jsonString);
		} catch (JSONException e1) {
			e1.printStackTrace();
		}

		try {

			EventOperations.deleteRating(json.getInt("event_id"),json.getInt("user_id"));

		} catch (JSONException e) {
			return e.getMessage();
		}
		return "{\"message\" : \"Rate deleted successful\"}";
	}

	@GET
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/getRating/{event_id}")	
	public String getRating( @PathParam("event_id") int eventID   ) {
		
		try {
			
			double ei = EventOperations.getRating( eventID );
						

			String json = "{\"event_id\" : " + eventID + " , \"rate\" : " + ei + "}";
			return json;
		} catch (Exception e) {
			// TODO handle errors
		}
		return "{\"message\": \"NULL\"}";
	}
	

	@GET
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/getEventsOfUser/{user_id}")	
	public String getEventsOfUser( @PathParam("user_id") int userID ) {
		
		ArrayList<EventImplementation> events = new ArrayList<EventImplementation>();
		
		try {
			events = EventOperations.getEventsOfUser(userID);
			//System.out.println("name1: " + events.get(0).getEvent_name() );
			//System.out.println("name2: " + events.get(2).getEvent_name() );
			Gson gson = new GsonBuilder()
			   .setDateFormat("dd-MM-yyyy HH:mm:ss").create();
			String json = gson.toJson(events);  
			return json;
		} catch (Exception e) {
			// TODO handle errors
		}
		return "{\"message\": \"NULL\"}";
	}
	

	@GET
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/getFriendsEventsInRadius/{user_id}/{latitude}/{longitude}/{limit}/{radius}/{startTime}/{endTime}")	
	public String getFriendsEventsInRadius( @PathParam("user_id") int userID 
			, @PathParam("latitude") double lat 
			, @PathParam("longitude") double lng , @PathParam("limit") int limit
			, @PathParam("radius") double radius 
			, @PathParam("startTime") String startTime , @PathParam("endTime") String endTime  ) {
		
		ArrayList<EventImplementation> events = new ArrayList<EventImplementation>();
		DateFormat df = new SimpleDateFormat("dd-MM-yyyy");
		
		
		try {
			events = EventOperations.getFriendsEventsInRadius( userID, lat, lng, limit, radius
					, new java.sql.Date(df.parse(startTime).getTime()), new java.sql.Date(df.parse(endTime).getTime()));

			Gson gson = new GsonBuilder()
			   .setDateFormat("dd-MM-yyyy HH:mm:ss").create();
			String json = gson.toJson(events);  
			return json;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return "{\"message\": \"NULL\"}";
	}
	
	@GET
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/getClosestEventsInRadius/{user_id}/{latitude}/{longitude}/{limit}/{radius}/{startTime}/{endTime}")	
	public String getClosestEventsInRadius( @PathParam("user_id") int userID 
			, @PathParam("latitude") double lat 
			, @PathParam("longitude") double lng , @PathParam("limit") int limit
			, @PathParam("radius") double radius 
			, @PathParam("startTime") String startTime , @PathParam("endTime") String endTime  ) {
		
		ArrayList<EventImplementation> events = new ArrayList<EventImplementation>();

		
		
		try {
			events = EventOperations.getClosestEventsInRadius( userID, lat, lng, limit, radius
					, java.sql.Date.valueOf(startTime), java.sql.Date.valueOf(endTime));

			Gson gson = new GsonBuilder()
			   .setDateFormat("dd-MM-yyyy HH:mm:ss").create();
			
			String json = gson.toJson(events);  
			return json;
		} catch (Exception e) {
			// TODO handle errors
		}
		return "{\"message\": \"NULL\"}";
	}	

	@GET
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/searchEvent/{search_string}/{user_id}/{lower_limit}/{upper_limit}")	
	public String searchEvent( @PathParam("user_id") int userID 
			, @PathParam("search_string") String searchString
			, @PathParam("lower_limit") int lowerLimit 
			, @PathParam("upper_limit") int upperLimit ) {
		
		ArrayList<EventImplementation> events = new ArrayList<EventImplementation>();		
		
		try {
			events = EventOperations.searchEvent( userID , searchString , lowerLimit , upperLimit );

			Gson gson = new GsonBuilder()
			   .setDateFormat("dd-MM-yyyy HH:mm:ss").create();
			
			String json = gson.toJson(events);  
			return json;
		} catch (Exception e) {
			// TODO handle errors
		}
		return "{\"message\": \"NULL\"}";
	}
	
	@GET
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/getEvent/{user_id}/{event_id}")	
	public String getEvent( @PathParam("user_id") int userID 
			, @PathParam("event_id") int eventID   ) {

		
		try {
			
			EventImplementation ei = EventOperations.getEvent( userID , eventID );
			if (ei == null) {
                return "{\"message\" : \"This event is missing\"}";
            }
            else {
                Gson gson = new GsonBuilder()
                        .setDateFormat("dd-MM-yyyy HH:mm:ss").create();

                String json = gson.toJson(ei);
                return json;
            }

		} catch (Exception e) {
			// TODO handle errors
		}
		return "{\"message\": \"NULL\"}";
	}
}
