package tr.cerealkillers.com.WebService;


import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import org.primefaces.json.JSONException;
import org.primefaces.json.JSONObject;
import tr.cerealkillers.com.Objects.FriendshipOperations;
import tr.cerealkillers.com.Objects.UserImplementation;

import javax.ws.rs.*;
import javax.ws.rs.core.MediaType;
import java.util.ArrayList;


@Path("/friendship")
public class Friendship {
	
	@POST
	@Consumes(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/acceptRequest")
	public String acceptRequest(String jsonString) {
		
		JSONObject json = null;
		
		try {
			json = new JSONObject(jsonString);
		} catch (JSONException e1) {
			e1.printStackTrace();
		}
		
		try {

			FriendshipOperations.acceptRequest( json.getInt("user_id") , json.getInt("friend_user_id") );
			
		} catch (JSONException e) {
			return "{\"message\" : \"JSONException\"}";
		}
		return "{\"message\" : \"Friendship added\" }";
	}

	
	@POST
	@Consumes(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/rejectRequest")
	public String rejectRequest(String jsonString) {
		
		JSONObject json = null;
		
		try {
			json = new JSONObject(jsonString);
		} catch (JSONException e1) {
			e1.printStackTrace();
		}
		
		try {

			FriendshipOperations.rejectRequest( json.getInt("user_id") , json.getInt("friend_user_id") );
			
		} catch (JSONException e) {
			return "{\"message\" : \"JSONException\"}";
		}
		return "{\"message\" : \"Friendship rejected\" }";
	}
	
	@POST
	@Consumes(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/addRequest")
	public String addRequest(String jsonString) {
		
		JSONObject json = null;
		
		try {
			json = new JSONObject(jsonString);
		} catch (JSONException e1) {
			e1.printStackTrace();
		}
		
		try {

			FriendshipOperations.addRequest( json.getInt("user_id") , json.getInt("requested_user_id") );
			
		} catch (JSONException e) {
			return "{\"message\" : \"JSONException\"}";
		}
		return "{\"message\" : \"Friendship Request added\" }";
	}



	@GET
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/getFriendRequestsOfUser/{user_id}")	
	public String getFriendRequestsOfUser( @PathParam("user_id") int userID ) {
		
		ArrayList<UserImplementation> users = new ArrayList<UserImplementation>();
		
		try {
			users = FriendshipOperations.getFriendRequestsOfUser(userID);
			Gson gson = new GsonBuilder()
			   .setDateFormat("dd-MM-yyyy HH:mm:ss").create();
			String json = gson.toJson(users);  
			return json;
		} catch (Exception e) {
			// TODO handle errors
		}
		return "{\"message\": \"NULL\"}";
	}



	@GET
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/getFriendsOfUser/{user_id}")	
	public String getFriendsOfUser( @PathParam("user_id") int userID ) {
		
		ArrayList<UserImplementation> users = new ArrayList<UserImplementation>();
		
		try {
			users = FriendshipOperations.getFriendsOfUser(userID);
			Gson gson = new GsonBuilder()
			   .setDateFormat("dd-MM-yyyy HH:mm:ss").create();
			String json = gson.toJson(users);  
			return json;
		} catch (Exception e) {
			// TODO handle errors
		}
		return "{\"message\": \"NULL\"}";
	}


	@GET
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/searchUser/{search_string}/{user_id}")	
	public String searchUser( @PathParam("search_string") String searchString
			, @PathParam("user_id") int userID) {
		
		ArrayList<ArrayList<UserImplementation>> users = new ArrayList<ArrayList<UserImplementation>>();

		try {
			users = FriendshipOperations.searchUser(searchString,userID);
			Gson gson = new GsonBuilder()
			   .setDateFormat("dd-MM-yyyy HH:mm:ss").create();
			String json = gson.toJson(users);
			return json;
		} catch (Exception e) {
			// TODO handle errors
		}
		return "{\"message\": \"NULL\"}";
	}
}
