package tr.cerealkillers.com.WebService;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import org.primefaces.json.JSONException;
import org.primefaces.json.JSONObject;
import tr.cerealkillers.com.Objects.LocationImplementation;
import tr.cerealkillers.com.Objects.LocationOperations;
import tr.cerealkillers.com.Util.WebServiceConnector;

import javax.ws.rs.*;
import javax.ws.rs.core.MediaType;
import java.util.ArrayList;

@Path("/location")
public class Location {

	@POST
	@Consumes(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/addLocation")
	public String addLocation(String jsonString) {

		JSONObject json = null;

		try {
			json = new JSONObject(jsonString);
		} catch (JSONException e1) {
			e1.printStackTrace();
		}

		try {

			LocationOperations.addLocation(json.getDouble("latitude"),
					json.getDouble("longitude"), json.getString("name"),
					json.getString("formatted_address"),
					json.getString("secondary_id"));

		} catch (JSONException e) {
			return e.getMessage();
		}
        LocationImplementation newLoc = null;
        try {
            newLoc = LocationOperations.getLocation(json.getString("secondary_id"));
        } catch (JSONException e) {
            e.printStackTrace();
        }
        return "{\"message\" : \"Location Added\", \"secondary_id\": \"" + newLoc.getSecondary_id() + "\"" +
                ", \"id\": " + newLoc.getLocation_id() +" }";
	}	


	@POST
	@Consumes(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/updateLocation")
	public String updateLocation(String jsonString) {

		JSONObject json = null;

		try {
			json = new JSONObject(jsonString);
		} catch (JSONException e1) {
			e1.printStackTrace();
		}

		try {

			LocationOperations.updateLocation(json.getInt("location_id")
					,json.getDouble("latitude"),
					json.getDouble("longitude"), json.getString("name"),
					json.getString("formatted_address"),
					json.getString("seconday_id"));

		} catch (JSONException e) {
			return e.getMessage();
		}
		return "{\"message\" : \"Location Added\"}";
	}

	@POST
	@Consumes(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/deleteLocation")
	public String deleteLocation(String jsonString) {

		JSONObject json = null;

		try {
			json = new JSONObject(jsonString);
		} catch (JSONException e1) {
			e1.printStackTrace();
		}

		try {

			LocationOperations.deleteLocation(json.getInt("location_id"));

		} catch (JSONException e) {
			return e.getMessage();
		}
		return "{\"message\" : \"Location Deleted\"}";
	}

	@GET
	@Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	@Path("/searchLocation/{searchString}")
	public String searchLocation(
			@PathParam("searchString") String search) {

		ArrayList<LocationImplementation> locations = new ArrayList<LocationImplementation>();

		try {
			locations = LocationOperations.searchLocation(search);
			if (locations.size() > 0) {
				Gson gson = new GsonBuilder()
				   .setDateFormat("dd-MM-yyyy HH:mm:ss").create();
				String json = gson.toJson(locations);
				json.replace("\\", "");
				json = "{\"results\":" + json + ", \"status\":\"OK\"}";
				return json;
			} else {
				return WebServiceConnector.getInstance()
						.connectGooglePlacesApi(search.split(" "));
			}
		} catch (Exception e) {
			// TODO handle errors
		}
		return "{\"message\": \"NULL\"}";
	}

}
