package tr.cerealkillers.com.WebService;

import org.primefaces.json.JSONObject;
import tr.cerealkillers.com.Exception.EmailAlreadyExist;
import tr.cerealkillers.com.Exception.PasswordDoesNotMatch;
import tr.cerealkillers.com.Exception.UserDoesNotExistException;
import tr.cerealkillers.com.Objects.UserImplementation;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

@Path("/login")
public class Login {
	@GET
	  @Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	  @Path("/{username}/{password}")
	  public String login(@PathParam("username") String username, @PathParam("password") String password) {
		  try {
			UserImplementation user = UserImplementation.login(username, password);
			return new JSONObject(user).toString();
		} catch (UserDoesNotExistException e) {
			return "{\"message\": \"UserDoesNotExistException\"}";
		} catch (PasswordDoesNotMatch e) {
			return "{\"message\": \"PasswordDoesNotMatch\"}";
		}
	  }
	
	@GET
	  @Produces(MediaType.APPLICATION_JSON + ";charset=utf-8")
	  @Path("/{email}/{password}/{first_name}/{last_name}/{gender}/{date_of_birth}/{city}")
	  public String facebookLogin(	@PathParam("email") String email, @PathParam("password") String password , 
									@PathParam("first_name") String first_name, @PathParam("last_name") String last_name , 
									@PathParam("gender") String gender, @PathParam("date_of_birth") String date_of_birth ,
									@PathParam("city") String city ) {
		try {
			UserImplementation user = UserImplementation.login(email, password);
			return new JSONObject(user).toString();
			
		} catch (UserDoesNotExistException e) {
			
			SimpleDateFormat formatter = new SimpleDateFormat("dd-MM-yyyy");
			Date date = null;
			try {

				date = formatter.parse( date_of_birth );

			} catch (ParseException ee) {
				ee.printStackTrace();
			}

			try {
				UserImplementation.register( first_name, last_name, email, password, gender, date, city );
				
			} catch (EmailAlreadyExist eu) {
				return "{\"message\" : \"" + eu.errorMessage + "\"}";
			}
			
			try {
				UserImplementation user = UserImplementation.login(email, password);
				return new JSONObject(user).toString();
			} catch (UserDoesNotExistException ea) {
				return "{\"message\": \"UserDoesNotExistException\"}";
			} catch (PasswordDoesNotMatch ed) {
				return "{\"message\": \"PasswordDoesNotMatch\"}";
			}
			
		} catch (PasswordDoesNotMatch e) {
			return "{\"message\": \"PasswordDoesNotMatch\"}";
		}
	  }
	
}
