package tr.cerealkillers.com.WebService;

import java.util.ArrayList;

import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;

import org.primefaces.json.JSONException;
import org.primefaces.json.JSONObject;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;

import tr.cerealkillers.com.Objects.EventImplementation;
import tr.cerealkillers.com.Objects.EventOperations;
import tr.cerealkillers.com.Objects.LocationImplementation;
import tr.cerealkillers.com.Objects.LocationOperations;
import tr.cerealkillers.com.Objects.NewsfeedItem;
import tr.cerealkillers.com.Objects.NewsfeedOperations;
import tr.cerealkillers.com.Util.WebServiceConnector;

@Path("/newsfeed")
public class Newsfeed {


	@GET
	@Produces(MediaType.APPLICATION_JSON)
	@Path("/getNewsfeed/{user_id}")
	public String getNewsfeed(
			@PathParam("user_id") int user_id) {

		ArrayList<NewsfeedItem> items = new ArrayList<NewsfeedItem>();

		try {
			items = NewsfeedOperations.getNewsfeed(user_id);
			
			Gson gson = new GsonBuilder()
			   .setDateFormat("dd-MM-yyyy HH:mm:ss").create();
			String json = gson.toJson(items);
			return json;
			
		} catch (Exception e) {
			// TODO handle errors
		}
		return "{\"message\": \"NULL\"}";
	}

}
